/*
 * Single Window Application Template:
 * A basic starting point for your application.  Mostly a blank canvas.
 * 
 * In app.js, we generally take care of a few things:
 * - Bootstrap the application with any data we need
 * - Check for dependencies like device type, platform version or network connection
 * - Require and open our top-level UI component
 *  
 */

//bootstrap and check dependencies
if (Ti.version < 3.0 ) {
	alert('Sorry - this application template requires Titanium Mobile SDK 1.8 or later');	  	
}

/*
Ti.Network.addEventListener('change', function(e){
	if(e.networkType!==Ti.Network.NETWORK_UNKNOWN && e.networkType!==Ti.Network.NETWORK_WIFI){
		if(e.networkType===Ti.Network.NETWORK_NONE){
			alert('Please enable Internet Services');
			return;
		}
		alert('Please enable WiFi for more accuarte location');
	}
});
*/
Ti.IOSPlus = function()
{
	// iOS-specific test
	if (Titanium.Platform.name == 'iPhone OS')
	{
		var version = Titanium.Platform.version.split(".");
		var major = parseInt(version[0],10);

		// Can only test this support on a 3.2+ device
		if (major >= 7)
		{
			return true;
		}
	}
	return false;
}();
	
ICABBI = require('core/icabbi');
IcabbiAPI = require('/core/IcabbiAPI');
Ti.include('lib/cache.js');

var applicationStarted = false;
var startApplication = function(restart){
	// var appKey = Ti.App.Properties.getString("LocationPublicKey", null);
	// if(appKey && appKey.length > 0)
	// {
		// ICABBI.Config.IcabbiApi.APP_KEY = appKey;
		// //IcabbiAPI.APP_KEY
	// }
	// load application configuration for company
	IcabbiAPI.getCompanyConfig({
		success: function(data){
			applicationStarted = true;
		
			ICABBI.initialize(data);
			
			ICABBI.Controller.initialize(restart);
				
			ICABBI.Controller.getUser().once('sessionvalidated',function(){
				ICABBI.start(restart);
			});
			
			ICABBI.Controller.start();
		},
		error : function(){
			ICABBI.navController.showError({
			    title:'Error!',
			    message:'Network problems. Please retry.',
			    buttons : [
			    	{ lable : 'Retry', icon : '/images/buttons/icon_button_ok.png'},
					{ lable : 'Exit', icon : '/images/buttons/icon_button_cancel.png'}
			    ],
			    click : function(e){
			    	if(e.index == 1)
			    	{
			    		startApplication();
			    	}
					else {
						ICABBI.navController.exit();
					}
			    }
			});
		}
	});
};
ICABBI.startApplication = startApplication;

var networkHandler = function(e){
	if(!Ti.Network.online)
		ICABBI.navController.showError({
		    title:'Network problem!',
		    message:'Please enable Internet Services',
		    buttons: null,
		    click : function(e){
		    	ICABBI.navController.exit();
		    }
		});
	else if(!applicationStarted) {
		ICABBI.navController.hideNotification();
		
		if (!Ti.Geolocation.locationServicesEnabled) {
			ICABBI.navController.showError({
			    title:'GPS problem!',
			    message:'Please enable Location Services',
			    buttons : ['OK'],
			    click : function(e){
			    	
			    	startApplication();
			    }
			});
		}
		else
			startApplication();
	}
	else
		ICABBI.navController.hideNotification();
};    
Ti.Network.addEventListener('change', networkHandler);

if(Ti.Platform.osname === 'iphone' || Ti.Platform.osname === 'ipad')
	networkHandler();
	
