var _ = require('/lib/lodash')._ ,
	tools = require('/lib/tools'),
	HTTPClient = require('/core/HTTPClient');
	
if(!String.prototype.str_pad){
	String.prototype.str_pad = function (padLength,padChar) {
		return this.length<padLength ? Array(padLength+1-this.length).join(padChar||0)+this : this.toString();
	};
}

var ConnectPayAPI = (function(){
	var self = {
			session:null,
			// config:ApiConfig
			config:null,
			initialized:false
	};
	self.initialize = function(config){
		if(!!self.initialized) return;
		self.initialized=true;
		
		self.config = config;
	};

	var	_getSecurityParams = function(){
			var params = {
					uid:self.config.UID,
					pwd:self.config.PWD,
					accountid:self.config.ACCOUNTID,
					profileid:self.config.PROFILEID,
					sessionid:+new Date,
				};
			return params;
		};
	
	self.remote = function(url, options, ctx){

		var paramsGET	= options.method==='GET' ? options.data : {},
			paramsPOST	= options.method==='POST' ? options.data : {}; //can be JSONstring || object

		if(!HTTPClient.isAbsoluteURL(url)){
			url= self.config.ENDPOINT+url;
			var	paramsURL={};
			if(!!~url.indexOf('?')){
				var	paramsArr= url.split('?')[1].split('&');
				_.each(paramsArr,function(param){
					var parts = param.split('=');
					paramsURL[parts[0]]=parts[1];
				});
				url = url.split('?')[0];
			}
			// _.extend(paramsGET,_getSecurityParams(),paramsURL);
			_.extend(paramsPOST,_getSecurityParams());

			if(options.method!=='GET' && !_.isEmpty(paramsGET)){
				url+='?'+HTTPClient.buildQueryString(paramsGET);	
			}
		};
		
		options.data = options.method==='GET' ? paramsGET : paramsPOST;
		options.timeout=90000;
		
		return HTTPClient.remote(url, options, ctx);
	};

//mpos_xpostokenise
	
	self.tokenize = function(data, options){
		data=_.extend({cardno:'',expmonth:'',expyear:'',avshouseno:'',avspostcode:''},data);
		options=options||{};
		//clear old session
		self.remote('mpos_xpostokenise.asp',{
			data:data,
			method:'POST',
			success:function(e){
				var response={};
				if(e && e.length){
					var parts = e.split('&');
					_.each(parts,function(part){var pair=part.split('=');response[pair[0]]=pair[1];});
				}
/*
Ti.API.info('>>>>>>>self.tokenize: '+JSON.stringify(response));
{"status":"1","response":"Card token has been obtained.",
"cardtoken":"715800212","cardno":"44/1111","expiry":"11/20"}

{ status: '0', response: 'Failed Validation, Card number is invalid ' }
*/
				options.success && options.success(response);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

	self.directPayment = function(params) {
					
		return {
			url: self.config.DIRECTENDPOINT,
			mid: self.config.ACCOUNTID,
			uid: self.config.UID,
			pwd: self.config.PWD,
			branding: self.config.BRANDING,
			pagetitle: self.config.PAGE_TITLE ? self.config.PAGE_TITLE : 'Adelante Secure Payment Portal',
			intromessage: self.config.PAGE_INTRO ? self.config.PAGE_INTRO : 'Welcome to our secure payment page',
			orderid: params.orderid,
			amount: parseInt(params.amount * 100),
			currency: params.currency,
			paymentmessage: self.config.PAYMENT_MSG,
			cardmask: 'AMTCDEJIS',
			surchargeamount: params.service_charge ? parseInt((params.amount + params.service_charge) * 100) : '',
			surchargecardmask: params.service_charge ? 'AMTCDEJIS' : '',
			cardfirstname: params.cardfirstname,
			cardsurname: params.cardsurname,
			addr1: params.addr1, 
			addr2: params.addr2,
			city: params.city,
			postalcode: params.postalcode,
			country: params.country,
			keycheck: '',
			resulturl: '',
			returnurl: self.config.RETRUNURL,
			autoreturn: 1
		};
	};
	
	return self;

})();

module.exports = ConnectPayAPI;