var _ = require('/lib/lodash')._ ,
	tools = require('/lib/tools'),
	sqlite = require('/lib/SQLiteManager'),
	HTTPClient = require('/core/HTTPClient');
//var	ICABBI = require('/core/icabbi');	
if(!String.prototype.str_pad){
	String.prototype.str_pad = function (padLength,padChar) {
		return this.length<padLength ? Array(padLength+1-this.length).join(padChar||0)+this : this.toString();
	};
}


var IcabbiAPI = (function(){
	var self = {
			session:null,
			// config:ApiConfig
			config:null,
			initialized:false
		};
	self.initialize = function(config){
		if(!!self.initialized) return;
		self.initialized=true;
		
		self.config = config;
	};
	
	var	_getSecurityParams = function(){
			var params = {
					//log:1,
					app_key:self.config.APP_KEY,
					user_id:self.session ? self.session.user_id : 0,
					nonce:tools.guid(),
					timestamp:(function(now){
						var ts = [
							now.getUTCFullYear().toString(),
							now.getUTCDate().toString().str_pad(2),
							(now.getUTCMonth()+1).toString().str_pad(2),
							now.getUTCHours().toString().str_pad(2),
							now.getUTCMinutes().toString().str_pad(2),
							now.getUTCSeconds().toString().str_pad(2),
						].join('');
						return ts;
					})(new Date) ,
					src:'APP',
					appv:Titanium.App.version
				};
			return params;
		},
		_generateHash = function(token,url,method,params,contentType){
			//url comes with protocol http:// or https://
			(url.charAt(url.length - 1) === '/') && (url=url.substr(0,url.length-1));
			url = encodeURIComponent(url.replace(/^https?:\/\//,''));
			var retVal=[],
				secureParams = _.extend({url:url},params.get,(method!=='GET' && contentType==='application/json' ? {}:params.post||{})),
				sortedKeys = _.sortBy(_.keys(secureParams),function(val){return val;});
				
			_.each(sortedKeys,function(key){
// Ti.API.info('************** [key] '+key+'    [value]' +secureParams[key]);
				retVal.push(key+':'+secureParams[key]);
			});
			if(method!=='GET' && contentType==='application/json'){
				retVal.push(params.post||'');
			}
// Ti.API.info('************** [token] '+token);
			retVal = retVal.join(',')+'.token:'+token;
			
// Ti.API.info('************** [hashstring] '+retVal);
			return Ti.Utils.sha1(retVal);
		};

	self.setSession = function(user_id,token){
		self.session = {user_id:id,token:token};
	};
	
	self.remote = function(url,options,ctx){
tools.dbg('++++++++++++++++++ IcabbiAPI.remote ++++++++++++++++++ ');
		_.defaults((options||(options={})),{method:"GET",data:{}});
tools.dbg(url);
tools.dbg("start: "+JSON.stringify(options));

		var paramsGET	= options.method==='GET' ? options.data : {},
			paramsPOST	= options.method==='POST' ? options.data : {}; //can be JSONstring || object

		if(!HTTPClient.isAbsoluteURL(url)){
			url= self.config.ENDPOINT+url;
			var	paramsURL={};
			if(!!~url.indexOf('?')){
				var	paramsArr= url.split('?')[1].split('&');
				_.each(paramsArr,function(param){
					var parts = param.split('=');
					paramsURL[parts[0]]=parts[1];
				});
				url = url.split('?')[0];
			}
			options.cache_key = url+'?'+HTTPClient.buildQueryString(paramsGET);
			
			_.extend(paramsGET,_getSecurityParams(),paramsURL);
			paramsGET.hash = _generateHash(
								self.session?self.session.token:'',
								url,options.method,
								{get:paramsGET,post:paramsPOST},
								options.contentType);
			
			if(!_.isEmpty(paramsGET)){
				url+='?'+HTTPClient.buildQueryString(paramsGET);	
			}
		};
		options.data = options.method==='POST' ? paramsPOST : {};
		// options.data = options.method==='GET' ? paramsGET : JSON.stringify(paramsPOST);
tools.dbg("end: "+JSON.stringify(options));
tools.dbg('++++++++++++++++');	
		
		var success = options.success;
		
		options.success = function(e){
			var response = JSON.parse(e);
			if(response.code==self.config.RESPONSE_CODES.TOKEN_INVALID ||
				response.code==self.config.RESPONSE_CODES.USERID_BANNED){
					ICABBI.Controller.deauthenticate({'alert': false});
				//self.session && sqlite.deleteSession(self.session);
				//self.session = null;
			}
			
			if(success){
		        	success.call(ctx||null,e);
		    }
		};
		
		
		return HTTPClient.remote(url,options,ctx);
	};

	self.validateUserSession = function(options){ 
Ti.API.info('###########validateUserSession ######################');
		options=options||{};
		self.session = options.session?options.session:sqlite.getSession();
Ti.API.info('>>>>>>>>self.session:' + JSON.stringify(self.session));
		//have nothing to validate
		if(null===self.session || !('token' in self.session)) {
			// Marian old call options.success && options.success(self.session);
			// invalid session (null or no token available for validation)
			options.success && options.success(null);
			return;
		}
		self.remote('account/validatetoken',{
			method:'POST',
			cache : false,
			data:{user_id:self.session.user_id,token:Titanium.Utils.sha1(self.session.token)},
			success:function(e){
				var response = JSON.parse(e);
/*
{"code":7,"message":"Token Invalid","body":[]}
{	"code":"0",
	"body":{
		"token":"IbpMrxzQ0sOkmNFbSaiGtzW8RMZSK8Ug","user_id":"103079",
		"valid":1,"client_id":"6","phone":"00353873588613","email":"sonal@gupta.com",
		"name":"sonalgupta","bookingreceipts":"0"
	},
	"warnings":[],
	"nonce":"07FAD890-6AA6-27E6-F40A-88EA4357A329"
}
*/
				
				
				if(response.code==self.config.RESPONSE_CODES.OK){
					if(response.body && response.body.token){
						self.session = _.extend(_.clone(response.body),self.session);
					}else{
						alert('werid Situation in icabbiApi.validateUserSession response');
					}
					//sqlite.updateSession(self.session);
				}
				else if(response.code==self.config.RESPONSE_CODES.TOKEN_INVALID ||
					response.code==self.config.RESPONSE_CODES.USERID_BANNED
					|| (response.body && !response.body.token)){
					Ti.API.info('>>>>>>>>>>>>>self.validateUserSession: INVALID SESSION');
					//token is invalid delete from db
					self.session && sqlite.deleteSession(self.session);
					self.session = null;
				}
				else if(response.error) {
					options.error && options.error(response);
					return;
				} 
				
				//token is valid that mean user is logged in
				//fetch user info here?
				options.success && options.success(self.session);
			},
			error:function(e){
				Ti.API.info('##########error#################');
				Ti.API.info(e);
				Ti.API.info(JSON.parse(e));
				Ti.API.info('###########################');
				options.error && options.error(e);
			}
		});
	};

	self.deauthenticate = function(options){ 
		//clear old session
		self.session && sqlite.deleteSessions(self.session);
		self.session=null;
		options.success && options.success();
	};
	
	self.authenticate = function(data,options){ 
		options=options||{};
		//clear old session
		self.session && sqlite.deleteSession(self.session);
		self.session=null;
		var err;
		
		self.remote('account/token',{
			data:data,
			// data:{username:'anocallaghan',password:'st*rbuck$'},
			method:'POST',
			success:function(e){
				var response = JSON.parse(e);
Ti.API.info('>>>>>>>self.authenticate: '+e);
/*
{"code":0,"message":"Incorrect Username and\/or Password entered","body":null}
{	"code":"0",
	"body":{
		"token":"IbpMrxzQ0sOkmNFbSaiGtzW8RMZSK8Ug",
		"user_id":"103079","client_id":"6","phone":"00353873588613",
		"email":"sonal@gupta.com","name":"sonalgupta","bookingreceipts":"0"
	},
	"warnings":[],
	"nonce":"F2DC7184-37AD-278A-9E5C-339410CA298B"
}
*/
				

				if(response.message){
					//user login failed..no token..enter username/password again
					Ti.API.info('>>>>>>>self.session: null');
					self.session=null;
					err=response.message;
				}
				else if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					self.session = _.extend(_.clone(response.body),{expires:0});
					Ti.API.info('>>>>>>>self.session:' +self.session);
					//save this token in sqlite
					sqlite.setSession(self.session);
				}
 
				options.success && options.success(self.session,err);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.resetPassword = function(data,options){
		options=options||{};
		self.remote('profile/password',{
			data:data,
			method:'POST',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
				}
				options.success && options.success();
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
		
	};
	
	self.updateUserProfile = function(data, options){
		options=options||{};
		self.remote('profile/updateprofile', {
			data: { userprofile: JSON.stringify(data) },
			method:'POST',
			success: function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response.error);
					return;
				}
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					options.success && options.success(response.body);
				}
			},
			error: function(e){
				options.error && options.error(e);
			}
		});		
	};
	
	self.forgotPassword = function(data,options){
		options=options||{};
		self.remote('account/forgot',{
			data:data,
			method:'POST',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				if(response.code!=self.config.RESPONSE_CODES.OK && response.message){
					options.error && options.error(response.message);
					return;
				}
				options.success && options.success();
			},
			error: function(e){
				options.error && options.error(e.message);
			}
		});
		
	};
	
	self.register = function(data,options){ 
		options=options||{};
		//clear old session
		self.session && sqlite.deleteSessions(self.session);
		self.session=null;
		var err;
		self.remote('account/register',{
			data:data,
			method:'POST',
			success:function(e){
				var response = JSON.parse(e);
Ti.API.info('>>>>>>>self.register: '+e);
/*
{"code":201,"message":"Registration failed","body":{"email":"This email is already in use, please try again or login"}}
{"code":"0","body":{"token":"MWThsDBVyJv9a1d5AbsENyPWVoWIXylG","user_id":"103295"},"warnings":[],"nonce":"7EF92BC8-6DE7-87E7-51DD-9508115353F1"}
*/
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					self.session = _.extend(_.clone(response.body),{expires:0});
					Ti.API.info('>>>>>>>self.session:' +self.session);
					//save this token in sqlite
					sqlite.setSession(self.session);
				}
				else if(response.message){
					//user registeration failed..no token..
					Ti.API.info('>>>>>>>self.session: null');
					self.session=null;
					err=response.body||response.message;
				}
				options.success && options.success(self.session,err);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.getETA = function(data,options){ 
		options=options||{};
		var eta = 0;
		//clear old session
		self.remote('eta/zone',{
			data:data,
			method:'POST',
			success:function(e){
				var response = JSON.parse(e);
/*
Ti.API.info('>>>>>>>self.getEta: '+e);
{"code":"0","body":{"eta":30},"warnings":[],"nonce":"A95B0700-CA8E-0A89-94C9-7E6B83337E93"}
*/
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					eta = response.body.eta;
				}
				options.success && options.success(eta);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

// $req->setAddress(Api::url('destinations/geocode', $options));
// $options = array('app_key'=>$this->appkey, 'q'=>urlencode($input), 'a'=>1);
	self.getDestinations = function(q,options){ 
Ti.API.info('>>>>>>>self.getDestinations');
		options=options||{};
		var addresses = [];
		var data = {q : q, f:1, p : 1};
		//clear old session
		self.remote('addresses/geocode',{
			data:data,
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
Ti.API.info('>>>>>>>self.getDestinations: '+e);
/*
[
{"id":"100484828","source":"CLIENT","source_id":"100484828","wheelchair":"0","condition":"3","saloon":"0","uniformed":"0","discount":"0.00","used":"4139","last_used":"1369654631","approved":"1","priority":"8","updated":"1355836829","short_code":"air","access_code":null,"instructions":null,"operator_instructions":null,"lat":"53.428905","lng":"-6.255774","organisation":null,"department":null,"sub_building":null,"building":"DAX 1","building_number":"TERMINAL 1","building_group":null,"building_use":"R","street":"DUBLIN AIRPORT TERMINAL 1 ","ctype_id":"3","type":"","area":null,"secondary_area":null,"postcode":null,"county":"Dublin","address":"Dublin Airport"}
,{"id":"100484763","source":"CLIENT","source_id":"100484763","wheelchair":"0","condition":"3","saloon":"0","uniformed":"0","discount":"0.00","used":"4297","last_used":"1368899781","approved":"1","priority":"8","updated":"1350381956","short_code":null,"access_code":"S","instructions":null,"operator_instructions":null,"lat":"53.346273","lng":"-6.293834","organisation":null,"department":null,"sub_building":null,"building":"HEUSTON TRAIN STATION","building_number":null,"building_group":null,"building_use":"R","street":"SAINTJOHNS","ctype_id":"4","type":"ROAD","area":null,"secondary_area":null,"postcode":null,"county":"Dublin","address":"Heuston Train Station, Dublin"}
]
*/
				// if(response.error) {
					// options.error && options.error(response);
					// return;
				// }
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					addresses = response.body.addresses;
				}
				options.success && options.success(addresses);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

	self.getVehicles = function(options){ 
Ti.API.info('>>>>>>>self.getVehicles');
		options=options||{};
		var vehicles = [];
		//clear old session
		self.remote('config/vehicletypes',{
			data:{},
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
Ti.API.info('>>>>>>>self.getVehicles: '+e);
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					vehicles = response.body.vehicletypes;
				}
				options.success && options.success(vehicles);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

	self.getTerms = function(options){ 
Ti.API.info('>>>>>>>self.getTerms');
		options=options||{};
		//clear old session
		self.remote('content/terms',{
			data:{},
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
Ti.API.info('>>>>>>>self.getTerms: '+e);
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				options.success && options.success(response.body.terms);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

	self.getConfig = function(options){ 
		options=options||{};
		//clear old session
		self.remote('client/config',{
			data:{},
			cache : false,
			method:'GET',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				response.body.config && options.success && options.success(response.body.config);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.getCompanyConfig = function(options){ 
		options=options||{};

		self.remote('appconfig/index',{
			data:{},
			cache : false,
			method:'GET',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				options.success && options.success(response.body.appconfig);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

	self.reverseGeocoder = function(lat, lng, options){ 
		options=options||{};

		self.remote('addresses/search',{
			data:{lat:lat,lng:lng, f:1,l:1, q:'', b : ICABBI.Config.show_map ? 0 : 1, p : 0},
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var addresses = null;
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					addresses = response.body.addresses;
				}
				options.success && options.success(addresses);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.searchAddreses = function(q, category_id, address_book, lat, lng, destination, options) { 
		options=options||{};
		var data = {q : q};
		
		if(lat != null) {
			data['lat'] = lat;
			data['lng'] = lng;
		}

		if(category_id) {
			data['c'] = category_id;
		}
		
		if(address_book) {
			data['b'] = 1;
		}
		else
			data['b'] = 0;
		data['f'] = 1;
		data['d'] = destination ? 1 : 0;
		
		self.remote('addresses/search',{
			data:data,
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var addresses = null;
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					addresses = response.body.addresses;
				}
				options.success && options.success(addresses);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};	

	self.relatedAddresses = function(address_id, options) {
		options=options||{};
		var data = {address_id : address_id};

		self.remote('addresses/related',{
			data: data,
			method: 'GET',
			cache : true,
			success: function(e){
				
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var addresses = null;
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					addresses = response.body.addresses;
				}
				options.success && options.success(addresses);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};

	self.poiCategories = function(options){ 
		options=options||{};

		self.remote('addresses/poicategories',{
			data:{},
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var poi_categories = null;
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					poi_categories = response.body.poi_categories;
				}
				options.success && options.success(poi_categories);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.confirmBooking = function(data,options){
		options=options||{};

		self.remote('bookings/check',{
			data:{booking:JSON.stringify(data)},
			method:'POST',
			contentType : 'application/x-www-form-urlencoded',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var booking = null, estimate = null;
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					booking = response.body.booking;
					estimate = response.body.estimate;
					
					options.success && options.success(booking, estimate);
				}
				else if(response.error)
					options.error && options.error(response);
				
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};	
	
	self.getBookingNotes = function(options){ 
		options=options||{};
		var notes = [];
		
		self.remote('bookings/notes',{
			data:{},
			method:'GET',
			cache : false,
			success:function(e){
				var response = JSON.parse(e);
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					notes = response.body.bookingnotes;
				}
				options.success && options.success(notes);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.getCardTypes = function(options){ 
		options=options||{};
		var notes = [];
		
		self.remote('creditcards/types',{
			data:{},
			method:'GET',
			cache : true,
			success:function(e){
				var response = JSON.parse(e);
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				var cards = [];
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					cards = response.body.accounts;
				}
				options.success && options.success(cards);
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.rateDriver = function(data,options){
		options=options||{};

		self.remote('drivers/rate',{
			data:{driverrating :JSON.stringify(data)},
			method:'POST',
			contentType : 'application/x-www-form-urlencoded',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var driverrating = null;
				if(response.code==self.config.RESPONSE_CODES.OK && response.body){
					driverrating = response.body.driverrating;
					options.success && options.success(driverrating);
				}
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.registerCreditCard = function(data, options){
		options=options||{};

		self.remote('creditcards/new', {
			data:{creditcard: JSON.stringify(data)},
			method:'POST',
			contentType : 'application/x-www-form-urlencoded',
			success:function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var creditcard = null;
				if(response.code == self.config.RESPONSE_CODES.OK && response.body){
					creditcard = response.body.creditcard;
					options.success && options.success(creditcard);
				}
			},
			error: function(e){
				options.error && options.error(e);
			}
		});
	};
	
	self.processPayment = function(payment, options){
		options=options||{};

		self.remote('payment/process', {
			data:{ payment: JSON.stringify(payment) },
			method:'POST',
			contentType : 'application/x-www-form-urlencoded',
			success: function(e){
				var response = JSON.parse(e);
				
				if(response.error) {
					options.error && options.error(response);
					return;
				}
				
				var payment = null;
				if(response.code == self.config.RESPONSE_CODES.OK && response.body){
					payment = response.body.payment;
					options.success && options.success(payment);
				}
			},
			error: function(e){
				var err = JSON.parse(e);
				options.error && options.error(err);
			}
		});
	};
	
	return self;

})();

module.exports = IcabbiAPI;