/**
 * @author Sonal
 */
var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ;


//ModalView Component Constructor
var ThemeManager = (function(options) {
	options = _.extend({name:'dark'},options);

	var self = {};
	var theme = require('/ui/theme/'+options.name);
	
	self.def = function(prop){
		var retval=theme.Properties;
		_.each(prop.split('.'),function(p){
			retval=retval[p]||{};
		});
		return _.clone(retval);
	};
	
	self.styl = function(){
		return _.extend.apply(_,_.map(Array.prototype.slice.call(arguments),function(prop){
				var retval={};
				if(_.isObject(prop)) retval=prop;
				else if(_.isString(prop)){
					retval=theme.Properties;
					_.each(prop.split('.'),function(p){
							retval=retval[p]||{};
					});					
				}
				return _.clone(retval);
			})
		);
	};
	
	self.getHeaderHeight = function(){
		return theme.Constants.headerHeight;
	};
	
	//get the statusbar height
	self.getStatusbarHeight = function(){
		//240x320 - 20px 320x480 - 25px 480x800+ - 38px
		var height;
		switch(theme.Constants.platformHeight){
			case 320 : height=20; break; 
			case 480 : height=25; break; 
			case 800 : height=38; break; 
			default : height=25; break; 
		}
		return height;
	};
	
	self.animateButton = function(btn,config){
		config = config||{};
		if(btn.backgroundGradient){
			//btn shud have both gradient and backgroundColor defined
			//ill only toggle gradient - so backgroundColor will takeover in [on] state
			var gradient = btn.backgroundGradient;
			btn.addEventListener('touchstart', function(e) {
				btn.backgroundGradient={};
			});
			btn.addEventListener('touchend', function(e) {
				btn.backgroundGradient=gradient;
			});
		}else{
			btn.addEventListener('touchstart', function(e) {
				btn.backgroundColor=config.backgroundColor.on;
			});
			btn.addEventListener('touchend', function(e) {
				btn.backgroundColor=config.backgroundColor.off;
			});
		}
	}
	return self;
})();

ThemeManager.ActivityIndicator = (function() {
	var active = false;
	var container = Ti.UI.createWindow({
        backgroundColor:  '#000',
		zIndex:10000,
        opacity: 0.85
	});
    var view = Ti.UI.createView({
        width:   Ti.UI.SIZE,
        height:   Ti.UI.SIZE,
		borderWidth: 2,
		borderColor: '#888',
		borderRadius: 4,
		backgroundColor: '#000',
		opacity:1,
		touchEnabled:false,
		bubbleParent:false,
    });
	
	var style = (Ti.Platform.osname === 'iphone') 
					? Ti.UI.iPhone.ActivityIndicatorStyle.PLAIN
					: Ti.UI.ActivityIndicatorStyle.PLAIN;

					
	var activityIndicator = Ti.UI.createActivityIndicator({
	  left:15,
	  top:15,
	  style:style,
	});
    view.add(activityIndicator);
	var label = Ti.UI.createLabel({
	  left:45,
	  right:15,
	  top:15,
	  bottom:15,
	  height:Ti.UI.SIZE,
	  textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
	  color:'#fff',
	  font: {fontFamily:'HelveticaNeue', fontSize:20},
	  text: 'Please wait...',
	});
    view.add(label);

    container.add(view);

	container.start = function(text) {
		if(active) return;
		active=true;
		label.text = text||'Please wait...';
        container.open();
		activityIndicator.show();
	};

    container.stop = function() { 
		if(!active) return;
		active=false;
        container.close();
		activityIndicator.hide();
	};
    return container;
})();

module.exports = ThemeManager;
