/**
 * @author Sonal
 */
// var ICABBI = require('/core/icabbi'),
	var HTTPClient = require('/core/HTTPClient'),
	_ = require('/lib/lodash'),
	IcabbiAPI = require('/core/IcabbiAPI');

var roundOff=function(num){
	return Number(Number(num).toFixed(6));
};

var Geolocation = (function(){
	var self = {
			initialized:false,
		},
		tracking = false,
		lastPosition = null,
		trackingCallback = null,
		GOOGLE_API='http://maps.googleapis.com/maps/api/geocode/json?sensor=true&latlng=';
		GOOGLE_SEARCH_API='http://maps.googleapis.com/maps/api/geocode/json?sensor=false&address=';
	
	self.addLocationProvider = function(first){
		first===void 0 && (first=false);
		var gpsProvider = Ti.Geolocation.Android.createLocationProvider({
  			name: Ti.Geolocation.PROVIDER_GPS,
    		minUpdateTime:first?0:60,// first?0:60, //s
    		minUpdateDistance:first?0.0:100.0,// first?0:100 //m
		});
		Ti.Geolocation.Android.addLocationProvider(gpsProvider);

		var networkProvider = Ti.Geolocation.Android.createLocationProvider({
  			name: Ti.Geolocation.PROVIDER_NETWORK,
    		minUpdateTime:first?0:60,// first?0:60, //s
    		minUpdateDistance:first?0:100,// first?0:100 //m
		});
		Ti.Geolocation.Android.addLocationProvider(networkProvider);
	};
	
	self.addLocationRule = function(){
		var gpsRule = Ti.Geolocation.Android.createLocationRule({
		    provider: Ti.Geolocation.PROVIDER_GPS,
		    // Updates should be accurate to 100m
		    accuracy: 100,
		    // Updates should be no older than 5m
		    maxAge: 1*60*1000,
		    // But  no more frequent than once per 10 seconds
		    minAge: 10*1000
		});
		Ti.Geolocation.Android.addLocationRule(gpsRule);

		var networkRule = Ti.Geolocation.Android.createLocationRule({
		    provider: Ti.Geolocation.PROVIDER_NETWORK,
		    // Updates should be accurate to 100m
		    accuracy: 100,
		    // Updates should be no older than 5m
		    maxAge: 1*60*1000,
		    // But  no more frequent than once per 10 seconds
		    minAge: 10*1000
		});
		Ti.Geolocation.Android.addLocationRule(networkRule);
	};
	
	
	self.init = function(){
		Titanium.Geolocation.Android.manualMode = true;

		/*ignored as manualMode=true*/
		Ti.Geolocation.accuracy = Ti.Geolocation.ACCURACY_BEST;
		Ti.Geolocation.preferredProvider = Ti.Geolocation.PROVIDER_GPS;


		if(Titanium.Geolocation.Android.manualMode){
			self.addLocationProvider(true);
			self.addLocationRule();
		}
		tracking=false;
		self.startTracking()
/*		
		Ti.Geolocation.addEventListener('location', function(e){
Ti.API.info('firstattemptgps:' + JSON.stringify(e));
			var fn = arguments.callee;
			// if(e.success && !e.error && e.coords && Number(e.coords.accuracy)<35){
			if(e.success && !e.error && e.coords){
				//reset to actuals
				Ti.Geolocation.removeEventListener('location',fn);
				self.addLocationProvider(false);
				self.locationCallback(e);
				return;
			}else{
				if(e.error){
					if(e.error==='gps is disabled'){
						// setTimeout(function(){
							// alert('Please enable GPS for more accurate position');
						// },2000);
					}
				}
			}
		});
*/
		// self.startTracking(false,function(e){
			// self.stopTracking();
		// });
		var activity = Ti.Android.currentActivity;
		activity.addEventListener('destroy', self.stopTracking);
	    // activity.addEventListener('pause', self.stopTracking);
	    activity.addEventListener('resume', self.startTracking);

		self.initialized=true;
	};
	
	var locationCallback = function(e){
Ti.API.info('locationCallback:' + JSON.stringify(e));
		if (!e.success || e.error) {
       		Ti.API.info('error:' + JSON.stringify(e.error));
    	}else{
			if(e.coords){
				Ti.API.info('coords: ' + JSON.stringify(e.coords));
				if(lastPosition && e.coords.timestamp-lastPosition.coords.timestamp<30*1000){
					if(Number(lastPosition.coords.accuracy)>Number(e.coords.accuracy)){
						e=lastPosition;
					}
				}
				lastPosition = e;
				trackingCallback && trackingCallback(e);
			}
		}
	};

	self.setTrackingCallback = function(callback){
Ti.API.info('updateUserLocation: setTrackingCallback'+(callback?'set':'unnnnnnset'));
		trackingCallback=callback;
	};
	/*
		e.provider.name
		e.source.accuracy
	*/
	
	self.getLastLocation = function(){
		return lastPosition;
	};
	// {"type":"location","source":{"bubbleParent":true,"hasCompass":true,"__propertiesDefined__":true,"Android":{"bubbleParent":true,"manualMode":false},"preferredProvider":"gps","locationServicesEnabled":true,"purpose":"Get Current Location","accuracy":2,"_events":{"location":[{},{}]}},"success":true,"provider":{"power":3,"accuracy":1,"name":"gps"},"coords":{"timestamp":1369432800000,"speed":0,"altitude":0,"longitude":-122.084095,"latitude":37.422005,"accuracy":0,"heading":0,"altitudeAccuracy":null},"bubbles":false,"cancelBubble":false}
	// {"timestamp":1357909204000,"speed":0,"altitude":0,"longitude":-122.084095,"latitude":37.422005,"accuracy":0,"heading":0,"altitudeAccuracy":null}
	self.getCurrentPosition = function(callback){
		Titanium.Geolocation.purpose = 'Get Current Location';
		//{"timestamp":1357909204000,"speed":0,"altitude":0,"longitude":-122.084095,"latitude":37.422005,"accuracy":0,"heading":0,"altitudeAccuracy":null}
		// if(lastPosition){
			// callback(lastPosition)
		// }
		// else{
			// Titanium.Geolocation.getCurrentPosition(callback);
		// }
		Titanium.Geolocation.getCurrentPosition(function(e){
			if(e.coords){
				if(!lastPosition 
					|| e.coords.timestamp-lastPosition.coords.timestamp>60*1000
					|| Number(lastPosition.coords.accuracy)>Number(e.coords.accuracy)){
					lastPosition=e;
				}
				callback && callback(lastPosition)
			}else{
				callback && lastPosition && callback(lastPosition);
			}
		});
	};

	// self.startTracking = function(sendCurrentPosition,callback){
	self.startTracking = function(callback){
		if(tracking)
			return;
Ti.API.info('sstracking:start')
		trackingCallback = callback||null;

		Titanium.Geolocation.purpose = 'Get Current Location';
		//{"timestamp":1357909205000,"speed":0,"altitude":0,"longitude":-122.084095,"latitude":37.422005,"accuracy":0,"heading":0,"altitudeAccuracy":null}
		//dirty hack for one-off without moving
	  //	sendCurrentPosition && Titanium.Geolocation.getCurrentPosition(trackingCallback);
		Ti.Geolocation.addEventListener('location', locationCallback);
		tracking = true;
	};

	self.stopTracking = function(callback){
Ti.API.info('sstracking:stop')
		// tracking && Titanium.Geolocation.removeEventListener('location', callback||self.locationCallback);
		tracking && Titanium.Geolocation.removeEventListener('location', locationCallback);
		// trackingCallback = null;
		tracking = false;
	};
	
	self.forwardGeocoder = function(address,callback){
		Ti.Geolocation.forwardGeocoder(address, function(e) {
    		Ti.API.info(JSON.stringify(e));
    		callback(e);
		});
	};
	
	//http://maps.googleapis.com/maps/api/geocode/json?latlng=40.714224,-73.961452&sensor=true_or_false
	self.reverseGeocoder = function(location,callback){
		Ti.API.info('>>>>>>reverseGeocoder');
		var address = {success:false};
		var titaniumapi = function(location,options){
			Ti.Geolocation.reverseGeocoder(location.latitude, location.longitude, function(data) {
				// data = JSON.parse(data);
	    		Ti.API.info('>>>>titanium>>>>>>reverseGeocoder: '+JSON.stringify(data));
				if(data.code!=-1 && data.success && data.places && data.places.length){
				var places = data.places||undefined;
					var place = data.places[0];
					address={
						success:true,
						src:'GOOGLE_MAPS',
						area:place.city,
						formatted:place.address ? place.address : place.country 
					};
				}


				options.success && options.success(address); 
			});
		};
		var icabbirevercegeocode = function(location,options){
			IcabbiAPI.reverseGeocoder(location.latitude, location.longitude,{
				success: function(addresses) {
					// data = JSON.parse(data);
		    		Ti.API.info('>>>>icabbi>>>>>>reverseGeocoder: '+JSON.stringify(addresses));
					if(addresses && addresses.length) {
						var place = addresses[0];
						
						address={
							success:true,
							id:place.id,
							src:place.source||'',
							area:place.area||'',
							formatted:place.formatted||'',
							lat: place.lat,
							lng: place.lng,
						};
					}
	
	
					options.success && options.success(address); 
				}
			});
		};

		var googleapi = function(location,options){
			var endpoint = GOOGLE_API+location.latitude+','+location.longitude;
			HTTPClient.remote(endpoint,{
				success: function(data){
					data = JSON.parse(data);
					var results = data.results;
		    		// Ti.API.info('>>>>google>>>>>>reverseGeocoder: '+JSON.stringify(data));

					// if(data.status!=='OK' || data.status!=='ZERO_RESULTS' || !results.length){
					if(data.status!=='OK' || !results.length){
						titaniumapi(location,options);
						return;
					}
					if(results.length){
						_.each(results[0].address_components,function(comp){
							address[comp.types[0]] = comp.long_name;
						});
						address={
							success:true,
							src:'GOOGLE_MAPS',
							area:address.locality||'',
							formatted:results[0].formatted_address
						};
						address['lat'] = results[0].geometry && results[0].geometry.location && results[0].geometry.location.lat;
						address['lng'] = results[0].geometry && results[0].geometry.location && results[0].geometry.location.lng;
					}
					options.success && options.success(address); 
				}
			});
		};
		
		var provider = ICABBI.Config.address_src==='google' ? googleapi : icabbirevercegeocode;
		provider(location,{
			success: function(address){
				if(callback != null)
			    	callback(address);
			}
		});
				
		/*
		Ti.Geolocation.reverseGeocoder(location.latitude, location.longitude, function(e) {
    		Ti.API.info('>>>>>>reverseGeocoder: '+JSON.stringify(e));
		});
		*/
	};
	
	var icabbisearchapi = function(q,poi,destination,location,options, address_book) {
			var lat = null;
			var lng = null;
			
			if(location) {
				lat = roundOff(location.lat);
				lng = roundOff(location.lng);
			}
			
			IcabbiAPI.searchAddreses(q, poi, address_book, lat, lng, destination, {
				success: function(data){
					
					if(data && data.length) {
						var addresses = [];
						
						_.each(data, function(place){
							
							var address = {
								success:true,
								id:place.id,
								src:place.source||'',
								formatted:place.formatted||'',
								area:place.area||'',
								lat: place.lat,
								lng: place.lng,
							};
							addresses.push(address);
						});
						
						options.success && options.success(addresses);
					}
					else {
						options.error && options.error(); 
					}
				},
				error: function(error){
					options.error && options.error(error); 
				}
			});
		};

		var googlesearchapi = function(q,poi,destination,location,options){
			
			var endpoint = GOOGLE_SEARCH_API+q;

			HTTPClient.remote(endpoint,{
				success: function(data){
					Ti.API.info('success get address');
					Ti.API.info(data);
					data = JSON.parse(data);
					var results = data.results;
					
					if(data.status!=='OK' || !results.length){
						options.error && options.error(); 
						return;
					}
					Ti.API.info('process address');
					Ti.API.info(results.length);
					var addresses = [];
					if(results.length){
						var resultList = [];
						_.each(results, function(resultAddress){
							var address = {};
							resultList.push(address);
							_.each(resultAddress.address_components,function(comp){
								address[comp.types[0]] = comp.long_name;
							});
							address['lat'] = resultAddress.geometry && resultAddress.geometry.location && resultAddress.geometry.location.lat;
							address['lng'] = resultAddress.geometry && resultAddress.geometry.location && resultAddress.geometry.location.lng;
							
							address['formatted_address'] = resultAddress.formatted_address;
						});
						_.each(resultList, function(address){
							if(address.route)
								addresses.push({
									success:true,
									src:'GOOGLE_MAPS',
									area:address.locality||'',
									formatted:address.formatted_address,
									lat: address.lat,
									lng: address.lng,
								});
						});
					}
					Ti.API.info('send address');
					Ti.API.info(options.success);
					Ti.API.info(addresses.length);
					options.success && options.success(addresses); 
				},
				error: function(error){
					Ti.API.info('error get address');
					Ti.API.info(error);
					options.error && options.error(error); 
				}
			});
		};
	
	self.searchAddressBook = function(q,destination,location,callback){
		Ti.API.info('>>>>>>search address book');
		
		icabbisearchapi(q, null, destination, location, {
			success: function(data){
				Ti.API.info('call address search');
				if(callback)
					callback(data);
			},
			error: function(error){
				if(callback)
					callback(null);
			}
		}, true);
	};
	
	self.searchAddress = function(q,poi,destination,location,callback){
		Ti.API.info('>>>>>>search address');
		
		var provider = ICABBI.Config.address_src==='google' ? googlesearchapi : icabbisearchapi;
		provider(q,poi, destination, location, {
			success: function(data){
				Ti.API.info('call address search');
				if(callback)
					callback(data);
			},
			error: function(error){
				if(callback)
					callback(null);
			}
		});
	};
	
	// initial setup
	self.init();
	
	return self;
})();

module.exports = Geolocation;