
(function() {

var _ = require('/lib/lodash')._,
	IcabbiAPI = require('core/IcabbiAPI');
var debug=false;

	
var Store = function(adapter) {
	this.adapter = adapter;
};

_.extend(Store.prototype, {

  create: function(model,options) {
debug && Ti.API.info('###############in store.create');
    this.storage().set(model,options);
    //return this.find(model);
  },

  // Update a model by replacing its copy in `this.data`.
  update: function(model,options) {
debug && Ti.API.info('###############in store.update');
    this.storage().update(model,options);
    //return this.find(model);
  },

  find: function(model,options) {
debug && Ti.API.info('###############in store.find');
    this.storage().get(model,options);
  },

  // Return the array of all models currently in storage.
  findAll: function(model,options) {
debug && Ti.API.info('###############in store.findAll');
  	this.storage().get(model,options);
  	/*
    return _(this.records).chain()
      .map(function(id){return this.jsonData(this.storage().getItem(this.endpoint+"-"+id));}, this)
      .compact()
      .value();
  */
  },

  // Delete a model from `this.data`, returning it.
  destroy: function(model,options) {
debug && Ti.API.info('###############in store.destroy');
    this.storage().remove(model,options);
    return model;
  },

  storage: function() {
  	return this.adapter;
  },
  
  // fix for "illegal access" error on Android when JSON.parse is passed null
  jsonData: function (data) {
      return data && JSON.parse(data);
  }

});

// Adapter
Store.Adapter = (function(){
	var self = {text:'hahahha'};
	
	self.AJAX=(function(){
		var adapter = {'type':'ajax','url':''};
		  var methodMap = {
			'create': 'POST',
			'update': 'POST',//'PUT',
			'patch':  'POST',//'PATCH',
			'delete': 'POST',//'DELETE',
			'read':   'GET'
		  };
		var urlError = function(){
			throw new Error('A "url" property or function must be specified');
		};
		var execute = function(method,model,options){
			var params = {type:methodMap[method],dataType:'json'};
debug && Ti.API.info('###############in adapter.execute.1');
debug && Ti.API.info('###############in adapter.execute.options: '+JSON.stringify(options));

			// Default options, unless specified.
			_.defaults(options || (options = {}), {
			  emulateJSON: true ,
			});		
debug && Ti.API.info('###############in adapter.execute.2');

			if (!options.url) {
			  params.url = _.result(model, 'url') || urlError();
			}
debug && Ti.API.info('###############in adapter.execute.3');
			
			// Ensure that we have the appropriate request data.
			if (options.data == null && model 
					&& (method === 'create' || method === 'update' || method === 'patch' || method === 'delete')) {
			  params.contentType = 'application/json';
			  params.data = JSON.stringify(options.attrs || model.toJSON(options));
			}
debug && Ti.API.info('###############in adapter.execute.4');
			// For older servers, emulate JSON by encoding the request into an HTML-form.
			if (options.emulateJSON) {
			  params.contentType = 'application/x-www-form-urlencoded';
			  var emulateJSONKey = options.emulateJSONKey ? options.emulateJSONKey : 'model';
			  if(params.data){
				var data = params.data;
				params.data = {};
				params.data[emulateJSONKey] = data;
			  }else{
				params.data = {};
			  }
			  // params.data = params.data ? {emulateJSONKey: params.data} : {};
			}
debug && Ti.API.info('###############in adapter.execute.5');

			_.extend(params, options);
		
debug && Ti.API.info('###############in adapter.execute.params: '+JSON.stringify(params));
			
			IcabbiAPI.remote(params.url,{
				data:params.data,
				method:params.type,
				cache : false,
				contentType:params.contentType ? params.contentType : null,
				success:function(resp){
					var resp = JSON.parse(resp);
debug && Ti.API.info('###############in adapter.execute.success.resp.code: '+resp.code);
					if(resp.code==IcabbiAPI.config.RESPONSE_CODES.OK && !resp.error){
						resp = resp.body;
					}else{
						options.error && options.error(resp);
						if(resp.code == IcabbiAPI.config.RESPONSE_CODES.TOKEN_INVALID ||
							resp.code==IcabbiAPI.config.RESPONSE_CODES.USERID_BANNED)
						{
							ICABBI.Controller.deauthenticate({'alert': false});
						}
						return;
					}
					options.success && options.success(resp);
				},
				error:function(e){
					options.error && options.error(e);
				}
			});
		};
		

		
		adapter.set = function(model,options){
Ti.API.info('###############in adapter.set');
			execute('create',model,options);
		};
		adapter.update = function(model,options){
Ti.API.info('###############in adapter.update');
			execute('update',model,options);
		};
		adapter.get = function(model,options){
Ti.API.info('###############in adapter.get');
			execute('read',model,options);
		};
		adapter.remove = function(model,options){
Ti.API.info('###############in adapter.remove');
			execute('delete',model,options);
		};
		return adapter;
	})();
	
	return self;
})();

// localSync delegate to the model or collection's
// *storage* property, which should be an instance of `Store`.
// window.Store.sync and Backbone.localSync is deprectated, use Backbone.storage.sync instead
Store.sync = function(method, model, options) {
  var store = model.storage || model.collection.storage;
		Ti.API.info('###############in store.sync');

  var resp, errorMessage; 

  try {

    switch (method) {
      case "read":
        resp = model.id != undefined ? store.find(model,options) : store.findAll(model,options);
        break;
      case "create":
        resp = store.create(model,options);
        break;
      case "update":
      case "patch":
        resp = store.update(model,options);
        break;
      case "delete":
        resp = store.destroy(model,options);
        break;
    }

  } catch(error) {
      errorMessage = error.message;
  }

  // if (resp) {
    // if (options && options.success)
      // options.success(model,resp,options);

  // } else {
    // errorMessage = errorMessage ? errorMessage
                                // : "Record Not Found";
    
    // if (options && options.error)
      // options.error(errorMessage);
  // }
  
  // add compatibility with $.ajax 
  // always execute callback for success and error
  // if (options && options.complete) 
	// options.complete(resp);

  return;
};

// // Backbone.ajaxSync = Backbone.sync;

// // Backbone.getSyncMethod = function(model) {
  // // if(model.storage || (model.collection && model.collection.storage)) {
    // // return Backbone.localSync;
  // // }

  // // return Backbone.ajaxSync;
// // };

// // // Override 'Backbone.sync' to default to localSync,
// // // the original 'Backbone.sync' is still available in 'Backbone.ajaxSync'
// // Backbone.sync = function(method, model, options) {
  // // return Backbone.getSyncMethod(model).apply(this, [method, model, options]);
// // };
module.exports = Store;
//return Store;
})();