//All application functionality is namespaced here
var tools = (function() {
	var self = {},
		osname = Ti.Platform.osname,
		locale = Ti.Platform.locale;


	self.guid = function(){
		// Generate four random hex digits.
/*
		var S4 = function(){
		   return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
		};
	   return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4()).toUpperCase();
*/
		return Ti.Platform.createUUID();
	}
	/*
		Branching logic based on locale
	*/
	self.locale = function(/*Object*/ map) {
		var def = map.def||null; //default function or value
		if (map[locale]) {
			if (typeof map[locale] == 'function') { return map[locale](); }
			else { return map[locale]; }
		}
		else {
			if (typeof def == 'function') { return def(); }
			else { return def; }
		}
	};

	/*
		Branching logic based on OS
	*/
	self.os = function(/*Object*/ map) {
		var def = map.def||null; //default function or value
		if (typeof map[osname] != 'undefined') {
			if (typeof map[osname] == 'function') { return map[osname](); }
			else { return map[osname]; }
		}
		else {
			if (typeof def == 'function') { return def(); }
			else { return def; }
		}
	};

	self.dbg = function(msg,delim){
		delim=delim||'>';
		var filler = new Array(15).join(delim);
		Ti.API.info(filler+' '+msg);
	};
	self.debug = function(msg,delim){
		delim=delim||'#';
		var filler = new Array(51).join(delim);
		Ti.API.info(filler);
		if(_.isObject(msg)){
			Ti.API.info(typeof msg);
			msg=JSON.stringify(msg);
		}
		Ti.API.info(msg);
		Ti.API.info(filler);
	};

	return self;
})();

module.exports = tools;