/**
 * @author Sonal
 */
(function(){
  var _ = require('/lib/lodash')._ ;
	
  var Model = require('/model/Model').Model,
		Collection = require('/model/Model').Collection,
		Store = require('/lib/Store');

//Model
  var AddressModel = Model.extend({
    // Default attributes
    defaults: {
      id		:'',
      src		: '',
      building	: '',
      street	: '',
      area	: '',
      formatted	: '',
      lat		: '',
      lng		: ''
    },
	isEmpty: function(){
		return this.get('formatted').length==0;
	},
    formatDisplay: function(showArea){
		showArea==void 0 && (showArea=false);
		var addr = this.get('formatted');
		if(showArea && this.get('area').length)
			addr+= ', '+this.get('area');
		return addr;
    },
	reset: function(options){
	  return this.set(this.defaults, options);
	},
    same: function(location){
    	return this.get('lat')===location.latitude
    			&& this.get('lng')===location.longitude;
    },
    sync: function(){
    	//method, model, options
    }

  });

  var AddressCollection = Collection.extend({
	model: AddressModel,
	url: 'address',
	storage: new Store(Store.Adapter.AJAX),
    sync: function(){
    	//method, model, options
    }

 });

  module.exports.Model = AddressModel;
  module.exports.Collection = AddressCollection;

})();
