/**
 * @author Sonal
 */

 (function(){
	var ICABBI;
	var _ = require('/lib/lodash')._ ,
		Model = require('/model/Model').Model,
		Collection = require('/model/Model').Collection,
		Store = require('/lib/Store');

	var sqlite = require('/lib/SQLiteManager'),
		media = require('/lib/MediaManager');
	// var mds = require('/model/MemoryDataStore');

	var Theme = require('/ui/Theme');
	var moment = require('/lib/moment');
//Model
  var BookingModel = Model.extend({
  
/*
{"code":"0","body":{"booking":{"id":242207,"perma_id":242207,"source":"ANDROIDAPP","distance":0.99758335182613,"eta":0,"date":"2013-05-16T01:04:53+00:00","name":"","address":{"id":"0","lat":"37.422005","lng":"-122.084095","formatted":"1600 Charleston Road, Mountain View, CA 94043, USA"},"destination":{"id":"0","lat":"37.414843","lng":"-122.086797","formatted":"Permanente Creek Trail, Mountain View, CA 94043, USA"},"vehicle_type":"1","instructions":"ggggg","status":"NEW","_object_type":"request","status_text":"Your taxi is scheduled for Thursday 16th May 2013, 02:04am"}},"warnings":[],"nonce":"A97637E6-98A4-BE0B-074A-A7E637BD05FC"}
*/
    // Default attributes
	idAttribute:'perma_id',
    defaults: {
		  // relativeid: 0,
		  //perma_id:0,
		  
		  date	: '', //2013-05-15T14:21:27+00:00
		  return_date: '', //2013-05-15T14:21:27+00:00
		  //time	: '',
		  now	: true,

		  name	: '', //set to loggedin user name
		  
		  //source: Ti.Android?'ANDROIDAPP':'IPHONEAPP',
		  source: 'APP',
		  
		  distance: '', //not using in mobileapp rt now
		  
		  address	: {src:'',area:'',formatted:'',lat:'',lng:''},
		  destination	: {src:'',area:'',formatted:'',lat:'',lng:''},
		  
		  vias : [],
		  
		  vehicle_type	: '', 
		  instructions: '', 

		  eta	: 0,//'12 Mins',
		  
		  driver	:{
				name:'',psv:'',lat:'',lng:'',
				vehicle	:{make:'',model:'',plate:'',reg:'',color:''}
			},

		  fixed		: 0,
		  live_eta	: 0,

		  status	: '', 
		  status_text	: '',
		  _object_type: 'booking',

		  locations: null,
		  createdat: '',
		  
			// account_type : ['CASH','CARD','INVOICE']
		  payment_type	: 'CASH',
		  // payment	:{
		  				// mode:'',
						// creditcard:{},
						// clientaccount:{},
						// cash:false
					// },

					
		  account_id: 0,
		  creditcard_id: 0,
		  order_id : 0,
		  fields:'',
		  
		  //dummy
		  feedback: {rating:'',text:''},
	      favourite	: false,
    },
	
	urlRoot: 'booking',
	storage: new Store(Store.Adapter.AJAX),
//	storage: new Store('booking.php',Store.Adapter.AJAX),

	
	initialize: function(){	
		this.on('change:status',this.handleStatusChange,this);
	},
	parse: function(resp,options){	
		var booking = (resp.hasOwnProperty('perma_id') && resp.hasOwnProperty('status'))?resp:resp.booking;
		// booking.address = _.extend(this.get('address'),booking.address);
		// booking.destination = _.extend(this.get('destination'),booking.destination);
		if(booking && booking.address && booking.address.formatted)
			booking.address.formatted = booking.address.formatted.replace(/&#39;/g,'\'');
		if(booking && booking.destination && booking.destination.formatted)
			booking.destination.formatted = booking.destination.formatted.replace(/&#39;/g,'\'');
		return booking;
	},

  	PAYMENT_MODES : {CASH:'CASH',CREDITCARD:'CARD',ACCOUNT:'INVOICE'},
	
	handleStatusChange: function(){
		var booking=this;

		if (!ICABBI) {
			ICABBI = require('/core/icabbi');
		}
		
/*
		if(booking.isFinished()) {
			var sound = media.sounds.status;
			
			// Open rate driver view
			var ChildWindow = require('/ui/common/ChildWindow'),
				RateDriverView = require('/ui/common/RateDriverView'),
				params = {
					content	: RateDriverView,
					header	: {visible:false},
					data:{
						booking: booking,
						modal: true,
					},
				};
		   var modal = new ChildWindow(params);
			modal.addEventListener('open',function(e){
				sound && sound.play();
				media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
				ICABBI.SlidingMenu.fireEvent('openview',{index:ICABBI.Config.show_map?0:1});
				ICABBI.Controller.trigger('mapview:change:mode',{mode:1});
				ICABBI.Controller.trigger('booking:complete',{perma_id:booking.get('perma_id')});
			});
		   ICABBI.navController.open(modal);
		}
*/
		
		if(!booking.isActive()){
			return;
		}
		
		/*
		var booking_details_displayed  = mds.getObject('booking_details',{perma_id:0}).perma_id;
		if(!!booking_details_displayed){
			media.sounds.status.play();
			media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
			return;
		}
		setTimeout(function(){
			if (!ICABBI) {
				ICABBI = require('/core/icabbi');
			}
			var ChildWindow = require('/ui/common/ChildWindow');
			var BookingDetailView = require('/ui/common/BookingDetailView');
			var config = {
					content:BookingDetailView,
					title:'Details',
					data:{booking:booking},
				};
			var modal = new ChildWindow(config);
			modal.open();
			modal.addEventListener('open',function(e){
				media.sounds.status.play();
				media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
			});
		},100);
		*/

		media.sounds.status.play();
		media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
	},
	
	stage: function(){
		var status=this.get('status');
		if('request'===this.get('_object_type')) 
			return 'SCHEDULED';
		if(!!~(['NEW','ASSIGN','BACKTOBASE','PAUSE','PAUSED','DRIVER_CANCELLED'].indexOf(status)))
			return 'DISPATCHED';
		if(!!~(['ENROUTE','FOLLOWON','WAIT','MADECONTACT','DROPPINGOFF'].indexOf(status)))
			return 'BOOKED';
		if(!!~(['NOSHOW','CUSTOMER_CANCELLED','DISPATCH_CANCELLED','COMPLETE','COMPLETED'].indexOf(status)))
			return 'FINISHED';
		if(!!~(['TRANSFERRED'].indexOf(status)))
			return 'TRANSFERRED';
			
		return status;
	},
	wasCancelled: function(){
		var status=this.get('status');
		return !!~(['NOSHOW','CUSTOMER_CANCELLED','DISPATCH_CANCELLED'].indexOf(status));
	},
	isScheduled: function(){
		return 'SCHEDULED'===this.stage();
	},
	isDispatched: function(){
		return !!~(['DISPATCHED'].indexOf(this.stage()));
	},
	isBooked: function(){
		return !!~(['BOOKED'].indexOf(this.stage()));
	},
	isActive: function(){
		return !!~(['DISPATCHED','BOOKED'].indexOf(this.stage()));
	},
	isFinished: function(){
		return !!~(['FINISHED','TRANSFERRED'].indexOf(this.stage()));
	},
	isCancellable: function(){
		var status=this.get('status');
		var stage = this.stage();
		
		if(stage){
			if (stage === 'BOOKED') {
				return !!~(['ENROUTE','FOLLOWON','WAIT'].indexOf(status));
			} else {
				return !!~(['SCHEDULED','DISPATCHED'].indexOf(stage));
			}
		}else{
			return !!~(['completed','cancelled','error'].indexOf(this.get('status_text').toLowerCase())) ;
		}
		
	},
	
	setPayment: function(mode,data){
		this.set('payment_type',mode);
		data===void 0 && (data={});
		
		if(this.PAYMENT_MODES.CASH == mode){
			this.set({fields:data,account_id: 0,creditcard_id: 0},{silent:1});
		}
		else if(this.PAYMENT_MODES.CREDITCARD == mode){
			this.set({fields:data},{silent:1});
		}
		else if(this.PAYMENT_MODES.ACCOUNT== mode){
			this.set({fields:data,creditcard_id: 0},{silent:1});
		}
	},
	
	setFeedback: function(feedback,options){
		// this.set('feedback',feedback);
		setTimeout(function(){
			options.success && options.success();
		},1000);
	},
	formatDateLocaleDisplay: function(){
		if (!ICABBI) {
			ICABBI = require('/core/icabbi');
		}
		
		var d = new Date(this.get('date'));
		
		return {
			date: moment(d).format(ICABBI.Config.formatDate),
			time: moment(d).format(ICABBI.Config.formatTime)
		};
	},
	formatShortDateLocaleDisplay: function(){
		if (!ICABBI) {
			ICABBI = require('/core/icabbi');
		}
		
		var d = new Date(this.get('date'));
		
		return {
			date: moment(d).format(ICABBI.Config.formatShortDate),
			time: moment(d).format(ICABBI.Config.formatShortTime)
		};
	},
	
    formatAddressDisplay: function(address,showArea){
		address = address||'address';
		showArea==void 0 && (showArea=false);
		var address = this.get(address);
    	return address.formatDisplay(showArea);
    },
/*	
	bookCheck: function(options){
		if (!ICABBI) {
			ICABBI = require('/core/icabbi');
		}
		IcabbiAPI.remote('bookings/check',{
			method:'POST',
			data:{booking:JSON.stringify(this.toJSON())}
			success:function(e){
				var booking  = JSON.parse(e).body.booking;
			}
		});
	},
*/	
	//not used
	syncStatus: function(options){
		var booking=this;
		this.fetch({
			url:'bookings/view/'+this.get('perma_id'),
			data:{
				_object_type:options.object_type||this.get('_object_type'),
				locations:typeof options.locations!=='undefined'?options.locations:false
			},
			success: function(model){
				options.success && options.success();
			}
		});
	},
	
	manageFavourite: function(){
		var fav = this.get('favourite');
		//insert into sqlite 
		sqlite.manageFavourite(this.get('perma_id'),!!fav);
	}
	
  },
  {
//  	PAYMENT_MODES : {CASH:'cash',CARD:'card',ACCOUNT:'acc'}
  });

//Collection
  var BookingCollection = Collection.extend({
	model: BookingModel,
	url: 'bookings',
	storage: new Store(Store.Adapter.AJAX),
	cancelledBookings : [],
	
	initialize: function(models,options){
		this.once('sync:active',function(){
			this.on('add',this.handleAdd,this);
			this.on('remove',this.handleRemove,this);
		});
		this.once('sync:upcoming',function(){
			this.on('remove',this.handleRemove,this);
		});
	},
	parse: function(resp,options){	
		return resp.bookings;
	},
	handleAdd: function(booking){
/*
		if (!ICABBI) {
			ICABBI = require('/core/icabbi');
		}
		var booking_details_displayed  = mds.getObject('booking_details',{perma_id:0}).perma_id;
		if(!booking.isActive() || !!booking_details_displayed){
			return;
		}
		setTimeout(function(){
			var ChildWindow = require('/ui/common/ChildWindow');
			var BookingDetailView = require('/ui/common/BookingDetailView');
			var config = {
					content:BookingDetailView,
					title:'Booking Details',
					data:{booking:booking},
				};
			var modal = new ChildWindow(config);
			modal.addEventListener('open',function(e){
				media.sounds.status.play();
				media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
			});
			ICABBI.navController.open(modal);
		},13);		
*/
	},
	addCancelledBooking : function(perma_id){
		this.cancelledBookings.push(perma_id.toString());
	},
	handleRemove: function(booking){
		if(!booking.isActive() && !booking.isScheduled()){
			return;
		}
		if (!ICABBI) {
			ICABBI = require('/core/icabbi');
		}
		var self = this;
		booking.syncStatus({
			object_type:'archive',
			success: function(){
				if(booking.isFinished()){
					
					var status=booking.get('status'),
						content = [],
						sound;
					if(!!~(['COMPLETE','COMPLETED'].indexOf(status))){
						
						// Open rate driver view
						var ChildWindow = require('/ui/common/ChildWindow'),
							RateDriverView = require('/ui/common/RateDriverView'),
							params = {
								content	: RateDriverView,
								header	: {visible:false},
								data:{
									booking: booking,
									modal: true,
								},
							};							
					   var modal = new ChildWindow(params);
						modal.addEventListener('open',function(e){
							media.sounds.status.play();
							media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
							ICABBI.SlidingMenu.fireEvent('openview',{index:ICABBI.Config.show_map?0:1});
							ICABBI.Controller.trigger('mapview:change:mode',{mode:1});
							ICABBI.Controller.trigger('booking:complete',{perma_id:booking.get('perma_id')});
						});
					   ICABBI.navController.open(modal);
/*
						content.push('Job completed. Thank you for travelling with '+ICABBI.Config.Company.name);
						sound = media.sounds.status;
*/
					}
					else if(!!~(['NOSHOW'].indexOf(status))){
						content.push('Your driver has marked the booking from '+booking.get('address').formatted+' as a No Show');
						content.push('Please make sure you are at the designated pickup point.');
						sound = media.sounds.noshow;
					}
					else {
						var perma_id = booking.get('perma_id').toString();
						
						var idx = self.cancelledBookings.indexOf(perma_id);
						
						if(idx === -1 ) {
							var msg = 'Your booking from ' + booking.get('address').formatted;
							
							if(booking.get('destination').formatted) {
								msg += ' to ' + booking.get('destination').formatted;
							}
							if(booking.get('now')) {
								msg += ' scheduled now';
							}
							else {
								var bookingDate = booking.formatDateLocaleDisplay();
								msg += ' scheduled on ' + bookingDate.date;
							}							
							msg += ', has been cancelled';
						
							content.push(msg);
						}
						else {
							self.cancelledBookings.splice(idx, 1);
						}
						sound = media.sounds.status;
							
					}
					if(content.length > 0)
					{
						var ChildWindow = require('/ui/common/ChildWindow'),
							PromptView = require('/ui/common/PromptView'),
							params = {
								content	: PromptView,
								header	: {visible:true,controls:{close:{visible:true}}},
								title:'Booking Cancelled',
								data:{
									message:content,
									modal:true,
								},
							};
					   var modal = new ChildWindow(params);
						modal.addEventListener('open',function(e){
							sound && sound.play();
							media.vibrate([ 0, 500, 100, 500, 100, 500 ]);
							ICABBI.SlidingMenu.fireEvent('openview',{index:ICABBI.Config.show_map?0:1});
							ICABBI.Controller.trigger('mapview:reset');
							ICABBI.Controller.trigger('booking:complete',{perma_id:booking.get('perma_id')});
						});
					   ICABBI.navController.open(modal);
				  }
				}
			}
		});
	},
	fetchActive: function(options){
		this.fetch({
			url:'bookings/active',
			add:true,
			merge:true,
			remove:true,
			success: function(collection,resp){
				options.success && options.success(collection,resp);
			},
			error: function(collection,resp){
				options.error && options.error(collection,resp);
			}
		});
	},
	fetchUpcoming: function(options){
		this.fetch({
			url:'bookings/upcoming',
			add:true,
			merge:true,
			remove:true,
			success: function(collection,resp){
				options.success && options.success(collection,resp);
			},
			error: function(collection,resp){
				options.error && options.error(collection,resp);
			}
		});
	},
	fetchPrevious: function(options){
		this.fetch({
			url:'bookings/history',
			add:true,
			merge:true,
			remove:true,
			success: function(collection,resp){
				options.success && options.success(collection,resp);
			},
			error: function(collection,resp){
				options.error && options.error(collection,resp);
			}
		});
	},
	
/*
	fetchFavourites: function(){
		var favourites_ids = sqlite.getFavourites();		
		var favourites=[];
		if(!favourites_ids.length){
			return favourites;
		}
		this.each(function(booking){
			if(!!~favourites_ids.indexOf(Number(booking.get('perma_id')))){
				favourites.push(booking);
			}
		});
		return favourites;
	},
*/
  });
  
  module.exports.Model = BookingModel;
  module.exports.Collection = BookingCollection;
})();
