/**
 * @author Sonal
 */
(function(){
	var _ = require('/lib/lodash')._ ;
	
	var Model = require('/model/Model').Model;
	var Collection = require('/model/Model').Collection;
	var Store = require('/lib/Store');

//Model
	var CreditCardModel = Model.extend({
    	defaults: {
			id: '',
			nickname: '',
			provider: ''
		},
		urlRoot: 'creditcards',
		storage: new Store(Store.Adapter.AJAX),
		parse: function(resp, options){	
			var creditcard = resp.hasOwnProperty('nickname') ? resp : resp.creditcard;
			return creditcard;
		},
	});

	//Collection
	var CreditCardCollection = Collection.extend({
		model: CreditCardModel,
		url: 'credicard/index',
		storage: new Store(Store.Adapter.AJAX),
		parse: function(resp,options){	
			return resp.creditcards;
		}
	});
  
	module.exports.Model = CreditCardModel;
	module.exports.Collection = CreditCardCollection;
})();
