/**
 * @author florin
 */

var Theme = require('/ui/Theme');

function view(args) {
	return Ti.UI.createView(args);
}

function label(args) {
	return Ti.UI.createLabel(args);
}

function image(args) {
	return Ti.UI.createImageView(args);
}

function window(args) {
	return Ti.UI.createWindow(args);
}

function button(args, onclick) {
	return btn = Ti.UI.createButton(args);
	btn.addEventListener('click', onclick);
	return btn;
}

function RatingView(initialRating, max) {
	//create and populate the rating object
	var instance = view({
		layout:'horizontal',
		height:48,
		width: Ti.UI.SIZE,
	});
	
	instance.rating;
	var stars = [];
	
	for (var i=0; i < max; i++) {
		var star = image({
			height: 48,
			width: 46,
			left: 5,
		});
		
		(function() {
			var index = i;
			star.addEventListener('click', function () {
				setRating(index+1);
			});
		})();
		stars.push(star);
		instance.add(star);
	}

	function setRating(newRating) {
		instance.rating = newRating;
		for (var i=0, l = stars.length; i < l; i++) {
			if (i >= instance.rating) {
				stars[i].image = 'images/rating/rating_off.png';
			}
			/*
			// Half star rating
			else if (rating > i && rating < i+1) {
				stars[i].image = 'images/rating/star_rating_half.png';
			}
			*/			
			else {
				stars[i].image = 'images/rating/rating_on.png';
			}
		}
	}
	
	setRating(initialRating);
	return instance;
};

function RatingComment() {

	var instance = view({
		width: Ti.UI.FILL,
	});

	// rating comment
	instance.textArea = Ti.UI.createTextArea({
		left:12,
		right:12,
		top:0,
		bottom:0,
		backgroundColor:Theme.form.inputBGColor,
		borderRadius:10,
		color:Theme.global.fontColor,
		font:Theme.menu.rowFont,
		minimumFontSize:Theme.menu.rowFont.fontSize,
		returnKeyType:Ti.UI.RETURNKEY_DONE,
        softKeyboardOnFocus: Ti.Android ? Titanium.UI.Android.SOFT_KEYBOARD_DEFAULT_ON_FOCUS : undefined,
		zIndex:10,
	});
	instance.add(instance.textArea);
	
	if(Ti.Android) {
		instance.textArea.setHintText('Add a comment');
	}
	else {
		// Hiht text not supported on iphone
		var hint = Ti.UI.createLabel({
			left:22,
			right:15,
			top:10,
			height:Ti.UI.SIZE,
			color:Theme.global.fontColor,
			font:Theme.form.helpFont,
			text:'Add a comment',
			touchEnabled:false,
			zIndex:20,
		});
		instance.add(hint);
		
		instance.textArea.addEventListener('focus',function(){
			hint.visible = false;
		});
		
		instance.textArea.addEventListener('blur',function() {
			var value = instance.textArea.value.trim();
			instance.textArea.setValue(value);
			hint.visible = !value.length;
		});
	}
	
	
	
	
	

	instance.hideKeybord = function(){
		instance.textArea.blur();
	};
	
	return instance;
};

// Public Module API
exports.RatingView = RatingView;
exports.RatingComment = RatingComment;
exports.view = view;
exports.label = label;
exports.image = image;
exports.button = button;