// global stuff
var highlightColor = '#7fb415',
	highlightRowColor = '#ffffcc',
	highlightLightColor = '#d0e991';

var Theme = {
	// CONST
	ANTIMATE_TYPE_HIGHLIGHT:'highlight',
	ANTIMATE_TYPE_OPACITY:'opacity',

	// global styles
	global:{
		highlightColor:highlightColor,
		highlightRowColor:highlightRowColor,
		highlightLightColor:highlightLightColor,
		bgColor:'#fff',
		altBGColor:'#666',
		fontColor:'#000',
		fontColorInverted:'#fff',
		listTopLineColor:'#fff',
		listBottomLineColor:'#cacaca',
		//buttonBGColor:'#dde9eae8', // aarrggbb
		buttonBGColor:'#dddddd',
		buttonFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:12,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		font:{
			fontFamily:'HelveticaNeue',
			fontSize:16,
		},
		smallFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:12,
		},
		backgroundSelected:'#B1D170',
	},
	// nav styles
	nav:{
		backgroundColor:'#dddddd',
		seperatorColor:'#cacaca',
		headerColor:'#000',
		headerFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		bgInactive:'#000000',
		buttonInactiveColor:'#FFFFFF',
		buttonColor:highlightColor,
		buttonColorAlt:'#fff',
		buttonFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:18,
		},
	},
	// menu styles
	menu:{
		headerColor:'#fff',
		rowFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:18,
		},
		rowFontSmall:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:14,
		},
	},
	// sections styles
	section:{
		titleColor:'#000',
		titleFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:16,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	},
	// form styles
	form:{
		smallColor:'#999999',
		smallFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:14,
		},
		labelColor:'#8F8F8F',
		labelFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:14,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		creditCards:[
			'/images/cards/visa.png',
			'/images/cards/maestro.png',
			'/images/cards/mastercard.png',
			'/images/cards/amex.png',
		],
		smallLinkFont:{
			fontFamily:'HelveticaNeue',
			fontSize:14,
		},
		helpFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_LtIt':'HelveticaNeue-LightItalic',
			fontSize:14,
		},
		buttonFont:{
			fontFamily:'HelveticaNeue',
			fontSize:16,
		},
		inputBGColor:'#dedede',
	},
	// map screen
	map:{
		overlayBGColor:'#ffffff', // aarrggbb
		smallColor:'#5d5d5d',
		smallFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:12,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		timeColor:'#f7d101',
		timeFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:30,
		},
		infoColor:'#000',
		infoFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		addressFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:14,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		buttonFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:17,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	},
	footer: {
		footerFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:9,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	},
	tour: {
		titleFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:24,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		subtitleFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:18,
		},
		maintextFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Lt':'HelveticaNeue-Light',
			fontSize:18,
		},
		mainTextColor:'#999',		
	},
	// address search screen
	address:{
		addressFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:15,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		subaddressFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:12,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		bgColor:'#f2f2f2',
	},
	// child window
	childwindow:{
		headerHeight:48,
		bgColor:'#ddd',
		borderColor:'#999',
		headerColor:'#000',
		buttonTextColor:'#fff',
		headerFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		headerButtonFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:12,
			fontWeight:Ti.Android ? 'bold':undefined,
		}
	},
	// child window
	bookingReview:{
		totalPriceLabel:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		totalPriceSmallLabel:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:10,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		totalPrice:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:36,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		estimatedPrice:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:36,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		farePrice:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:24,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	},
	// vehicle type
	vehicleType:{
		titleFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:16,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		attrFont:{
			fontFamily:'HelveticaNeue',
			fontSize:15,
		},
		timesFont:{
			fontFamily:'HelveticaNeue',
			fontSize:10,
		},
	},
	// button helper
	animateButton:function(self) {
		self.animateType = self.animateType||Theme.ANTIMATE_TYPE_HIGHLIGHT;
		
		var normal;
		
		// iOS style click animation
		if (self.animateType === Theme.ANTIMATE_TYPE_OPACITY) {
			self.addEventListener('touchstart',function(){
				self.opacity = 0.6;
			});
			
			normal = function() {
				self.opacity = 1;
			};
		}

		// blast the UI with highlights
		if (self.animateType === Theme.ANTIMATE_TYPE_HIGHLIGHT) {
			var originalBGColor = self.backgroundColor||'transparent';
			var highlightBGColor = Theme.makeTranslucentColor(Theme.global.highlightColor);
			
			self.addEventListener('touchstart',function(){
				self.backgroundColor = highlightBGColor;
			});
			
			normal = function() {
				self.backgroundColor = originalBGColor;
			};
		}
		
		if (Ti.Android) {
			self.addEventListener('touchend',function(){
				setTimeout(normal,500);
			});
			self.addEventListener('touchcancel',function(){
				setTimeout(normal,500);
			});
		} else {
			self.addEventListener('touchend',normal);
			self.addEventListener('touchcancel',normal);
		}
	},
	makeTranslucentColor:function(color){
		var highlightBGColor = color;
		
		if (highlightBGColor.length === 4) {
			highlightBGColor = highlightBGColor.replace(/^#/,'#9');
		} else if (highlightBGColor.length === 7) {
			highlightBGColor = highlightBGColor.replace(/^#/,'#99');
		} else if (highlightBGColor.length === 9) {
			highlightBGColor = highlightBGColor.replace(/^#[0-9a-fA-F]{2}/,'#99');
		}
		
		return highlightBGColor;
	},
	bookingMapView:{
		headerFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:13,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	},
	picker:{
		backgroundColor:'#fff',
		footerBackgroundColor:'#dddddd',
		titleFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:15,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		subtitleFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:12,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		rowSeparator : '#cacaca',
		rowBackgroundColor:'#f8f8f8',
		sectionBackgroundColor:'#C6C6C6',
	},
	bookingForm:{
		headerColor:'#000',
		headerFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		labelColor:'#8F8F8F',
		labelFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:13,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	},
	fleetSelect : {
		buttonTextColor:'#000',
		buttonFont:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
		fontColor:'#000',
		font:{
			fontFamily:Ti.Android ? 'HelveticaNeue_Bld':'HelveticaNeue-Bold',
			fontSize:18,
			fontWeight:Ti.Android ? 'bold':undefined,
		},
	}
};

module.exports = Theme;
