var Theme = require('/ui/Theme');

var ActionButton = function(args){
	var self = Ti.UI.createView({
		height:65,
		width:65,
		backgroundColor:Theme.global.buttonBGColor,
		borderColor:Theme.global.highlightColor,
		borderWidth:1,
		borderRadius:8,
	});
	
	var icon = Ti.UI.createImageView({
		top:4,
		height:41,
		width:41,
		image:args.icon,
		touchEnabled:false,
	});
	self.add(icon);
	
	var label = Ti.UI.createLabel({
		bottom:0,
		height:29,
		left:0,
		right:0,
		color:Theme.global.fontColor,
		font:Theme.global.buttonFont,
		text:args.title,
		textAlign:'center',
		touchEnabled:false,
	});
	self.add(label);
	
	Theme.animateButton(self);
	
	if(args.blinkIcon) {
		var blinkActive = false;
		setInterval(function() {
			icon.image = blinkActive ? args.icon : args.blinkIcon;
			self.backgroundColor = blinkActive ? Theme.global.buttonBGColor : Theme.global.highlightColor;
			label.color = blinkActive ? Theme.global.fontColor : Theme.global.fontColorInverted;
			blinkActive = !blinkActive;
		}, 1500);
	}
	
	return self;
};

module.exports = ActionButton;
