/**
 * @author Sonal
 * AppSettingsView.js
 */
var ICABBI = require('/core/icabbi');
var _ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

//auto_fav_booking

//AppSettingsView Component Constructor
var AppSettingsView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			title:'Settings',
		};
	options = _.extend(defaults,options.data||{});

	var platformWidth = ICABBI.width;
	var table;
	var checkboxImages = {on:'/images/switch_on.png',off:'/images/switch_off.png'};
	var appsettings = ICABBI.Controller.getUser().appsettings; 

	var createLabel = function(options){
		var label = Ti.UI.createLabel($$.styl('label',{
			    height:Ti.UI.FILL,
			    left:0,
			    width:80,//Ti.UI.FILL
		  	    font: {fontSize:18,fontWeight:'bold'}
			},options)
		);
		return label;
	};
	
	var createTableViewRow = function(appsetting){
		var row = Titanium.UI.createTableViewRow({
			top:4,
	        height: 50,
	        width: Ti.UI.FILL,
			backgroundColor:'transparent',
			//rowData: {},
			__appsetting: appsetting.get('id')
	    });

		var btnCheckbox = Ti.UI.createButton({
			left:10,
			height: Ti.UI.SIZE,
			width: Ti.UI.SIZE,
			backgroundColor : 'transparent',
			image:appsetting.get('value') ? checkboxImages.on : checkboxImages.off,
			checked: appsetting.get('value'),
		});
		row.add(btnCheckbox);
		//click handler
		btnCheckbox.addEventListener('click',function(e){
			var currentVal = e.source.checked;
			e.source.checked = !currentVal;  
			var newImg = currentVal ? checkboxImages.off : checkboxImages.on;
			btnCheckbox.setImage(newImg);
			//update
			appsetting.set('value',e.source.checked);
			ICABBI.Controller.updateAppSetting(appsetting);
		});

		
	 	var lblContent = createLabel({
			left:70,
		 	text:appsetting.get('title'),
		 	height:Ti.UI.FILL, 
		 	width:Ti.UI.FILL,
	 	});
		row.add(lblContent);
 
	    return row;
	};

	var createTableView = function(title){
		var table = Ti.UI.createTableView({
			//backgroundImage:'/images/table_bg.png',
			separatorStyle:Ti.Android ? 0 : Ti.UI.iPhone.TableViewSeparatorStyle.NONE,
			top:10,
			left:0,
			width: Ti.UI.FILL,
			height: Ti.UI.SIZE,
			//separatorColor: '#FFFFFFF',
		   // backgroundColor: '#FFFFFF'
		});
		return table;
	};

	var create = function(){
		var content = Ti.UI.createView({
			backgroundColor: 'transparent',
		    borderColor:'#CCC',
		    borderWidth:0,
			width:'98%',
			//height: '99%',
			layout:'vertical'
		});
		var scroll = Ti.UI.createScrollView({
		    contentWidth:'auto',//Ti.UI.FILL,
		    contentHeight:'auto',//Ti.UI.FILL,
		    showVerticalScrollIndicator:false,
		    showHorizontalScrollIndicator:false,
		    top:0,
		    left:0,
		    scrollType: 'vertical',
		    layout:'vertical'
		});
		
		table = createTableView('Active');
		scroll.add(table);
		
		content.add(scroll);
		return content;
	};


 	var self = create();

	(function(){

		//table click action handler
		table.addEventListener('click',function(e){
			var row = e.row;
			var rowIndex = e.index;
			var appsetting= appsettings.get(row.__appsetting);
			
			///TODO: save
		});

		//changing Collection:reset to this as that was blocking UI
		//may have scope for further optimization or another way
		var datafetched=false;
		var populate = function(){
			self.addEventListener('slidingmenu:view:load',function(e){
				self.removeEventListener('slidingmenu:view:load',arguments.callee);
				var populate = function(callback){
					setTimeout(function(){
						$$.ActivityIndicator.start('Getting Your Settings');
						appsettings.each(function(appsetting){ 
							Ti.API.info('###############AppSettingsView [reset] appsetting: '+appsetting.get('id'));
							table.appendRow(createTableViewRow(appsetting));
						}); //each
						$$.ActivityIndicator.stop();
					},13);
				};
				if(datafetched) populate();
				else appsettings.once('fetched',function(e){datafetched=true;populate();});
			});
		};
		populate();
		//if appsettings are fetched before viewload
		appsettings.on('fetched',function(e){
			datafetched=true;
		});
		appsettings.on('cleared',function(e){
			datafetched=false;
			if(table && table.data && table.data.length){
				table.deleteSection(0);
			}
			populate();
		});


	/*
		//populate
		appsettings.on('reset',function(e){
			if(table && table.data && table.data.length){
				table.deleteSection(0);
			}
			setTimeout(function(){
				appsettings.each(function(appsetting){ 
	 				Ti.API.info('###############AppSettingsView [reset] appsetting: '+appsetting.get('id'));
					table.appendRow(createTableViewRow(appsetting));
				}); //each
			},13);
		});
*/
		//add
		appsettings.add('add',function(e){
			Ti.API.info('###############AppSettingsView [ADD] appsetting: '+appsetting.get('id'));
			table.appendRow(createTableViewRow(appsetting));
		});

	})();


	return self;
};

module.exports = AppSettingsView;
