/**
 * @author Sonal 
 */

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

//BookingCancelView Component Constructor
var BookingCancelView = function(options) {
	options = options || {};
	
	var createLabel = function(options){
		var label = Ti.UI.createLabel($$.styl('label','Modal.label',{
		    height:Ti.UI.FILL,
		    left:0,
		    width:80,//Ti.UI.FILL
	  	    font:{fontSize:14,fontWeight:'bold'},
		},options)
		);
		return label;
	};

	var createContent = function(){
		var rect;
		var action = '';

		//create object instance, a parasitic subclass of Observable
		var view = Titanium.UI.createView({
	        height:options.height || Ti.UI.FILL,
	        width:options.width || Ti.UI.FILL,
			layout:'vertical'
	    });

		view.add(createLabel({
			text:'Are you sure you want to cancel this booking?',
		    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		    width:Ti.UI.FILL,
			height: Ti.UI.SIZE,
			font:{fontSize:20,fontWeight:'bold'}
		}));

		/*
		 * Control button
		 */		
		var createButton = function(options){
			var btnWidth=130;
			var btn = Ti.UI.createButton($$.styl('Modal.button',{
				title: '',
				left:10,
				height: 40,
				width: btnWidth,
		  	    font:{fontSize:14,fontWeight:'bold'},
			},options||{}));
			$$.animateButton(btn);
			return btn;
		};

		var controlBar = Titanium.UI.createView({
	        height: 60,
	        width: Ti.UI.SIZE,
	        top:20,
			layout:'horizontal'
	    });
  		view.add(controlBar);

		var btnYes = createButton({title:'Yes, cancel taxi',left:0});
		controlBar.add(btnYes);
		var btnNo = createButton({title:'No, don\'t cancel',left:10});
		controlBar.add(btnNo);

		var closeParent = function(action){
			if(options.parent.window){
				options.parent.window.__retval = action;
				ICABBI.navController.close(options.parent.window);
			}
		};
		btnYes.addEventListener('click',function(e){
			closeParent('yes');
		});
		btnNo.addEventListener('click',function(e){
			closeParent('no');
		});
		

		return view;
	}; 
	
	var self = createContent();
	return self;
};

module.exports = BookingCancelView;
