var	ICABBI = require('/core/icabbi'),
	ChildWindow = require('/ui/common/ChildWindow');

var SlidingView = require('/ui/common/SlidingView'),
	tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	mds = require('/model/MemoryDataStore'),
	$$ = require('/core/ThemeManager'),
	Booking = require('/model/Booking'),
	Address = require('/model/Address'),
	VehicleType = require('/model/VehicleType'),
	MapControl = require('/lib/MapControl');

var Theme = require('/ui/Theme');
var ActionButton = require('/ui/common/ActionButton');
var FormPickerRow = require('/ui/common/FormPickerRow');
var FormTextareaRow = require('/ui/common/FormTextareaRow');
var CheckboxView = require('/ui/common/CheckboxView');
var HeaderButton = require('/ui/common/HeaderButton');
var FormViaRow = require('/ui/common/FormViaRow');


var createRow = function(args){
		
		var self = Ti.UI.createView({
			left:8,
			right:8,
			height:54,
			value:args.value,
		});
		
		var label = Ti.UI.createLabel({
			left:0,
			height:21,
			width:45,
			color:Theme.form.labelColor,
			font:Theme.form.labelFont,
			text:args.label,
			textAlign:'right',
			touchEnabled:false,
		});
		self.add(label);
		
		var hint = Ti.UI.createLabel({
			//left: args.predefinedValues ? 95 : 70,ß
			left:82,
			right:0,
			height:Ti.UI.SIZE,
			color:Theme.global.fontColor,
			font:Theme.form.helpFont,
			value:args.hint,
			text:args.hint,
			touchEnabled:false,
			visible:!self.value.length,
			zIndex:20,
		});
		self.add(hint);
		
		var input = Ti.UI.createTextField({
			left:72,
			right:0,
			backgroundColor:'transparent',
			borderColor:'transparent',
			color:Theme.global.fontColor,
			font:Theme.menu.rowFont,
			paddingLeft:10,
			paddingRight:10,
			//hintText:args.hint,
			value:self.value,
			// keyboard stuff
			clearButtonMode:args.clearButtonMode,
			clearOnEdit:args.clearOnEdit,
			keyboardType:args.keyboardType,
			keyboardToolbar:args.keyboardToolbar,
			passwordMask:args.passwordMask,
			returnKeyType:args.returnKeyType,
			autocapitalization:args.autocapitalization,
			autocorrect:args.autocorrect,
		});
		input.addEventListener('focus',function(){
			hint.visible = false;
		});
		input.addEventListener('change',function(e){
			self.value = e.value;
			hint.visible = !self.value.length;
			hint.setLeft(82);
		});
		input.addEventListener('blur',function() {
			var value = self.value;
			hint.visible = !value.length;
			hint.setLeft(82);
		});
		self.putText = function(args){
			input.value = args.value;
			self.value = args.value;
			hint.visible = !self.value.length;
			hint.setLeft(82);
		};
		self.add(input);
		var pencilIcon = Ti.UI.createImageView({
		    height:15,
		    width:15,
		    left: 60,
		    image:'/images/map/btn_pencil_noborder.png',
		    touchEnabled:false,
		});
		self.add(pencilIcon);
		self.done = function(){
			input.blur();
		};
				
		var rowLine = Ti.UI.createView({
			left:args.label.length?60:0,
			right:0,
			bottom:0,
			height:1,
			backgroundColor:Theme.global.listBottomLineColor,
			visible:!args.lastItem,
			touchEnabled:false,
		});
		self.add(rowLine);
		
		var rowLineTop = Ti.UI.createView({
			left:args.label.length?60:0,
			right:0,
			top:0,
			height:1,
			backgroundColor:Theme.global.listTopLineColor,
			visible:!args.firstItem,
			touchEnabled:false,
		});
		self.add(rowLineTop);
		
		if(!args.readonly && !args.inline)
			Theme.animateButton(self);
		
		return self;
	};

//BookingEditView Component Constructor
var BookingEditView = function(options) {
	
	var header;
	var footer;
	var headerHeight = 48,
		footerHeight = 81,
		btnSlideMenu,
		btnBackMenu,
		currentETA=30,
		typeRow,
		timeRow,
		noteRow,
		view,
		lblError, 
		viaRow,
		screenTitle,
		statuxBox,
		nameRow,
		phoneRow,
		singleCheck,
		returnCheck;

	options = options || { data : {}};
	var bookingData = options.bookingData ? options.bookingData : options.data.bookingData;
//		btnFavourite = options.data.__headerButtons[0],
	
	bookingData.booking.set('name',ICABBI.Controller.getUser().get('name'));
	var	vehicleType = new VehicleType.Model(bookingData.booking.get('vehicle_type'));
	
	var defaultVehicle = function() {
		var vehicleTypes = ICABBI.Controller.getMeta().vehicleTypes;
		// if (!vehicleTypes.length) {
			// setTimeout(defaultVehicle,1000);
			// return;
		// }
		var vt = vehicleTypes.at(0);
		if(vt)
			vehicleType.set(vt.toJSON());
		bookingData.booking.set('vehicle_type',vehicleType.toJSON());
	};
	
	if(bookingData.booking.get('vehicle_type')==='') {
		defaultVehicle();
	}

	// var appsettings = ICABBI.Controller.getUser().appsettings,
		// auto_fav_booking = appsettings.get('auto_fav_booking'); 
	var auto_fav_booking = false;

	if(auto_fav_booking && auto_fav_booking.get('value')){
		bookingData.booking.set('favourite',true);
	}
	
	var createForm = function(reset){
		
		//create object instance, a parasitic subclass of Observable
		var parentView = reset;
		
		if(!reset)
			parentView = new SlidingView({
		        left:0,
				right:0,
				top:0,
				height:Ti.UI.FILL,
				bottom:0,
				opacity:1, //dont remove			
		    });

		var mainview = Ti.UI.createView({
			top:0,
			left:0,
			right:0,
			bottom:0,
		    /*backgroundGradient: {
		        type: 'linear',
		        startPoint: { x: '50%', y: '0%' },
		        endPoint: { x: '50%', y: '100%' },
		        colors: [ { color: 'white', offset: 0.0}, { color: '#f1f1f1', offset: 1.0 } ],
		    },*/
		   backgroundColor:'#f1f1f1',
		});
		
		var backAction = false;
		if(ICABBI.Config.show_map) {
			backAction = function(e){
				noteRow.hideKeybord();
				nameRow.done();
				phoneRow.done();
				
				if(ICABBI.Config.show_map) {
					ICABBI.SlidingMenu.fireEvent('openview',{index:0});
					return false;
				}
				return true;
			};
			
			parentView.onBackPressed = backAction;
		}
		
		header = createHeader(backAction);
		mainview.add(header);
		
		view =  Ti.UI.createScrollView({
				scrollType:'vertical',
		        bottom:footerHeight,
		        top:headerHeight,
		        layout:'vertical',
			});
			
	    mainview.add(view);
	    
		var footerBg = Ti.UI.createView({
			bottom:0,
			left:0,
			right:0,
			height: footerHeight,
			backgroundColor: 'black',
			opacity: 0.10,
		});

		mainview.add(footerBg);

		var footer = Ti.UI.createView({
			bottom:0,
			left:0,
			right:0,
			height: footerHeight,
			
			//zIndex: 11,
		});

		var footerBorderGray = Ti.UI.createView({
			top: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.listBottomLineColor,
		});
		footer.add(footerBorderGray);
		
		var footerBorderWhite = Ti.UI.createView({
			top: 1,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.listTopLineColor,
		});
		footer.add(footerBorderWhite);

		var controlBar = Ti.UI.createView({
	        height:65,
	        width:Ti.UI.SIZE,
	        layout:'horizontal',
	        top: 9,
	    });
	    footer.add(controlBar);

		var btnPayCash = null;
		if(!ICABBI.Config.disable_cash_payment) {
			btnPayCash = new ActionButton({title:'CASH',icon:'/images/buttons/icon_cash.png'});
			controlBar.add(btnPayCash);
		}

		var btnPayCreditCard = new ActionButton({title:'CARD',icon:'/images/buttons/icon_card.png'});
		btnPayCreditCard.left = 16;
		controlBar.add(btnPayCreditCard);
	
		var btnPayClientAccount = new ActionButton({title:'ACCOUNT',icon:'/images/buttons/icon_account.png'});
		btnPayClientAccount.left = 16;
		controlBar.add(btnPayClientAccount);
		
		mainview.add(footer);
		
		var user = ICABBI.Controller.getUser();
		 
		if(ICABBI.Config.return_journey_enabled) {
			
			var returnJourneyRow = Ti.UI.createView({
//				layout: 'horizontal',
				left: 0,
				right: 0,
				top: 18,
				height: Ti.UI.SIZE,
			});
			view.add(returnJourneyRow);
			
		    singleCheck = new CheckboxView({
		    	text: 'Single',
	   			value: false,
	   			//color:Theme.bookingForm.labelColor,
				//font:Theme.bookingForm.labelFont,
		    });
		    singleCheck.left = 65;
		    returnJourneyRow.add(singleCheck);
		    
		    returnCheck = new CheckboxView({
		    	text: 'Return',
	   			value: false,
	   			//color:Theme.bookingForm.labelColor,
				//font:Theme.bookingForm.labelFont,
		    });
		    returnCheck.right = 16;
		    returnJourneyRow.add(returnCheck);
		    
		    singleCheck.addEventListener('change', function(data) {
		    	if(data.value) {
			    	if(returnCheck.value){
		    			returnCheck.putValue(false);
			    	}
		    	}
		    });
		    returnCheck.addEventListener('change', function(data) {
		    	if(data.value && singleCheck.value)
		    		singleCheck.putValue(false);
		    	
		    	bookingData.returnJourneyChecked = data.value;
		    	if(data.value)
		    		returnTimeRow.showRow();
		    	else
		    		returnTimeRow.hideRow();
		    });
		}		
		
   		/*
   		 * DateTime;
   		 */
   		timeRow = new FormPickerRow({
   			label:'When',
   			title:bookingData.objDateTime.now ? 'Now' : bookingData.objDateTime.formatted.date,
   			subTitle:bookingData.objDateTime.now ? '':bookingData.objDateTime.formatted.time,
   			firstItem:true,
   		});
   		timeRow.top = ICABBI.Config.return_journey_enabled ? 0 : 10;
		view.add(timeRow);
		
		timeRow.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			var DateTimeView = require('/ui/common/DateTimeView');
			var config = {
				content:DateTimeView,
				title:'Select Time & Date',
				header:{visible:true,controls:{cancel:{visible:true},submit:{visible:false}}},
				data:{objDateTime:bookingData.objDateTime.raw},
			};
		    var win = new ChildWindow(config);
		    win.addEventListener('close',function(e){

		    	if(win.__retval){
		    		bookingData.objDateTime = win.__retval;
		    		if(!_.isObject(bookingData.objDateTime)) {
		    			return;
		    		}
		    		timeRow.putText({
			   			label:'When',
			   			title:bookingData.objDateTime.now ? 'Now' : bookingData.objDateTime.formatted.date,
   						subTitle:bookingData.objDateTime.now ? '':bookingData.objDateTime.formatted.time,
			   		});
		    		
					bookingData.booking.set({
						now:bookingData.objDateTime.now,
						date:bookingData.objDateTime.formatted.date,
						time:bookingData.objDateTime.formatted.time,
					});
		    	}
		    });
		    noteRow.hideKeybord();
		    ICABBI.navController.open(win,undefined,self);
		});

   		/*
   		 * From
   		 */
   		var fromRow = new FormPickerRow({
   			label:'From',
   			title: bookingData.addressFrom.get('src') ? bookingData.addressFrom.formatDisplay(false) : 'Address not found',
   			subTitle:bookingData.addressFrom.get('area'),
   		});
   		view.add(fromRow);
   		
		fromRow.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			$$.ActivityIndicator.start('Load addresses!');
			bookingData.booking.off();
			
			if(ICABBI.Config.search_addresses)
			{
				var AddressSearchView = require('/ui/common/AddressSearchView');
				var config = {content:AddressSearchView,
						header:{visible:true , controls : {cancel : {visible: true} }},
						title : 'From address search',
						notScrollable : true,
						data:{destination: false, location : MapControl.currentLocation ? {lat : MapControl.currentLocation.latitude, lng : MapControl.currentLocation.longitude} : null},
					};
			    
			    var win = new ChildWindow(config);
			    
			    win.addEventListener('close',function(e){
					if(win.__retval && _.isObject( win.__retval) && win.__retval.address){
						bookingData.addressFrom.set(win.__retval.address);
						MapControl.setAddressEdited(bookingData.addressFrom, false);
					}
					
				});
				noteRow.hideKeybord();
			    ICABBI.navController.open(win,undefined,self);
			}
			else
			{ 
				ICABBI.Controller.trigger('mapview:open:edit',{find:true});
				ICABBI.SlidingMenu.fireEvent('openview',{index:0});
				self.opening = false;
				$$.ActivityIndicator.stop();
			}
		});
		bookingData.addressFrom.on('change',function(){
			fromRow.putText({
				    	label:'From',
   						title:bookingData.addressFrom.formatDisplay(false),
   						subTitle:bookingData.addressFrom.get('area'),
				  });
		});
   		/*
   		 * To
   		 */
   		var toRequired = ICABBI.Config.behaviours && ICABBI.Config.behaviours.fields && ICABBI.Config.behaviours.fields.destination &&
					ICABBI.Config.behaviours.fields.destination['required'] && ICABBI.Config.behaviours.fields.destination['required'].id;
   		var toRow = new FormPickerRow({
   			label:'To',
   			title:bookingData.addressTo.isEmpty() ? '':bookingData.addressTo.formatDisplay(),
   			subTitle: bookingData.addressTo.isEmpty() ? (toRequired ? 'required' : 'optional') :bookingData.addressTo.get('area'),
   		});
   		view.add(toRow);
   		bookingData.addressTo.on('change',function(){
   			var addr = bookingData.addressTo.formatDisplay();
   			if(!addr || addr.length == 0)
   			{
   				bookingData.booking.set('vias', []);
   				viaRow.setBooking(bookingData.booking);
   				viaRow.visible = false;
   				viaRow.height = 0;
   			}
   			else
   			{
   				viaRow.visible = true;
   				viaRow.height = Ti.UI.SIZE;
			}
			
			toRow.putText({
				    	label:'To',
   						title:addr,
   						subTitle:bookingData.addressTo.isEmpty() ? (toRequired ? 'required' : 'optional') :bookingData.addressTo.get('area'),
				  });
		});
   		
		toRow.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			$$.ActivityIndicator.start('Load addresses!');
			if(ICABBI.Config.search_addresses)
   			{
				var AddressSearchView = require('/ui/common/AddressSearchView');
				var config = {content:AddressSearchView,
						header:{visible:true , controls : {cancel : {visible: true} }},
						title : 'To address search',
						notScrollable : true,
						data:{destination: true},
					};
			    var win = new ChildWindow(config);
			    win.addEventListener('close',function(e){
					if(win.__retval && _.isObject( win.__retval) && win.__retval.address){
						bookingData.addressTo.set(win.__retval.address);	
					}
					
				});
				noteRow.hideKeybord();
			    ICABBI.navController.open(win,undefined,self);
			 }
			 else
			 {
			 	if(!bookingData.pois)
			 	{
			 		bookingData.pois = [];
					
					ICABBI.Controller.getMeta().destinations.each(function(destination){
						bookingData.pois.push({
							title:destination.get('formatted'),
							id:destination.id
						});
					});
			 	}
			 	noteRow.hideKeybord();
			 	$$.ActivityIndicator.stop();
			 	if(bookingData.pois.length == 0)
			 	{
			 		self.opening = false;
					return;
			 	}
			 	ICABBI.navController.showPickerModal({
				    title:'Destination',
				    data: bookingData.pois,
				    click : function(e){
				    	//if(e.selected) {
				    		var destination = null;
							ICABBI.Controller.getMeta().destinations.each(function(dest){
								if(dest && dest.id == e.selected){
									destination = dest;							
								}
							});
							if(destination)
				    			bookingData.addressTo.set(destination.toJSON());
				    	//}
				    }
				});
				
				self.opening = false;
				$$.ActivityIndicator.stop();
			 }
		});
		
		
		// var toRowUpdate = function(e){
				// var row = picker_destination.getSelectedRow(0) || pois[default_sel_row_idx];
				// if(row) {
					// var destination = ICABBI.Controller.getMeta().destinations.get(row.destinationId);
					// bookingData.addressTo.set(destination.toJSON());
				// }
	    		// toRow.putText({
		   			// label:'To',
		   			// title:bookingData.addressTo.isEmpty() ? '':bookingData.addressTo.formatDisplay(),
		   			// subTitle:bookingData.addressTo.isEmpty() ? 'optional':bookingData.addressTo.get('area'),
		   		// });
			// };
			
		
		
		/*
		 * VIA 
		 */
		viaRow = new FormViaRow({
			bookingData : bookingData
		});
		var toaddr = bookingData.addressTo.get('formatted');
		viaRow.visible = !(!toaddr || toaddr.length == 0);
		viaRow.height = !(!toaddr || toaddr.length == 0) ? Ti.UI.SIZE : 0;
		view.add(viaRow);
		
		viaRow.setBooking(bookingData.booking);
		
		if(ICABBI.Config.return_journey_enabled)
		{
	   		/*
	   		 * Return DateTime;
	   		 */
	   		returnTimeRow = new FormPickerRow({
	   			label:'Return',
	   			title: bookingData.objReturnDateTime.now ? 'Return Date & Time' : bookingData.objReturnDateTime.formatted.date,
	   			subTitle: bookingData.objReturnDateTime.now ? '' : bookingData.objReturnDateTime.formatted.time,
	   			firstItem:true,
	   		});
	   		returnTimeRow.setHeight(0);
			view.add(returnTimeRow);
			
			returnTimeRow.addEventListener('click',function(e){
				if (ICABBI.navController.opening(self)) {
					return;
				}
				var DateTimeView = require('/ui/common/DateTimeView');
				var config = {
					content:DateTimeView,
					title:'Select Time & Date',
					header:{visible:true,controls:{cancel:{visible:true},submit:{visible:false}}},
					data:{objDateTime:bookingData.objReturnDateTime.raw},
				};
			    var win = new ChildWindow(config);
			    win.addEventListener('close',function(e){
	
			    	if(win.__retval){
			    		bookingData.objReturnDateTime = win.__retval;
			    		if(!_.isObject(bookingData.objReturnDateTime)) {
			    			return;
			    		}
			    		returnTimeRow.putText({
				   			label:'Return',
				   			title:bookingData.objReturnDateTime.now ? 'Return Date & Time' : bookingData.objReturnDateTime.formatted.date,
	   						subTitle:bookingData.objReturnDateTime.now ? '':bookingData.objReturnDateTime.formatted.time,
				   		});
			    	}
			    });
			    noteRow.hideKeybord();
			    ICABBI.navController.open(win,undefined,self);
			});
		}
		
   		/*
   		 * VehicleType
   		 */
   		typeRow = new FormPickerRow({
   			label:'Type',
   			title:vehicleType.get('title'),
   			subTitle:'',
   		});
   		view.add(typeRow);
		
		typeRow.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			$$.ActivityIndicator.start('Load vehicle types!');
			var VehicleTypeView = require('/ui/common/VehicleTypeView');
			var config = {
				content:VehicleTypeView,
				title:'Vehicle Type',
				header:{visible:true,controls:{cancel:{visible:true},submit:{visible:false}}},
				data:{vehicleType:vehicleType},
				notScrollable:true,
			};
		    var win = new ChildWindow(config);
		    noteRow.hideKeybord();
			ICABBI.navController.open(win,undefined,self);
		});
		vehicleType.on('change',function(){
			bookingData.booking.set('vehicle_type',vehicleType.toJSON());
    		typeRow.putText({
	   			label:'Type',
	   			title:vehicleType.get('title'),
	   			subTitle:'',
	   		});
		});

   		/*
   		 * DriverNote
   		 */
   		noteRow = new FormTextareaRow({
   			label:'Note',
   			value:bookingData.booking.get('instructions'),
   			hint:'eg. Ring mobile when outside',
   			lastItem:false,
   			predefinedValues:true,
   		});
   		view.add(noteRow);
   		
		var bookingNotes = ICABBI.Controller.getBookingNotes();
	
		if(!bookingNotes || !bookingNotes.length) {
			noteRow.hidePredefinedBtn();
		}
		else {
			setTimeout(function() {
				noteRow.showPredefinedBtn();
			}, 100);				
		}
		
		noteRow.addEventListener('change',function(e){
			bookingData.booking.set('instructions', e.value);
   		});
   		
		
		var bookingNoteRows = [{
			title: "No Note"
		}];
		if(bookingNoteRows) {
			for(var idx in bookingNotes) {
				bookingNoteRows.push({
					title: bookingNotes[idx]
				});
			}
		}
		
		ICABBI.Controller.on('booking_notes_changed', function(e){
			bookingNotes = ICABBI.Controller.getBookingNotes();
			
			if(!bookingNotes || !bookingNotes.length) {
				noteRow.hidePredefinedBtn();
			}
			else {
				setTimeout(function() {
					noteRow.showPredefinedBtn();
				}, 100);				
			}
		});
		
		noteRow.predefinedBtn.addEventListener('click', function(){
	    	var pickerNotes = [];
	    	var notes = bookingNotes;
	    	
	    	pickerNotes.push({
					title: "No Note",
					id:0,
			});
		
	    	for(idx in notes) {
				pickerNotes.push({
					title: notes[idx],
					id: parseInt(parseInt(idx)+1),
				});
			}
			ICABBI.navController.showPickerModal({
						    title:'Note Select',
						    data: pickerNotes,
						    click : function(e){	
						    	if(e.selected || e.selected === 0) 
						    	{
						    		if(e.selected == 0) {
										noteRow.putValue('');
										bookingData.booking.set('instructions', '');
										return;
									}
						    		var nt = noteRow.getValue().trim();
						    		if(nt) {
						    			nt += '\r\n';
						    		}
									nt += notes[e.selected-1];
						    		noteRow.putValue(nt);
						    		bookingData.booking.set('instructions', nt);
						    	}
						    }
						});		
		});
		
   		/*
   		 * CustomerName
   		 */
   		nameRow = createRow({
   			label:'Name',
   			hint: 'Name of Passenger',
   			inline : true,
			autocapitalization:false,
			autocorrect:false,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			value:user.get('name')
	    });
	    nameRow.addEventListener('change',function(e){
			bookingData.booking.set('name',e.value);
   		});
   		view.add(nameRow);

   		/*
   		 * TelephoneNumber
   		 */
   		var flexSpace = Titanium.UI.createButton({
		    systemButton:Titanium.UI.iPhone.SystemButton.FLEXIBLE_SPACE
		});
		 
		
		var done = Titanium.UI.createButton({
		    systemButton:Titanium.UI.iPhone.SystemButton.DONE
		});
		 
		done.addEventListener('click',function(){
		    phoneRow.done();
		});
   		phoneRow = createRow({
   			label:'Phone',
   			hint: 'Phone number of Passenger',
   			inline : true,
			keyboardType:Titanium.UI.KEYBOARD_NUMBER_PAD,
			autocapitalization:false,
			autocorrect:false,
			value:user.get('phone').number,
			returnKeyType:Ti.UI.RETURNKEY_DONE,
			keyboardToolbar:[flexSpace, done],
			lastItem:!(ICABBI.Config.return_journey_enabled),
	    });
	    phoneRow.addEventListener('change',function(e){
			bookingData.booking.set('phone',e.value);
   		});
   		view.add(phoneRow);
	    
		/*
		 * Return Journey
		 */
/*
		if(ICABBI.Config.return_journey_enabled) {
			var rowLineTop = Ti.UI.createView({
				left:68,
				right:8,
				top:0,
				height:1,
				backgroundColor:Theme.global.listTopLineColor,
				visible:true,
				touchEnabled:false,
			});
			view.add(rowLineTop);
		    var returnJourneyLabel = Ti.UI.createView({
		    	height:33,
		    	left:0,
		    	right:0,
		    	layout:'horizontal'
		    });
	   		
			var returnJourneyLabelText = Ti.UI.createLabel({
				height:33,
				width:Ti.UI.SIZE,
				color:Theme.global.fontColor,
				font:Theme.global.font,
				text:'Tick here for Return Journey',
				touchEnabled:false,
			});
			returnJourneyLabel.add(returnJourneyLabelText);
			
		    returnJourneyRow = new FormCheckboxRow({
		    	labelView:returnJourneyLabel,
	   			value:bookingData.returnJourneyChecked,
	   			checkWidth:53,
	   			labelCheck:true
		    });
		    
		    returnJourneyRow.addEventListener('change', function(data) {		    	
		    	bookingData.returnJourneyChecked = data.value;
		    });
		    
			view.add(returnJourneyRow);
			
			bookingData.on('booking_changed', function() {
				view.scrollTo(0, 0);
		    	returnJourneyRow.visible = !bookingData.returnJourneyActive;
		    	screenTitle.visible = bookingData.returnJourneyActive;
		    	statuxBox.visible = !bookingData.returnJourneyActive;
		    	if(bookingData.returnJourneyActive)
		    	{
					screenTitle.setText('Return Booking');		    		
		    	}
		    	else
		    	{
		    		screenTitle.setText('');
		    	}
		    	
		    	if(btnBackMenu)
		    		btnBackMenu.visible = bookingData.returnJourneyActive ? bookingData.returnJourneyActive : (ICABBI.Config.show_map ? true : false);
		    	if(btnSlideMenu)
		    		btnSlideMenu.visible = bookingData.returnJourneyActive ? bookingData.returnJourneyActive : (ICABBI.Config.show_map ? false : true);
		    	booking = bookingData.returnJourneyActive ? bookingData.returnJourneyBooking : bookingData.booking;
		    	
		    	vehicleType.set(ICABBI.Controller.getMeta().vehicleTypes.get(booking.get('vehicle_type')).toJSON());
		    	noteRow.putValue(booking.get('instructions'));
		    	
	    		timeRow.putText({
		   			title:bookingData.objDateTime.now ? (bookingData.returnJourneyActive ? '' : 'Now') : bookingData.objDateTime.formatted.date,
   					subTitle:bookingData.objDateTime.now ? '':bookingData.objDateTime.formatted.time,
		   		});
		   		
		   		viaRow.setBooking(booking);
		    });
		}*/

		
		// pay by
		// 	
		// var paybyLabel = Ti.UI.createLabel({
			// text:'Pay\nby',
			// left:0,
			// width:44,
			// height:79,
			// color:Theme.global.fontColor,
			// font:Theme.global.buttonFont,
			// textAlign:'center',
		// });
		// footer.add(paybyLabel);
   		
		
		/////////////////
		//[sonal] deprecate?? setting values in bookin model already now
		var _getBookingDetails = function() {
			var form = {};
			form.now  = bookingData.objDateTime.now;
		
			form.date = bookingData.objDateTime.isoFormat();
			form.return_date = bookingData.returnJourneyChecked ? bookingData.objReturnDateTime.isoFormat() : '',
			
			form.address 			= bookingData.addressFrom.toJSON();
			form.destination 		= bookingData.addressTo.toJSON();
			
			form.vehicle_type 	= vehicleType.get('key');//picker_type.getSelectedRow(0).typeid;
			form.instructions	= bookingData.booking.get('instructions');
			if (nameRow.value=='' && phoneRow.value=='')
			{
				var user = ICABBI.Controller.getUser(); 
				nameRow.putText({
			    	value:user.get('name'),	
			    });
			    
				phoneRow.putText({
			    	value:user.get('phone').number,	
			    });
				form.name	= user.get('name');
				form.phone	= user.get('phone').number;
			}
			else {
				form.name	= nameRow.value;
			form.phone	= phoneRow.value;
			}
		
			form.createdat	= +new Date;
			form.silent = 1;
			
			form.vias = viaRow ? viaRow.getVias() : [];
			
			return form;
		};
	
		//{"code":601,"message":"Booking Save Failed","body":{"destination":"destination must not be empty"}}
		function openBookingReview(booking, estimate)
		{
			var BookingReviewView = require('/ui/common/BookingReviewView');
					Ti.API.info('=============================');
					Ti.API.info(JSON.stringify(booking));
					var config = {
							content:BookingReviewView,
							header: {visible : true, controls: {cancel: {visible : true} }},
							notScrollable : true,
							title: 'Review Booking',
							data:{booking:booking, bookingData:bookingData, estimate:estimate},
					};
					bookingData.bookingReview.booking = booking;
					bookingData.bookingReview.estimate = estimate;
					
					var modal = new ChildWindow(config);
					noteRow.hideKeybord();
					ICABBI.navController.open(modal);
		}
		var _confirmBooking = function(prepaid){
			bookingData.booking.set(_getBookingDetails());

			$$.ActivityIndicator.start('Getting Booking Confirmation');
			
			ICABBI.Controller.confirmBooking(bookingData.booking, {
				success: function(request, estimate){
					var payment = request['payment'];
					if ((payment && payment.total==0) && prepaid ){
						$$.ActivityIndicator.stop();
						ICABBI.navController.showError({
						    title:'Error!',
						    message:'Card prepaid is not available!',
						    close:true
						});
						self.opening = false;
						return;
					}
					openBookingReview(request, estimate);
				},
				error: function(resp) {
					$$.ActivityIndicator.stop();
					var msg = resp && resp.message ? resp.message : 'Server Unavailable. Please try again later.';
					if(resp)
					for (var i in resp.body) {
						msg += '\n' + i + ': ' + resp.body[i];
					}
					ICABBI.navController.showError({
					    title:'Error!',
					    message:msg,
					    close:true
					});
				}
			});
		};

/*
btnFavourite && btnFavourite.addEventListener('click',function(e){
	var currentState = btnFavourite.state;
	btnFavourite.state = !currentState;
	var newImage = currentState ? '/images/star_off.png' : '/images/star_on.png';
	btnFavourite.setBackgroundImage(newImage);
	booking.set('favourite',btnFavourite.state);
}); 
if(booking.get('favourite')){
	btnFavourite.fireEvent('click');
}
*/
	var validate = function () {
		// clear payment settings
		bookingData.booking.set('creditcard_id', 0);	
		bookingData.booking.set('accountcard_id', 0);
		bookingData.booking.set('account_id', 0);
		var noError = true;
		//var error = 'Form contains errors:';
		var error = '';

		if(ICABBI.Config.behaviours && ICABBI.Config.behaviours.fields && ICABBI.Config.behaviours.fields.pickup &&
					ICABBI.Config.behaviours.fields.pickup['required'] && ICABBI.Config.behaviours.fields.pickup['required'].id
					&& bookingData.addressFrom.formatDisplay(true).length == 0) {
			noError = false;
			error += '- From address is required!\n';
		}
		if(ICABBI.Config.behaviours && ICABBI.Config.behaviours.fields && ICABBI.Config.behaviours.fields.destination &&
					ICABBI.Config.behaviours.fields.destination['required'] && ICABBI.Config.behaviours.fields.destination['required'].id
					&& bookingData.addressTo.formatDisplay(true).length == 0) {
			noError = false;
			error += '- To address is required!\n';
		}

		if(ICABBI.Config.return_journey_enabled && !singleCheck.value && !returnCheck.value) {
			noError = false;
			error += '- Please select Single or Return journey!\n';
		}

		if(bookingData.returnJourneyChecked && !bookingData.addressTo.get('lat') && !bookingData.addressTo.get('lng')) {
			noError = false;
			error += '- To address is required for Return journey!\n';
		}
		
		if(bookingData.returnJourneyChecked && bookingData.objReturnDateTime.now) {
			noError = false;
			error += '- Please provide a date for Return journey!\n';
		}
		else if(bookingData.returnJourneyChecked && bookingData.objReturnDateTime.isoFormat() <= bookingData.booking.date) {
			noError = false;
			error += '- Return date must be greater than the booking date!\n';
		}
		
		if(!noError) {
			ICABBI.navController.showError({
			    title:'Error!',
			    message:error,
			    close:true
			});
		}
		return noError;
	};
	
btnPayClientAccount.addEventListener('click',function(e){
	noteRow.hideKeybord();
	if (ICABBI.navController.opening(self)) {
		return;
	}
	
	if(validate()) {
		// if user is not logged in then show login view
		ICABBI.Controller.displayLogin({
			success: function(user,callback){
				ICABBI.Controller.creatingBooking = true;
				ICABBI.Controller.getUser().clientaccounts.fetchAll({
					success: function(collection,resp){
		
							var clientaccounts = ICABBI.Controller.getUser().clientaccounts;
							var options;
							var openPaymentView=true;
							if(clientaccounts.size()===0){
								options = {
										content	: require('/ui/common/ClientAccountErrorView'),
										header	: {visible:false},
										height	: Ti.UI.FILL
									};
							}
							else{
								options = {
										content	: require('/ui/common/ClientAccountPaymentView'),
										title	: 'Account Payment',
										data	: {booking:bookingData.booking,clientaccounts:clientaccounts},
										// height	: 290
								};
								if(clientaccounts.size()===1){
									clientaccounts.each(function(clientaccount){
										if(clientaccount.get('fields').length===0){
											bookingData.booking.set({account_id:clientaccount.get('id')});
											bookingData.booking.setPayment(clientaccount.get('type'),{});
											openPaymentView=false;
											_confirmBooking();
											self.opening = false;
											;
										}
									});								
								} 
							}
							if (openPaymentView){
								var modal = new ChildWindow(options);
								modal.addEventListener('open',function(){
									callback(false);
								});
								noteRow.hideKeybord();
								ICABBI.navController.open(modal,undefined,self);
								modal.addEventListener('close',function(e){
									if(modal.__retval && !!bookingData.booking.get('account_id')){
										_confirmBooking();
										self.opening = false;
									}
								});
							}
					}
				});
			},
			close : function(){
				self.opening = false;
			}
		});
	}
	else {
		self.opening = false;
	}
});

btnPayCreditCard.addEventListener('click',function(e){
	noteRow.hideKeybord();
	if (ICABBI.navController.opening(self)) {
		return;
	}
	returnJorneyCheck(function(){
		if(ICABBI.Config.card_prepaid_payment) {
			var addr = bookingData.addressTo.formatDisplay();
			var defaultAdd = null;
			if(ICABBI.Config.behaviours && ICABBI.Config.behaviours.fields && ICABBI.Config.behaviours.fields.destination &&
				ICABBI.Config.behaviours.fields.destination['default'] && 
				ICABBI.Config.behaviours.fields.destination['default'].formatted)
			{
				defaultAdd = ICABBI.Config.behaviours.fields.destination['default'].formatted;
			}
			if(!(addr.length > 0 && defaultAdd != addr)){
				ICABBI.navController.showError({
				    title:'Error!',
				    message:' Please select a pickup/destination address first!',
				    close:true
				});
				self.opening = false;
				return;
			}
		}
		
		if(validate()) {
			// if user is not logged in then show login view
			ICABBI.Controller.displayLogin({
				success: function(user,callback){
					ICABBI.Controller.creatingBooking = true;
					
					function selectType(cards, accountCards, accounts){
						var pickerCards = [];
						if(cards.length > 0) {
							pickerCards.push({
								title : 'Registered Cards',
								rows : cards
							});
						}
						
						if(accountCards.length > 0) {
							pickerCards.push({
								title : 'New Card',
								rows : accountCards
							});
						}
						//xxxx
						callback(false);
						
						ICABBI.navController.showPickerModal({
						    title:'Please Select Card',
						    data: pickerCards,
						    grouping : true, 
						    click : function(e){
						    	if(e.selected) {
						    		var parts = e.selected;

						    		parts = parts.split('_');
						    		var type = parts[0];
						    		
						    		bookingData.booking.setPayment(bookingData.booking.PAYMENT_MODES.CREDITCARD);
						    		
						    		if(type == '0') // card token
						    		{
						    			var cardId = parseInt(parts[1]);
						    			bookingData.booking.set('creditcard_id', cardId);
						    			
						    			if(accounts)
						    			{
							    			var creditcards = ICABBI.Controller.getUser().creditcards;
							    			creditcards.each(function(creditcard){
												if(creditcard.get('id') === cardId)
							    				{
							    					_.each(accounts, function(card_type){
							    						var accountcard_id= parseInt(card_type.accountcard_id);
							    						
														if(parseInt(accountcard_id) === creditcard.get('accountcard_id'))
							    						{
							    							Ti.API.error(card_type.id + "---------------------------------");
							    							bookingData.booking.set('account_id', card_type.id);
							    							Ti.API.error(bookingData.booking.get('account_id') + "---------1-----------------------");
							    						}
													});
							    				}
											});	
										}
						    		}
						    		else // new card
						    		{
						    			bookingData.booking.set('accountcard_id', parseInt(parts[1]));
						    			bookingData.booking.set('account_id', parseInt(parts[2]));
						    		}
						    		
									_confirmBooking(ICABBI.Config.card_prepaid_payment);
						    	}
						    	
								self.opening = false;
						    }
						});
					}
					var creditcards = ICABBI.Controller.getUser().creditcards,
						requiresCVV = ICABBI.Config.card_provider == 'sagepay';
						
					//select existing registered card or add new...then register booking
					var options;
					if(creditcards.length===0 && !ICABBI.Config.card_prepaid_payment){
						options = {
							content:require('/ui/common/CreditCardRegistrationView'),
							title:'Confirm Card Payment',
							data:{booking:bookingData.booking},
						};
						var modal = new ChildWindow(options);
						modal.addEventListener('open',function(){
							callback(false);
						});
						noteRow.hideKeybord();
						ICABBI.navController.open(modal,undefined,self);
						modal.addEventListener('close',function(e){
							if(creditcards.length){
							_confirmBooking(ICABBI.Config.card_prepaid_payment);
								self.opening = false;
							}
						});
					} 
					else if(creditcards.length == 1 && !requiresCVV && !ICABBI.Config.card_prepaid_payment){
						creditcards.each(function(creditcard){
							bookingData.booking.set({creditcard_id:creditcard.get('id')});
							bookingData.booking.setPayment(bookingData.booking.PAYMENT_MODES.CREDITCARD);
						});	
						callback(false);
						_confirmBooking(ICABBI.Config.card_prepaid_payment);
						self.opening = false;			
					}
					else if(creditcards.length>=1 || requiresCVV){
						var accountCards = [];
						var cards = [];
						creditcards.each(function(creditcard){
							cards.push({
								title:creditcard.get('nickname'),
								id: '0_' + creditcard.get('id'),
							});
						});
						
						if(ICABBI.Config.card_prepaid_payment)
						{
							ICABBI.Controller.getCardTypes({
								success: function(data){
								 	_.each(data, function(card_type){
										accountCards.push({
												title: card_type.name,
												id: '1_' + card_type.accountcard_id + '_' + card_type.id,
											});
									});
										
									selectType(cards, accountCards, data);
								}
							});
						}
						else
							selectType(cards, accountCards, null);
					}
				},
				close : function(){
					self.opening = false;
				}
			});
		}
		else {
			self.opening = false;
		}
	});
});
function returnJorneyCheck(calback) {
	Ti.API.info('xxxx - user - ' + JSON.stringify(user));
	var user = ICABBI.Controller.getUser();
		
	if(ICABBI.Config.return_journey_enabled && !bookingData.returnJourneyNotified && !(singleCheck.value || returnCheck.value) && 
		user.get('return_discount_type') != 'NONE' && ICABBI.Config.return_journey_discount && ICABBI.Config.return_journey_discount > 0) {
		bookingData.returnJourneyNotified = true;
		
		var btnClick = function(e) {
			if(e.index == 1)
			{
				returnCheck.putValue(true);
				self.opening = false;
			}
			if(e.index == 2)
			{
				singleCheck.putValue(true);
				if(calback)
					calback();
			}							
		};
		
		ICABBI.navController.showNotification({
		    title: false,
		    close:false,
		    message: 'Would you like to book a return journey and avail of a ' + ICABBI.Config.return_journey_discount + '% discount?',
		    textAlign:Ti.UI.TEXT_ALIGNMENT_CENTER,
			buttons: [
				{ lable : 'Yes Please', icon: false, color: '#7fb615', width: 100, height: 40, click: btnClick },
				{ lable : 'No Thanks', icon: false, color: '#333433', width: 100, height: 40, click: btnClick }
			],
		});
	}	
	else if(calback)
		calback();
}

if(!ICABBI.Config.disable_cash_payment && btnPayCash) {
	
	btnPayCash.addEventListener('click',function(e){
		noteRow.hideKeybord();
		if (ICABBI.navController.opening(self)) {
			return;
		}
		//returnJorneyCheck(function(){
			if(validate()) {
				// if user is not logged in then show login view
				ICABBI.Controller.displayLogin({
					success: function(user,callback){
						callback();
						ICABBI.Controller.creatingBooking = true;
						bookingData.booking.setPayment(bookingData.booking.PAYMENT_MODES.CASH);
						_confirmBooking();
						self.opening = false;
					},
					close : function(){
						self.opening = false;
					}
				});
			}
			else {
				self.opening = false;
			}
		//});
	});
}
 
/////////////////			

		parentView.add(mainview);
		return parentView;
	};
	
	var createHeader = function(backAction){
		var header = Ti.UI.createView({
			top:0,
			left:0,
			right:0,
			height: 48,
			backgroundColor: '#dddddd',
		});

		var headerBorder = Ti.UI.createView({
			bottom: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.altBGColor,
		});
		header.add(headerBorder);

		if(!ICABBI.Config.show_map)
		{
			btnSlideMenu = Ti.UI.createView({
				left:6,
				height:36,
				width:36,
				animateType:Theme.ANTIMATE_TYPE_OPACITY,
			});
			
			var menuIcon = Ti.UI.createImageView({
				height:16,
				width:21,
				touchEnabled:false,
				image:'/images/map/btn_menu.png',
			});
			btnSlideMenu.add(menuIcon);
			Theme.animateButton(btnSlideMenu);
	
			btnSlideMenu.addEventListener('click',function(e){
				noteRow.hideKeybord();
				ICABBI.Controller.trigger('slidingmenu:toggle');
			});

			header.add(btnSlideMenu);
			
			var lblNotification = Ti.UI.createLabel({
				right:0,
				top:0,
				color:Theme.global.fontColor,
				backgroundColor:Theme.global.highlightLightColor,
				width:20,
				height:18,
			    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
				borderRadius:6,
				borderWidth:1,
				borderColor:Theme.global.highlightColor,
				font:Theme.global.smallFont,
				touchEnabled:false,
				visible:false			
			});
			ICABBI.Controller.on('change:active_bookings',function(e){
				lblNotification.text = e.count;
				lblNotification.visible = !!e.count;
			});
			btnSlideMenu.add(lblNotification);
		}
		
		if(backAction)
		{
			btnBackMenu = Ti.UI.createView({
				left:5,
				height:48,
				width:50,
				animateType:Theme.ANTIMATE_TYPE_OPACITY,
				visible: ICABBI.Config.show_map ? true : false
			});
			
			var backIcon = Ti.UI.createImageView({
				height:30,
				width:50,
				left:0,
				touchEnabled:false,
				image:'/images/headers/icon_back.png',
			});
			btnBackMenu.add(backIcon);
			var backLabel = Ti.UI.createLabel({
				text: 'Back',
				bottom:17,
			    left: 15,
				color:Theme.childwindow.buttonTextColor,
				font:Theme.childwindow.headerButtonFont,
			});
			btnBackMenu.add(backLabel);
			Theme.animateButton(btnBackMenu);
			btnBackMenu.addEventListener('click', backAction);
			header.add(btnBackMenu);
		}
		
		var statuxBoxContainer = Ti.UI.createView({
			left:60,
			right:35,
			height:36,
		});
		header.add(statuxBoxContainer);
		screenTitle = Ti.UI.createLabel({
			height:36,
			width:Ti.UI.SIZE,
			color:Theme.bookingForm.headerColor,
			font:Theme.bookingForm.headerFont,
			textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
			horizontalWrap:false,
			center: {
		  		x: '50%',
			},
			visible:false
		});
		statuxBoxContainer.add(screenTitle);
		statuxBox = Ti.UI.createView({
			height:36,
			width:Ti.UI.SIZE,
			layout:'horizontal',
			horizontalWrap:false,
			center: {
		  		x: '50%',
			},
		});
		statuxBoxContainer.add(statuxBox);
		
		if(!ICABBI.Config.app_disable_eta) {
			var lblEstimate = Ti.UI.createLabel({
				width:Ti.UI.SIZE,
				height:36,
				color:Theme.map.smallColor,
				font:Theme.map.smallFont,
				textAlign:'right',
				text:'Estimated\nArrival',
			});
			statuxBox.add(lblEstimate);
	
			var timeBox = Ti.UI.createView({
				left:4,
				height:36,
				width:Ti.UI.SIZE,
			});
			statuxBox.add(timeBox);
			
			var doTime = function() {
				if (timeBox.children && timeBox.children.length) {
					timeBox.removeAllChildren();
				}
				
				var etaArray = currentETA.toString().split('');
				var thisLeft = 0;
				
				for (var i in etaArray) {
					var box = Ti.UI.createView({
						height:34,
						width:31,
						left:thisLeft,
						backgroundImage:'/images/map/background_minute.png'
					});
					
					var digit = Ti.UI.createLabel({
						width:31,
						height:45,
						color:Theme.map.timeColor,
						font:Theme.map.timeFont,
						text:etaArray[i],
						textAlign:'center',
					});
					box.add(digit);
					
					timeBox.add(box);
					
					thisLeft += 32;
				}
			};
			
			doTime();
			
			var lblMins = Ti.UI.createLabel({
			    left:4,
				height:36,
			    width:Ti.UI.SIZE,
			    color:Theme.global.fontColor,
			    font:Theme.map.infoFont,
			    text:'Minutes',
			});
			statuxBox.add(lblMins);
			
			ICABBI.Controller.on('change:eta',function(e){
				if (currentETA !== e.eta) {
					currentETA=e.eta;
					doTime();
				}
			});
		}
		var btnCurrentLocation = Ti.UI.createView({
			right:5,
			height:48,
			width:25,
			animateType:Theme.ANTIMATE_TYPE_OPACITY,
		});
		
		var locationIcon = Ti.UI.createImageView({
			height:25,
			width:25,
			right:0,
			touchEnabled:false,
			image:'/images/map/btn_location.png',
		});
		btnCurrentLocation.add(locationIcon);
		Theme.animateButton(btnCurrentLocation);

		btnCurrentLocation.addEventListener('click',function(e){
			MapControl.getCurrentPosition();
		});
		header.add(btnCurrentLocation);
	
		return header;
	};

	bookingData.on('reset', function() {
		view.scrollTo(0, 0);
		
		screenTitle.visible = false;	
		statuxBox.visible = true;
				
		defaultVehicle();
		
		noteRow.putValue('');
		
		var user = ICABBI.Controller.getUser(); 
		nameRow.putText({
	    	value:user.get('name'),	
	    });
		phoneRow.putText({
	    	value:user.get('phone').number,	
	    });
		
		if(ICABBI.Config.show_map || ICABBI.Config.return_journey_enabled)
		{
			if(btnBackMenu)
				btnBackMenu.visible = ICABBI.Config.show_map ? true : false;
			if(btnSlideMenu)
				btnSlideMenu.visible = ICABBI.Config.show_map ? false : true;
		}
		
		if(ICABBI.Config.return_journey_enabled) {
			singleCheck.putValue(false);
			returnCheck.putValue(false);
		}
		
		timeRow.putText({
			title:bookingData.objDateTime.now ? 'Now' : bookingData.objDateTime.formatted.date,
   			subTitle:bookingData.objDateTime.now ? '':bookingData.objDateTime.formatted.time,
		});
		if(ICABBI.Config.return_journey_enabled)
			returnTimeRow.putText({
	   			label:'Return',
	   			title:bookingData.objReturnDateTime.now ? 'Return Date & Time' : bookingData.objReturnDateTime.formatted.date,
				subTitle:bookingData.objReturnDateTime.now ? '':bookingData.objReturnDateTime.formatted.time,
	   		});
		typeRow.putText({
			title:vehicleType.get('title'),
   			subTitle:'',
		});
		
		viaRow.setBooking(bookingData.booking);
	});	
	var self = createForm();
	ICABBI.Controller.on('application:reset',function(data){
		self.children.forEach(function(child){
			self.remove(child);	
		});
				
		createForm(self);
	});
	return self;
};

module.exports = BookingEditView;
