var	ICABBI = require('/core/icabbi'),
	ChildWindow = require('/ui/common/ChildWindow');
	
var HeaderButton = require('/ui/common/HeaderButton');

var Theme = require('/ui/Theme');

var _ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager'),
	Booking = require('/model/Booking');
	
var BookingMapView = function(options) {
	var map;
	var booking = options.data.booking;

	var modes={FINISHED:2,ACTIVE:3};
	var active = true;
	var createMap = function(){
		var file = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, 'web/track.html');
		var view = Titanium.UI.createWebView({
				top:0,
				bottom:0,
				left: 0,
				right:0,
				loading:true,
				url:file.nativePath,
				borderRadius:1
				// backgroundColor:'#fff'
		});
		
		view.addEventListener('error',function(e){
			if(Ti.App.deployType !== 'production') {
				alert(JSON.stringify(e));
			}
		});
		
		return view;
	};
	
	var create = function(){
		var view = Titanium.UI.createView({
			top:0,
	        left:0,
	        right:0,
	        bottom:0,
	    });
	    var controls = Ti.UI.createView({
			width:Ti.UI.SIZE,
			height: 44,
			right:0,
			layout:'horizontal',
		});
		view.add(controls);
		
		var btnClose = Ti.UI.createView({
			right:5,
			height:48,
			width:50,
			animateType:Theme.ANTIMATE_TYPE_OPACITY,
		});
		
		var closeIcon = Ti.UI.createImageView({
			height:30,
			width:50,
			left:0,
			touchEnabled:false,
			image:'/images/headers/icon_close_button.png',
		});
		btnClose.add(closeIcon);
		var closeLabel = Ti.UI.createLabel({
			text: 'Close',
			bottom:17,
		    left: 10,
			color:Theme.childwindow.buttonTextColor,
			font:Theme.childwindow.headerButtonFont,
		});
		btnClose.add(closeLabel);
		btnClose.addEventListener('click',function(e){
			ICABBI.SlidingMenu.fireEvent('openview',{index:ICABBI.Config.show_map?0:1});
		});
		Theme.animateButton(btnClose);
		controls.add(btnClose);
	    
		map = createMap();
		view.add(map);
		
		Ti.App.addEventListener('app:leaflet:loaded', function(e){
			loadMapInfo();
		}); 
		return view;
	};

	function loadMapInfo() {
		if(options.data.Mode===modes.FINISHED){
			
			options.parent.setTitle('Thank you!');
			
			var addressStart = booking.get('address'),
				addressFinish = booking.get('destination'),
				locations = booking.get('locations'),
				points=[];

			_.each(locations,function(location){
				points.push({
					latitude:Number(location.lat),
					longitude:Number(location.lng),
					updated:location.updated,
				});
			});

			if(locations && locations.length && Number(addressFinish.lat) && Number(addressFinish.lng)){
				addressFinish.lat=points[points.length-1].latitude;
				addressFinish.lng=points[points.length-1].longitude;
			}
			
			var startImage = Ti.Filesystem.getFile('/images/map/pin_hail.png');
			var endImage = Ti.Filesystem.getFile('/images/map/pin_finish.png');
			
			// var points= [{latitude:53.38814,longitude:-6.06448},{latitude:53.391314,longitude:-6.092976},{latitude:53.388959,longitude:-6.11924},{latitude:53.417717,longitude:-6.143273},{latitude:53.440423,longitude:-6.123016},{latitude:53.451056,longitude:-6.148422},{latitude:53.446149,longitude:-6.173485},{latitude:53.454327,longitude:-6.214512},{latitude:53.410555,longitude:-6.238716},{latitude:53.407281,longitude:-6.301029},{latitude:53.386809,longitude:-6.358364},{latitude:53.367865,longitude:-6.381024},{latitude:53.339586,longitude:-6.387375},{latitude:53.32021,longitude:-6.369431},{latitude:53.300107,longitude:-6.337159},{latitude:53.288205,longitude:-6.330979},{latitude:53.248371,longitude:-6.381104},{latitude:53.233578,longitude:-6.420243}];
			Ti.App.fireEvent('app:leaflet:addRoute',{
				padding:0.2,
				points:points,
				annotations:[
						{key:'start',latitude:Number(addressStart.lat),longitude:Number(addressStart.lng),title:addressStart.formatted||'Pick up',image:startImage.nativePath},
						{key:'finish',latitude:Number(addressFinish.lat),longitude:Number(addressFinish.lng),title:addressFinish.formatted||'Drop off',image:endImage.nativePath}
				],
			
			});
		}
		else if(options.data.Mode===modes.ACTIVE){
			var addressStart = booking.get('address'),
				locations = booking.get('locations')||[],
				points=[],
				driver = booking.get('driver');

			var activeUpdate = function(){
				booking.syncStatus({
					locations:1,
					success: function(){ 
						if(active && ICABBI.Controller.getUser().bookings.get(booking.get('perma_id'))){
							// if (booking.get('live_eta') == 0) {
								// ICABBI.Controller.trigger('change:header:info',{text:booking.get('status_text')});
							// } else {
								// ICABBI.Controller.trigger('change:eta',{eta:booking.get('live_eta')});
							// }
							if(booking.get('status_text'))
								options.parent.setTitle(booking.get('status_text'));
							
							driver = booking.get('driver');
							if(!driver.id)
								ICABBI.navController.close(options.window);							
							locations = booking.get('locations')||[];
							points=[];
							
							//update driver annotation
							_.each(locations,function(location){
								points.push({
									latitude:Number(location.lat),
									longitude:Number(location.lng),
									updated:location.updated,
								});
							});

							var startImage = Ti.Filesystem.getFile('/images/map/pin_hail.png');
							var endImage = Ti.Filesystem.getFile('/images/map/pin_driver.png');
							
							var driverText ='<p>';
							if(driver.photo) {
								driverText += '<img align="right" src="' + driver.photo + '" height="80">';
							}

							driverText += '<b>ETA:</b> '+booking.get('live_eta')+' min' + (booking.get('live_eta') != 1 ? 's':'');
							if (driver.name && driver.name.length) {
								driverText += '<br/><b>Driver:</b> ' + driver.name;
							}
							var vehicle = '';
							if (driver.vehicle && driver.vehicle.make && driver.vehicle.make.length) {
								vehicle += driver.vehicle.make + ' ';
							}
							
							if (driver.vehicle && driver.vehicle.model && driver.vehicle.model.length) {
								vehicle += driver.vehicle.model;
							}
							if (vehicle.length) {
								driverText += '<br/><b>Vehicle:</b> ' + vehicle;
							}
							
							if (driver.vehicle && driver.vehicle.reg && driver.vehicle.reg.length) {
								driverText += '<br/><b>Vehicle Reg:</b> ' + driver.vehicle.reg;
							}
							driverText+='</p>';
							
// points=[{latitude:53.346273,longitude:-6.293834},{latitude:53.346273,longitude:-6.293834},{latitude:53.340765,longitude:-6.307539},{latitude:53.341789,longitude:-6.297239},{latitude:53.343583,longitude:-6.288399},{latitude:53.343583,longitude:-6.275353}]
							Ti.App.fireEvent('app:leaflet:addRoute',{
								padding:0.2,
								points:points,
								annotations:[
										{key:'start',latitude:Number(addressStart.lat),longitude:Number(addressStart.lng),title:addressStart.formatted||'Pick up',image:startImage.nativePath},
										{key:'driver',latitude:Number(driver.lat),longitude:Number(driver.lng),title:driverText,image:endImage.nativePath}
								],
							
							});
							
							//loop if still in view...doublecheck modes.ACTIVE
							active && setTimeout(activeUpdate,15*1000);
						}
					}
				});
			};
			
			setTimeout(activeUpdate,500);
	/////////////		
		}
	}
	var self = create();
	$$.ActivityIndicator.start('Loading map');
	var loadEvent = function(){
		Ti.App.fireEvent('app:leaflet:init',{
			lat : ICABBI.Controller.DEVICE_LOCATION_LATLNG.latitude || ICABBI.Config.base_lat,
			lng : ICABBI.Controller.DEVICE_LOCATION_LATLNG.longitude || ICABBI.Config.base_lng
		});
		self.removeEventListener('loaded', loadEvent);
		
		$$.ActivityIndicator.stop();
	};
	
	self.addEventListener('load', loadEvent);
	
	// close active timer
	options.parent.window.addEventListener('close', function(e){
		active = false;
	});
	return self;
};

module.exports = BookingMapView;
