var ICABBI = require('/core/icabbi');

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager'),
	Uri = require('/lib/Uri');

var Card3DPaymentView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
		modal: false
	};
	options = _.extend(defaults,options||{});
	
	var create = function(){
		var content = Ti.UI.createWebView({
			height:Ti.UI.FILL,
			width:Ti.UI.FILL,
			scalesPageToFit:true,
			borderRadius : 1
		});
		
		
		var resultUri = (ICABBI.Config.IcabbiApi.ENDPOINT + 'payment/result').replace(/.*?:\/\//g, "");
		
		content.addEventListener('beforeload', function(e){
			if(e.url.indexOf(resultUri) != -1)
			{
				var result = Uri.parseUri(e.url).queryKey;
				options.parent.window.__retval = {success : result.success && result.success == "0" ? false : result.success, message:result.message};

				ICABBI.navController.close(options.parent.window);
			}
		});
		
		return content;
	};

	var self = create();
	
	self.loadPage = function(paymentOptions) {
		$$.ActivityIndicator.start('Opening 3D Secure payment page');
		var file = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, 'web/' + paymentOptions.provider + '.html' );		
		self.setUrl(file.nativePath);
		
		delete paymentOptions['provider'];
		var loadEvent = function(){
			Ti.App.fireEvent('app:card:payment', { data : paymentOptions });
			self.removeEventListener('loaded', loadEvent);
			$$.ActivityIndicator.stop();
		};		
		self.addEventListener('load', loadEvent);
	};	
	self.loadPage(options.data.payment);
	return self;
};

module.exports = Card3DPaymentView;
