var ICABBI = require('/core/icabbi');

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager'),
	Uri = require('/lib/Uri'),
	ConnectPayAPI = require('/core/ConnectPayAPI');

var CardPaymentView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			modal:false
	};
	options = _.extend(defaults,options||{});
	
	var create = function(){
		var content = Ti.UI.createWebView({
			height:Ti.UI.FILL,
			width:Ti.UI.FILL,
			scalesPageToFit:true
		});
		content.addEventListener('beforeload', function(e){
			Ti.API.info(e.url);
			if(e.url.indexOf(ICABBI.Config.IcabbiApi.ENDPOINT + 'payment/result'/*'http://digiapi.icabbi.com/digi/payment/result'*/) != -1)
			{
				var result = Uri.parseUri(e.url).queryKey;
				if(result.result == 0) // success
				{
					options.parent.window.__retval = {success : true, orderid:result.orderid, message:result.message};
				}
				else
				{
					options.parent.window.__retval = {success : false, message:result.message};
				}

				ICABBI.navController.close(options.parent.window);
			}
		});

		return content;
	};

	var self = create();
	
	self.loadPayment = function(paymentOptions) {
		$$.ActivityIndicator.start('Opening payment page');
		var file = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, 'web/payment.html' );
		self.setUrl(file.nativePath);
		var loadEvent = function(){
			Ti.App.fireEvent('app:card:payment',{ data : paymentOptions});
			self.removeEventListener('loaded', loadEvent);
			
			$$.ActivityIndicator.stop();
		};
		
		self.addEventListener('load', loadEvent);
	};
	
	self.loadPayment(ConnectPayAPI.directPayment(options.data.payment));
	return self;
};

module.exports = CardPaymentView;
