var Theme = require('/ui/Theme');

var CheckboxView = function(args){
	args.value = args.value||false;
	args.labelView = args.labelView||Ti.UI.createView();
	args.checkWidth = args.checkWidth || 65;
	args.labelCheck = args.labelCheck || false;

	var self = Ti.UI.createView({
		width: Ti.UI.SIZE,
		height: Ti.UI.SIZE,
		value: args.value,
		layout: 'horizontal',
	});
	
	var checkView = Ti.UI.createView({
		left:0,
		height: 25, // minimum height for the row
		width: 30,
	});
	self.add(checkView);
	
	var checkImage = Ti.UI.createImageView({
		height:23,
		width:23,
		image: self.value ? '/images/buttons/check.png' : '/images/buttons/check_off.png',
		touchEnabled:false,
	});
	checkView.add(checkImage);

	self.putValue = function(val) {
		var changed = self.value != val;
		self.value = val;
		checkImage.image = self.value ? '/images/buttons/check.png' : '/images/buttons/check_off.png';
		
		if(changed)
			self.fireEvent('change',{value:self.value});
	};
	
	var checkFunction = function(){
		if(args.disabled)
			return;
		self.putValue(!self.value);
	};
	checkView.addEventListener('click', checkFunction);
	
	var labelView = Ti.UI.createLabel({
		height:25,
		width:Ti.UI.SIZE,
		color:args.color || Theme.form.labelColor,
		font:args.font || Theme.form.labelFont,
		text: args.text,
		touchEnabled: true,
	});
	labelView.addEventListener('click', checkFunction);
	self.add(labelView);
	
	return self;
};

module.exports = CheckboxView;