var _ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

var Theme = require('/ui/Theme');
var HeaderButton = require('/ui/common/HeaderButton');

//ModalView Component Constructor
var ModalView = function(options) {
	//header.controls was late entry but proper way to go
	//refactor options.titleBtnClose when get chance
	var defaults = {
		title:'',
		header:{visible:true,controls:{cancel:{visible:true},submit:{visible:false},close:{visible:false}}},
//		height:Ti.UI.SIZE,
		controls:{},
		data:{}
	};
	options = _.extend(defaults, options||{});
	options.data.__headerButtons=[];

	var headerHeight = Theme.childwindow.headerHeight;
	
	var submitVisible = options.header.controls && options.header.controls.submit && options.header.controls.submit.visible;
	var lblTitle;
	
	var createHeader = function(){
		
		var header = Ti.UI.createView({
			top: 0,
			left: 0,
			right:0,
			height: headerHeight,
			backgroundColor: Theme.childwindow.bgColor,
		});

		var headerBorder = Ti.UI.createView({
			bottom: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.altBGColor,
		});
		header.add(headerBorder);

		if(options.header.controls && options.header.controls.cancel && options.header.controls.cancel.visible){
			var btnBackMenu = Ti.UI.createView({
				left:5,
				height:48,
				width:50,
				animateType:Theme.ANTIMATE_TYPE_OPACITY,
			});
			
			var backIcon = Ti.UI.createImageView({
				height:30,
				width:50,
				left:0,
				touchEnabled:false,
				image:'/images/headers/icon_back.png',
			});
			btnBackMenu.add(backIcon);
			var backLabel = Ti.UI.createLabel({
				text: 'Back',
				bottom:17,
			    left: 15,
				color:Theme.childwindow.buttonTextColor,
				font:Theme.childwindow.headerButtonFont,
			});
			btnBackMenu.add(backLabel);
			btnBackMenu.addEventListener('click',function(e){
				//close the modal window
				var cancelClose = false;
				if(mainContentView && mainContentView.onClose)
					cancelClose = mainContentView.onClose();
				if(options.onClose){
					options.onClose();
				}
				if(!cancelClose) {
					options.window && (options.window.__retval=false);
					ICABBI.navController.close(options.window);
				}
			});
			Theme.animateButton(btnBackMenu);
			header.add(btnBackMenu);
		}

		lblTitle = Ti.UI.createLabel({
		    text: options.title || '',
		    left: submitVisible ? 68 : 60,
		    right: submitVisible ? 68 : 60,
			color:Theme.childwindow.headerColor,
			font:options.header.font||Theme.childwindow.headerFont,
			textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		});
		header.add(lblTitle);

		var controls = Ti.UI.createView({
			backgroundColor: 'transparent',
			width:Ti.UI.SIZE,
			height: headerHeight,
			right:5,
			layout:'horizontal'
		});
		header.add(controls);
	
		var btnHeaderHeight = 40;
		// if(options.controls.right && options.controls.right.length){
			// _.each(options.controls.right,function(control){
				// var btn = new HeaderButton({
					// title:control.meta.title,
				// });
				// btn.left = 5;
// 				
				// btn.addEventListener('click',function(e){
					// setTimeout(function(){
						// control.onclick && control.onclick(e);
					// },13);
					// ICABBI.navController.close(options.window);
				// });
				// controls.add(btn);
			// });
		// };
		
		if(mainContentView && mainContentView.createHeaderRightControls){
			var buttons = mainContentView.createHeaderRightControls();
			Ti.API.info(buttons.length);
			_.each(buttons,function(control){
				controls.add(control);
			});
		};
		
		if(options.header.controls && options.header.controls.close && options.header.controls.close.visible){
			var btnClose = Ti.UI.createView({
				right:5,
				height:48,
				width:50,
				animateType:Theme.ANTIMATE_TYPE_OPACITY,
			});
			
			var closeIcon = Ti.UI.createImageView({
				height:30,
				width:50,
				left:0,
				touchEnabled:false,
				image:'/images/headers/icon_close_button.png',
			});
			btnClose.add(closeIcon);
			var closeLabel = Ti.UI.createLabel({
				text: 'Close',
				bottom:17,
			    left: 10,
				color:Theme.childwindow.buttonTextColor,
				font:Theme.childwindow.headerButtonFont,
			});
			btnClose.add(closeLabel);
			btnClose.addEventListener('click',function(e){
				//close the modal window
				if(options.onClose){
					options.onClose();
				}
				options.window && (options.window.__retval=false);
				ICABBI.SlidingMenu.fireEvent('openview', {index:ICABBI.Config.show_map?0:1});
				ICABBI.navController.close(options.window);
			});
			Theme.animateButton(btnClose);
			controls.right=0;
			controls.add(btnClose);
		}
		
		if(options.header.controls && options.header.controls.submit && options.header.controls.submit.visible){
			// var btnSubmit = new HeaderButton({
				// title:'Submit',
			// });
			// btnSubmit.left = 5;
// 			
			// btnSubmit.addEventListener('click',function(e){
				// mainContentView.fireEvent('modal:header:control:submit:click');
				// ICABBI.navController.close(options.window);
			// });
// 			
			// controls.add(btnSubmit);
			var btnSubmit = Ti.UI.createView({
				right:5,
				height:48,
				width:58,
				animateType:Theme.ANTIMATE_TYPE_OPACITY,
			});
			
			var submitIcon = Ti.UI.createImageView({
				height:31,
				width:58,
				left:0,
				touchEnabled:false,
				image:'/images/headers/icon_submit.png',
			});
			btnSubmit.add(submitIcon);
			var submitLabel = Ti.UI.createLabel({
				text: 'Submit',
			    left: 7,
				color:Theme.childwindow.buttonTextColor,
				font:Theme.childwindow.headerButtonFont,
			});
			btnSubmit.add(submitLabel);
			btnSubmit.addEventListener('click',function(e){
				mainContentView.fireEvent('modal:header:control:submit:click');
				
				var cancelClose = false;
				if(mainContentView && mainContentView.onSubmit)
					cancelClose = mainContentView.onSubmit();
				if(options.onSubmit){
					options.onSubmit();
				}
				if(!cancelClose) {
					ICABBI.navController.close(options.window);
				}
			});
			Theme.animateButton(btnSubmit);
			header.add(btnSubmit);
		}
		return header;		
	};
	var mainContentView;
	var createBody = function(view){
		//BODY
		
		var body = null;
		
		if(options.notScrollable)
			body = Ti.UI.createView($$.styl('Modal.body',{
				top: options.header.visible ? Theme.childwindow.headerHeight : 0,
			}));
		else
			body = Ti.UI.createScrollView($$.styl('Modal.body',{
				top: options.header.visible ? Theme.childwindow.headerHeight : 0,
				scrollType:'vertical',
  				contentHeight: 'auto',
			}));
//		var content = Ti.UI.createView($$.styl('Modal.content',{height:Ti.UI.SIZE}));

		mainContentView = new options.content({data:options.data,parent:{window:options.window,view:view,setTitle:function(t){
			if(lblTitle)
				lblTitle.setText(t);
			else
				options.title = t;
		},scroller:body}});
//		content.add(mainContentView);

//		body.add(content);
		body.add(mainContentView);
		return body;
	};
	
	var createView = function(){
		//create object instance, a parasitic subclass of Observable
		var container = Titanium.UI.createView($$.styl('Modal.container',{
	        // height:options.height || Ti.UI.FILL,
	        height:options.height || Ti.UI.FILL,
	    }));
		
		var body = createBody(container);
		if(options.header.visible){
			container.add(createHeader());
		}
		container.add(body);
		
		if(mainContentView.createFooter)
			mainContentView.createFooter(container);
		
		container.mainContentView = mainContentView;

		return container;
	};
	
	var self = createView();
	return self;
};

//Application Window Component Constructor
	/*
	 * [sonal]
	 * once evrything is working then see if a single modal window/view can serve all
	 * just changing the main content view MAY suffice
	 * but will have Look for mem leaks/perfomance..removing all event listeners on close
	 */
var ChildWindow = function(options) {
	options = options || {};
	options.heavyweight=true;
	
	var extras = {
		navBarHidden:true
	};

	if (Ti.Android && options.heavyweight) {
		extras.windowSoftInputMode = Ti.UI.Android.SOFT_INPUT_STATE_HIDDEN | Ti.UI.Android.SOFT_INPUT_ADJUST_RESIZE;
	}
	
	var self = Ti.UI.createWindow($$.styl('Modal.window',{
		title:options.title,
		__retval:true,
		backgroundColor:'#fff',
		top:Ti.IOSPlus?20:0
	},extras));
	
    self.orientationModes = [Ti.UI.PORTRAIT,Ti.UI.UPSIDE_PORTRAIT];
	//set the window
	options.window = self;
	
	var displayContainer = new ModalView(options); 
	self.add(displayContainer);
	
	var _open = self.open;
	self.open = function(){
		self.__retval=true;
		_open.apply(self,arguments);
	};

	var _close = self.close;
	self.close = function(){
		_close.apply(self,arguments);
	};
	self.addEventListener('open', function(e){
		// if any indicator is still up stop it
		$$.ActivityIndicator.stop();
	});

	self.addEventListener('android:back', function(e){
		var cancelClose = false;
		if(displayContainer.mainContentView && displayContainer.mainContentView.onClose){
			cancelClose = displayContainer.mainContentView.onClose();
		}
		if(options.onClose){
			options.onClose();
		}
		if(!cancelClose) {
			options.window && (options.window.__retval=false);
			
			var closeVisible = options.header && options.header.controls && options.header.controls.close && options.header.controls.close.visible,
				backVisible = options.header && options.header.controls && options.header.controls.cancel && options.header.controls.cancel.visible;
			
			if(closeVisible && !backVisible)
				ICABBI.SlidingMenu.fireEvent('openview', {index:ICABBI.Config.show_map?0:1});
			
			ICABBI.navController.close(options.window);
		}
	});

	return self;
};

//make constructor function the public component interface
module.exports = ChildWindow;

/*
 *
    var animationProperties = {delay: 1500, duration: 300, opacity: 0.1};
    if (Ti.Platform.osname == "iPhone OS") {
        animationProperties.transform = Ti.UI.create2DMatrix()
                                                     .translate(-200,200).scale(0);
    }
    infoWindow.animate(animationProperties, function(){ infoWindow.close(); });
 */