var _ = require('/lib/lodash')._ ,
	ICABBI = require('/core/icabbi');

var Theme = require('/ui/Theme');
var ActionButton = require('/ui/common/ActionButton');
var HeaderButton = require('/ui/common/HeaderButton');

var ClientAccountErrorView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			title:'Contact',
			logo:'icabbi.png',
			header: {visible:false},
			phoneNumber:'01 45678987',
			modal:false,
		};
	options = _.extend(defaults,options.data||{},{parent:options.parent||{}});
	
	var self = Ti.UI.createView({
        width:Ti.UI.FILL,
        height:Ti.UI.FILL,
		backgroundColor:'#fff',
	});
	
	// logo
	var logo = Ti.UI.createImageView({
		top:0,
		left : '10%',
		right : '10%',
		height : ((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		image:'/images/logo200.png',
	});
	self.add(logo);
	
	// powered by
	var powered = Ti.UI.createImageView({
		bottom:2,
		height:28,
		width:128,
		image:'/images/powered.png',
	});
	self.add(powered);
	
	// close button
	var controls = Ti.UI.createView({
		width:Ti.UI.SIZE,
		height: 44,
		top:1,
		right:0,
		layout:'horizontal',
	});
	self.add(controls);
	
	var btnClose = new HeaderButton({
		title:'Close',
		icon:'/images/headers/icon_close.png',
	});

	btnClose.addEventListener('click',function(e){
		ICABBI.navController.close(options.parent.window);
	});		
	controls.add(btnClose);
	
	// content positioning
	var content = Ti.UI.createView({
		top:5+((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		bottom:30,
		left:0,
		right:0,
	});
	self.add(content);
	
	var layoutListener = function(){
		self.removeEventListener('postlayout', layoutListener);
		logo.height = logo.rect.width;
		content.top = 5+logo.rect.width; 
	};
	self.addEventListener('postlayout',layoutListener);
	
	var contactBox = Ti.UI.createView({
		left:16,
		right:16,
		height:Ti.UI.SIZE,
		layout:'vertical',
	});
	content.add(contactBox);

	// text
	var firstLabel = Ti.UI.createLabel({
		left:0,
		right:0,
		height:Ti.UI.SIZE,
		color:Theme.global.fontColor,
		font:Theme.nav.buttonFont,
		text:'Sorry, you do not currently have an account set up with '+ICABBI.Config.Company.name,
		textAlign:'center',
	});
	contactBox.add(firstLabel);

	var secondLabel = Ti.UI.createLabel({
		left:0,
		right:0,
		height:Ti.UI.SIZE,
		color:Theme.global.fontColor,
		font:Theme.global.smallFont,
		text:'To set up an account or activate your number on an existing account please call us on '+ICABBI.Config.phone,
		textAlign:'center',
	});
	contactBox.add(secondLabel);
	
	// button
	var phoneButton = ActionButton({
		title:'PHONE',
		icon:'/images/buttons/icon_phone.png',
	});
	phoneButton.top = 10;
	contactBox.add(phoneButton);
	
	phoneButton.addEventListener('click',function(){
		Ti.Platform.openURL('tel:'+ICABBI.Config.phone.replace(/[^\d^+]/g, ''));
	});
	return self;
};

module.exports = ClientAccountErrorView;
