var _ = require('/lib/lodash')._ ,
	ICABBI = require('/core/icabbi');

var Theme = require('/ui/Theme');
var ActionButton = require('/ui/common/ActionButton');
var HeaderButton = require('/ui/common/HeaderButton');

var ContactView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			title:'Contact',
			logo:'icabbi.png',
			header: {visible:false},
			phoneNumber:'01 45678987',
			modal:false,
		};
	options = _.extend(defaults,options.data||{},{parent:options.parent||{}});
	
	var self = Ti.UI.createView({
        width:Ti.UI.FILL,
        height:Ti.UI.FILL,
		backgroundColor:'#ffffff',
	});
	
	// logo
	var logo = Ti.UI.createImageView({
		top:0,
		left : '10%',
		right : '10%',
		height : ((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		image:'/images/logo200.png',
	});
	self.add(logo);
	// powered by
	var powered = Ti.UI.createImageView({
		bottom:2,
		height:28,
		width:128,
		image:'/images/powered.png',
	});
	self.add(powered);
	
	// content positioning
	var content = Ti.UI.createView({
		top: ((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)) + 5,
		bottom:30,
		left:0,
		rigth:0,
	});
	self.add(content);
	var layoutListener = function(){
		self.removeEventListener('postlayout', layoutListener);
		logo.height = logo.rect.width;
		content.top = 5+logo.rect.width; 
	};
	self.addEventListener('postlayout',layoutListener);
	// text
	if(options.message){
		var message = Ti.UI.createLabel({
			top:20,
			left:16,
			right:16,
			// width:Ti.UI.SIZE,
			height:Ti.UI.SIZE,
			textAlign:'center',
			color:Theme.global.fontColor,
			font:Theme.nav.buttonFont,
			touchEnabled:false,
			text:options.message
		});
		content.add(message);
	}
	
	var contactBox = Ti.UI.createView({
		height:90,
		width:Ti.UI.SIZE,
	});
	content.add(contactBox);
	
	// button
	var phoneButton = ActionButton({
		title:'PHONE',
		icon:'/images/buttons/icon_phone.png',
	});
	phoneButton.left = 0;
	phoneButton.top = 12;
	contactBox.add(phoneButton);
	
	phoneButton.addEventListener('click',function(){
		Ti.Platform.openURL('tel:'+ICABBI.Config.phone.replace(/[^\d^+]/g, ''));
	});

	// text
	var phoneLabel = Ti.UI.createLabel({
		top:0,
		left:80,
		right: 10,
		width: Ti.UI.FILL,
		height:28,
		color:Theme.global.fontColor,
		font:Theme.nav.buttonFont,
		text:ICABBI.Config.phone,
	});
	contactBox.add(phoneLabel);
	
	var websiteLabel = Ti.UI.createLabel({
		top:24,
		left:80,
		right: 10,
		width: Ti.UI.FILL,
		height:28,
		color:'#1e0fbe',
		font:Theme.nav.buttonFont,
		text:ICABBI.Config.Company.web,
		ellipsize : true,
		wordWrap : false
	});
	websiteLabel.addEventListener('click', function(e) { Titanium.Platform.openURL(ICABBI.Config.Company.web); }); 
	contactBox.add(websiteLabel);
	
	if(ICABBI.Config.app_show_address)
	{
		var addressLabel = Ti.UI.createLabel({
			top:48,
			left:80,
			right: 10,
			width: Ti.UI.FILL,
			height:28,
			color:Theme.global.fontColor,
			font:Theme.nav.buttonFont,
			text:ICABBI.Config.Company.address,
		});
		contactBox.add(addressLabel);
		
		var cityLabel = Ti.UI.createLabel({
			top:72,
			left:80,
			right: 10,
			width: Ti.UI.FILL,
			height:18,
			color:Theme.global.fontColor,
			font:Theme.global.smallFont,
			text:ICABBI.Config.Company.city,
		});
		contactBox.add(cityLabel);
	}
	ICABBI.Controller.on('application:reset',function(data){
		phoneLabel.setText(ICABBI.Config.phone);
	});
	return self;
};

module.exports = ContactView;
