var	ICABBI = require('/core/icabbi'),
	ChildWindow = require('/ui/common/ChildWindow');

var _ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

var Theme = require('/ui/Theme');
var HeaderButton = require('/ui/common/HeaderButton');
var ActionButton = require('/ui/common/ActionButton');

//CreditCardsView Component Constructor
var CreditCardsView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			title:'My Credit Cards',
		};
	options = _.extend(defaults,options.data||{});
	
	var platformWidth = ICABBI.width;
	//var headerHeight = 30;
	var table;
	var creditcards = ICABBI.Controller.getUser().creditcards; 

	var addCreditCard = function() {
		var CreditCardRegistrationView = require('/ui/common/CreditCardRegistrationView');
			var config  = {content:CreditCardRegistrationView,title:'Add Card',data:{}};
		    var win = new ChildWindow(config);
		    ICABBI.navController.open(win,undefined,self);
	};
	
	// var createHeader = function(header){
		// var btnAdd = new HeaderButton({
			// title:'Add',
			// icon:'/images/headers/icon_add.png',
		// });
		// btnAdd.right = 12;
// 		
		// btnAdd.addEventListener('click',function(e){
			// if (ICABBI.navController.opening(self)) {
				// return;
			// }
			// addCreditCard();
		// });
		// header.add(btnAdd);
	// };
	
	var createTableViewRow = function(creditcard){
		var row = Ti.UI.createTableViewRow({
			height:50,
			backgroundColor:'transparent',
			selectionStyle:Ti.Android?undefined:Ti.UI.iPhone.TableViewCellSelectionStyle.GRAY,
	  	    __creditcard:creditcard.get('id'),
		});
		var lblNumber = Ti.UI.createLabel({
			left:15,
			right:120,
			height:28,
			color:Theme.global.fontColor,
			font:Theme.menu.rowFont,
			minimumFontSize:Theme.menu.rowFont.fontSize,
			wordWrap:false,
			text:creditcard.get('nickname'),
			touchEnabled:false,
		});
		row.add(lblNumber);
		
		/*
		 * Delete button
		 */
		var btnDelete = Ti.UI.createButton({
			deleteBtn:true,
			right:16,
			width:77,
			height:30,
			backgroundColor:Theme.global.buttonBGColor,
			borderColor:Theme.global.highlightColor,
			backgroundFocusedColor:Theme.global.highlightColor,
			backgroundSelectedColor:Theme.global.highlightColor,
			borderWidth:1,
			borderRadius:8,
			color:Theme.global.fontColor,
			font:Theme.form.buttonFont,
			title:'DELETE',
	  	    style:Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		});
		Theme.animateButton(btnDelete);
		row.add(btnDelete);
		
		var rowLine = Ti.UI.createView({
			left:0,
			right:0,
			bottom:0,
			height:'1px',
			backgroundColor:Theme.global.altBGColor,
			touchEnabled:false,
		});
		row.add(rowLine);

		return row;
	};
	
	var create = function(){
		//first append right button to header
		var header = options.__parent.header;
		//createHeader(header);
		
		var content = Ti.UI.createView({
			backgroundColor:'#fff',
			top:0,
			bottom:0,
			left:0,
			right:0,
		});

		table = Ti.UI.createTableView({
			backgroundColor:'#fff',
			separatorColor:'transparent',
			separatorStyle:Ti.UI.Android ? undefined : Ti.UI.iPhone.TableViewSeparatorStyle.NONE,
			allowsSelection:Ti.Android,
			top:0,
			bottom:0,
			left:0,
			right:0,
		});
		
		content.add(table);
		
		var footerBg = Ti.UI.createView({
			bottom:0,
			left:0,
			right:0,
			height: 81,
			backgroundColor: 'black',
			opacity: 0.10,
		});

		content.add(footerBg);

		var footer = Ti.UI.createView({
			bottom:0,
			left:0,
			right:0,
			height: 81,
			
			//zIndex: 11,
		});

		var footerBorderGray = Ti.UI.createView({
			top: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.listBottomLineColor,
		});
		footer.add(footerBorderGray);
		
		var footerBorderWhite = Ti.UI.createView({
			top: 1,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.listTopLineColor,
		});
		footer.add(footerBorderWhite);

		var controlBar = Ti.UI.createView({
	        height:65,
	        width:Ti.UI.SIZE,
	        layout:'horizontal',
	        top: 9,
	    });
	    footer.add(controlBar);
	    
		var btnAdd = new ActionButton({title:'Add',icon:'/images/buttons/icon_add.png'});
		controlBar.add(btnAdd);
		btnAdd.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			addCreditCard();
		});
		content.add(footer);
		
		return content;
	};

	var self = create();

	(function(){
		self.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			var row = e.row;
			if(row && row.__creditcard)
			{
				var creditcard = creditcards.get(row.__creditcard);
	
				if (e.source.deleteBtn) {
					ICABBI.navController.showYesNo({
					    title:'Delete Card!',
					    message:'Are you sure you want to delete this card?',
					    click : function(e){
					    	if(e.index == 1) {
								//destroy card
								creditcard.destroy({
									url:'creditcards/delete/' + creditcard.get('id')
								});
							}
							self.opening = false;
					    }
					});
					return;
				}
			}
			self.opening = false;
			/*
			var ChildWindow = require('/ui/common/ChildWindow');
			var CreditCardRegistrationView = require('/ui/common/CreditCardRegistrationView');
			
			setTimeout(function(){
				config = {
						content:CreditCardRegistrationView,
						title:'Edit Card',
						data:{creditcard:creditcard},
					};
				
				var win = new ChildWindow(config);
				ICABBI.navController.open(win,undefined,self);
			},13);*/
		});
		//changing Collection:reset to this as that was blocking UI
		//may have scope for further optimization or another way
		var populate = function(){
			table.deleteSection(0);
			// $$.ActivityIndicator.start('Getting Your Cards');
			setTimeout(function(){
				if(self.visible && creditcards.length == 0)
					addCreditCard();
				else
					creditcards.each(function(creditcard){ 
						table.appendRow(createTableViewRow(creditcard));
					}); //each
				// $$.ActivityIndicator.stop();
			},13);
		};
		
		if(creditcards.fetched) populate();

		//if creditcards are fetched before viewload
		creditcards.on('cleared',function(e){
			if(table && table.data && table.data.length){
				table.deleteSection(0);
			}
		});
		//new		
		creditcards.on('add',function(creditcard){
			table.appendRow(createTableViewRow(creditcard));
		});		
		creditcards.on('remove',function(creditcard){
			creditcard.off();
			for(var i=0;i<table.data[0].rowCount;i++){
				var row = table.data[0].rows[i];
				if(row.__creditcard == creditcard.get('id')){
					table.deleteRow(i);
					break;
				}
			}
		});

		creditcards.on('fetched',function(e){
			//self.addEventListener('slidingmenu:view:load',function(e){
			//	self.removeEventListener('slidingmenu:view:load',arguments.callee);
				populate();
			//});
		});
	})();

	
	self.addEventListener('slidingmenu:view:load',function(e){
			setTimeout(function(){
				if(creditcards.fetched && creditcards.length == 0)
					addCreditCard();
			}, 13);
		}); 
	
	return self;
};

module.exports = CreditCardsView;
