/**
 * @author Sonal
 * DriverNoteView
 */

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');
	mds = require('/model/MemoryDataStore');


//DriverNoteView Component Constructor
var DriverNoteView = function(options) {
	options = options || {};
	var storeItemKey = options.data.storeItemKey||'drivernote';
	
	var createForm = function(){
		//create object instance, a parasitic subclass of Observable
		var view = Titanium.UI.createView({
	        height:options.height || Ti.UI.FILL,
	        width:options.width || Ti.UI.FILL,
			layout:'vertical'
	    });

		var lblDriverNote = Ti.UI.createLabel($$.styl('label','Modal.label',{
		    text: 'Add a Note for your Driver',
		    height:30,
		    top:0,
		    left:0,
		    width:Ti.UI.SIZE,
	  	    font:{fontSize:16,fontWeight:'bold'},
		}));
		view.add(lblDriverNote);
		
		var fldDriverNote = Ti.UI.createTextArea($$.styl('textArea',{
			font: {fontSize:16, fontWeight:'bold'},
			top: 5, 
			left:0,
			width: Ti.UI.FILL,
			height : 100,
			value: mds.getObject(storeItemKey,{text:''}).text
		}));

		view.add(fldDriverNote);
/*
		var controlBar = Titanium.UI.createView({
	        height: Ti.UI.SIZE,
	        width: Ti.UI.FILL,
	        top:10,
	    });
	    view.add(controlBar);
		var btnSave = Ti.UI.createButton($$.styl('Modal.button',{
			title: 'Save',
			top:10,
			height: 50,
			width: 80,
		}));
		$$.animateButton(btnSave);

		btnSave.addEventListener('click',function(e){
			//MemoryDataStore
			var driverNote = {
							text: fldDriverNote.getValue()
					};
			
			mds.setObject(storeItemKey,driverNote);
			//close the modal window
			options.parent.window && options.parent.window.close();
			options.parent.window = null;
		});

		view.add(btnSave);
*/
		view.close = function(){
			fldDriverNote.blur();
		};
		view.getValue = function(){
			return {
				text: fldDriverNote.getValue()
			};
		};

		return view;
	} 
	
	var self = createForm();
	self.addEventListener('modal:header:control:submit:click',function(e){
		var driverNote = self.getValue();
		mds.setObject(storeItemKey,driverNote);
		self.close();
	});

	return self;
};

module.exports = DriverNoteView;
