/**
 * @author Sonal 
 */

var ICABBI = require('/core/icabbi');
var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

//FavouritesPickerView Component Constructor
var FavouritesPickerView = function(options) {
	options = options || {};
	var table,
		addressFrom = options.data.addressFrom,
		addressTo = options.data.addressTo;

	
	var createLabel = function(options){
		var label = Ti.UI.createLabel($$.styl('label','Modal.label',{
		    height:Ti.UI.FILL,
		    left:0,
		    width:80,//Ti.UI.FILL
	  	    font:{fontSize:14,fontWeight:'bold'},
		},options)
		);
		return label;
	};
	
	var createNRFRow = function(){
		var row = Titanium.UI.createTableViewRow({
			top:4,
	        height: Ti.UI.SIZE,//40,
	        width: Ti.UI.FILL,
			backgroundColor:'transparent',
			selectionStyle:Ti.Android?undefined:Ti.UI.iPhone.TableViewCellSelectionStyle.GRAY,
			__booking: 'nrf',
			visible: false,
	    });
		var cell = Titanium.UI.createView({
			height: Ti.UI.SIZE,
			width: Ti.UI.FILL,
			top:0,
		});
		var lblContent = createLabel({
			text:'No Favourite Bookings!',
//		 	color:'#000',
			left:0,
			height:Ti.UI.SIZE, 
			width:Ti.UI.FILL,
			textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
			font: {
				fontSize:14,
				// fontWeight:'bold'
			}
		});
		cell.add(lblContent);
		row.add(cell);
	
		return row;
	};
	var createTableViewRow = function(booking){
	    var createCell = function(data,options){
			var cell = Titanium.UI.createView(_.extend({
		        height: Ti.UI.SIZE,
		        width: '40%',
				layout:'vertical'
		    },options));
			cell.add(createLabel({
			 	text:data.heading+':',
			 	color:'#888',
			 	left:0,
			 	width:Ti.UI.FILL,
			 	height:Ti.UI.SIZE, 
		  	    font:{fontSize:12,fontWeight:'bold'}
		 	}));
		 	var lblContent = createLabel({
			 	text:data.content,
			 	left:0,
			 	height:Ti.UI.SIZE, 
			 	width:Ti.UI.FILL,
		  	    font: data.font || {fontSize:14,fontWeight:'bold'}
		 	});
			cell.add(lblContent);
		    return {cell:cell,label:lblContent};
	 	};
		var row = Titanium.UI.createTableViewRow({
			top:4,
	        height: Ti.UI.SIZE,//40,
	        width: Ti.UI.FILL,
			backgroundColor:'transparent',
			selectionStyle:Ti.Android?undefined:Ti.UI.iPhone.TableViewCellSelectionStyle.GRAY,
			//rowData: {},
			__booking: booking.get('perma_id')
	    });

		var data = {heading:'',content:''};
		
		//column1 
		data.heading='From';
		// data.content=booking.formatAddressDisplay('address');
		data.content=booking.get('address').formatted;
		var col1 = createCell(data,{left:5}); 
		row.add(col1.cell);
		
		//column2 
		data.heading='To';
		// data.content=booking.formatAddressDisplay('destination');
		data.content=booking.get('destination').formatted;
		var col2 = createCell(data,{right:15}); 
		row.add(col2.cell);

	    return row;
	};

	var createTableView = function(title){
		var table = Ti.UI.createTableView({
			//backgroundImage:'/images/table_bg.png',
			separatorStyle:Ti.Android ? 0 : Ti.UI.iPhone.TableViewSeparatorStyle.NONE,
			allowsSelection:Ti.Android,
			top:10,
			left:0,
			width: Ti.UI.FILL,
			height: Ti.UI.SIZE,
			separatorColor: '#000',
		});
		return table;
	};

	var createForm = function(){
		var view = Titanium.UI.createView({
	        height:options.height || Ti.UI.FILL,
	        width:options.width || Ti.UI.FILL,
			layout:'vertical'
	    });
		var scroll = Ti.UI.createScrollView({
		    contentWidth:'auto',//Ti.UI.FILL,
		    contentHeight:'auto',//Ti.UI.FILL,
		    showVerticalScrollIndicator:false,
		    showHorizontalScrollIndicator:false,
		    top:0,
		    left:0,
		    scrollType: 'vertical',
		    layout:'vertical'
		});
		
		table = createTableView();
		scroll.add(table);
		
		view.add(scroll);
		return view;
		
	} 
	
	var self = createForm();
	
	(function(){
		var	bookingsActive = ICABBI.Controller.getUser().bookings, 
			bookingsUpcoming = ICABBI.Controller.getUser().bookingsUpcoming, 
			bookingsPrevious = ICABBI.Controller.getUser().bookingsPrevious; 

		var appendRow = function(booking){
			var row = createTableViewRow(booking);
			table.appendRow(row);
		};
		$$.ActivityIndicator.start('Getting Your Favourites');
		var favourites = _.union(
							bookingsActive.fetchFavourites(),
							bookingsUpcoming.fetchFavourites(),
							bookingsPrevious.fetchFavourites()
						);
		if(!favourites.length){
			table.appendRow(createNRFRow());
			return;
		}
		//on dialog load..get all the booking from sqlite and get addresses from 3booking bucket
		_.each(favourites,function(booking){ 
				appendRow(booking);
		}); //each
		$$.ActivityIndicator.stop();

		table.addEventListener('click',function(e){
			var row = e.row;
			var booking = bookingsActive.get(row.__booking)||bookingsUpcoming.get(row.__booking)||bookingsPrevious.get(row.__booking);
			addressFrom.set(booking.get('address'));
			addressTo.set(booking.get('destination'));
			setTimeout(function(){
				ICABBI.navController.close(options.parent.window);
			},13);
		});
	})();
	return self;
};

module.exports = FavouritesPickerView;
