/**
 * @author Sonal
 * FeedbackView
 */

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');


//FeedbackView Component Constructor
var FeedbackView = function(options) {
	options = options || {};
	var booking = options.data.booking;
	var RATING = {OK:1, BAD:1, GOOD:2};
	
	var createForm = function(){
		//create object instance, a parasitic subclass of Observable
		var view = Titanium.UI.createView({
	        height:options.height || Ti.UI.FILL,
	        width:options.width || Ti.UI.FILL,
			layout:'vertical'
	    });

		var lblFeedback = Ti.UI.createLabel($$.styl('label','Modal.label',{
		    text: 'We value feedback from our customers. Please tell us what you think of our service',
		    height:Ti.UI.SIZE,
		    width:Ti.UI.SIZE,
	  	    font:{fontSize:16,fontWeight:'bold'},
		}));
		view.add(lblFeedback);
		
		/*
		 * Control button
		 */		
		var controlBar = Titanium.UI.createView({
	        height: 60,
	        width: Ti.UI.SIZE,
	        top:10,
	        right:0,
			layout:'horizontal',
	    });
  		view.add(controlBar);

		var createButton = function(options){
			var btnWidth=60;
			var btn = Ti.UI.createButton({
				title: '',
				color:'white',
				right:10,
				height: btnWidth,
				width: btnWidth,
//				textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
				backgroundColor : '#fff',
			    borderColor:'transparent',
			    borderWidth:2,
			    borderRadius:4,
				image: options.image,
				__rating:options.rating				
			});
			return btn;
		}
//		var barRatings = {};
//		barRatings.btnGOOD = createButton({image:'/images/rating/good.png'});
//		barRatings.btnOK = createButton({image:'/images/rating/ok.png'});
//		barRatings.btnBAD = createButton({image:'/images/rating/bad.png'});

		var RATING = {OK:{val:0,image:'ok.png'},BAD:{val:1,image:'bad.png'},GOOD:{val:2,image:'good.png'}};
		var oldRating,currentRating = '';

		_.each(RATING,function(item,key){
			var btn= createButton({rating:item.val,image:'/images/rating/'+item.image});
			RATING[key].btn = btn;
			controlBar.add(btn);
			btn.addEventListener('click',function(e){
				currentRating && RATING[currentRating].btn.applyProperties({borderColor:'transparent'});;
				btn.applyProperties({borderColor:'#f15315'});
				currentRating = key;
			});
		});

		var fldFeedback = Ti.UI.createTextArea($$.styl('textArea',{
			font: {fontSize:16, fontWeight:'bold'},
			top: 15, 
			width: Ti.UI.FILL,
			height : 120,
			value: '',
		}));

		view.add(fldFeedback);

		var btnSave = Ti.UI.createButton($$.styl('Modal.button',{
			title: 'Save',
			top:15,
			right: 10,
			height: 40,
			width: 80,
		}));
		
		btnSave.addEventListener('click',function(e){
			var form = {
				rating 	: RATING[currentRating].val,
				text	: fldFeedback.getValue()
			}
			Ti.API.info(JSON.stringify(form));
			$$.ActivityIndicator.start('Thank You for Submitting Your Feedback');
			booking.setFeedback(form,{
				success: function(){
					//close this
					setTimeout(function(){
						ICABBI.navController.close(options.parent.window);
					},100);
				}
			});
		});

		view.add(btnSave);

		return view;
	} 
	
	var self = createForm();
	return self;
};

module.exports = FeedbackView;

