var _ = require('/lib/lodash')._ ,
	ICABBI = require('/core/icabbi');

var Theme = require('/ui/Theme');
var ActionButton = require('/ui/common/ActionButton');
var HeaderButton = require('/ui/common/HeaderButton');

var FleetSelectView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			
		};
	options = _.extend(defaults,options.data||{},{parent:options.parent||{}});
	
	var self = Ti.UI.createView({
        width:Ti.UI.FILL,
        height:Ti.UI.FILL,
		backgroundColor:'#fff',
	});
	
	// logo
	var logo = Ti.UI.createImageView({
		top:0,
		left : '10%',
		right : '10%',
		height : ((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		image:'/images/logo200.png',
	});
	
	self.add(logo);
	// powered by
	var powered = Ti.UI.createImageView({
		bottom:2,
		height:28,
		width:128,
		image:'/images/powered.png',
	});
	self.add(powered);
		
	// content positioning
	var content = Ti.UI.createView({
		top:5+((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		bottom:30,
		left:0,
		rigth:0,
		layout: 'vertical'
	});
	self.add(content);

	var layoutListener = function(){
		self.removeEventListener('postlayout', layoutListener);
		logo.height = logo.rect.width;
		content.top = 5+logo.rect.width; 
	};
	self.addEventListener('postlayout',layoutListener);
	
	var message = Ti.UI.createLabel({
		top:10,
		left:30,
		right:30,
		height:Ti.UI.SIZE,
		textAlign:'center',
		color:Theme.fleetSelect.fontColor,
		font:Theme.fleetSelect.font,
		touchEnabled:false,
		text:'Please select your location'
	});
	content.add(message);
	var scrollView =  Ti.UI.createScrollView({
		scrollType:'vertical',
		left:30,
		right:30,
	}); 
	content.add(scrollView);
	var fleetBox = Ti.UI.createView({
		left:0,
		right:0,
		layout: 'vertical'
	});
	scrollView.add(fleetBox);
	
	var createFleetButton = function(client) {
		var button = Ti.UI.createView({
			top: 10,
		    left: 0,
		    right: 0,
		    height: 50,
		    borderRadius:10,
		    backgroundGradient: {
		        type: 'linear',
		        startPoint: { x: '0%', y: '0%' },
		        endPoint: { x: '0%', y: '100%' },
		        colors: [ { color: '#cccccc', offset: 0.0}, { color: '#ffffff', offset: 0.5 }, { color: '#cccccc', offset: 1.0 } ],
		    }
		});
		button.client = client;
		var label = Ti.UI.createLabel({
			text: client.name,
			right: 0,
		    left: 0,
		    top : 10,
		    bottom : 10,
		    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
			color:Theme.fleetSelect.buttonTextColor,
			font:Theme.fleetSelect.buttonFont,
		});
		button.add(label);
		button.addEventListener('click',function(e){
			if (ICABBI.navController.opening(self)) {
				return;
			}
			$$.ActivityIndicator.start('Loading location...!');
			ICABBI.Config.IcabbiApi.APP_KEY = button.client.publickey;
			Ti.App.Properties.setString('LocationPublicKey', button.client.publickey);
			Ti.API.error(Ti.App.Properties.getString("LocationPublicKey", null));
			ICABBI.startApplication(true);
			self.opening = false;
		});
		Theme.animateButton(button);
			
		return button;
	};

	var loadFleet = function() {
		if(ICABBI.Config.fleet != null && ICABBI.Config.fleet.length > 0)
			ICABBI.Config.fleet.forEach(function(client) {
				fleetBox.add(createFleetButton(client));
			});
	};
	
	loadFleet();
	
	return self;
};

module.exports = FleetSelectView;
