var Theme = require('/ui/Theme');

var FormCheckboxRow = function(args){
	args.value = args.value||false;
	args.labelView = args.labelView||Ti.UI.createView();
	args.checkWidth = args.checkWidth || 65;
	args.labelCheck = args.labelCheck || false;

	args.top = args.top || 15;
	args.bottom = args.bottom || 0;
	args.left = args.left || 0;
	args.right = args.right || 0;
	
	var self = Ti.UI.createView({
		left:args.left,
		right:args.right,
		top:args.top,
		bottom:args.bottom,
		height:Ti.UI.SIZE,
		value:args.value,
	});
	
	var checkView = Ti.UI.createView({
		left:0,
		height:33, // minimum height for the row
		width:args.checkWidth,
	});
	self.add(checkView);
	
	var checkImage = Ti.UI.createImageView({
		right:0,
		height:27,
		width:27,
		image:self.value?'/images/buttons/check.png':'/images/buttons/check_off.png',
		touchEnabled:false,
	});
	checkView.add(checkImage);

	self.putValue = function(val) {
		self.value = val;
		checkImage.image = self.value?'/images/buttons/check.png':'/images/buttons/check_off.png';
	};
	
	var checkFunction = function(){
		if(args.disabled)
			return;
		self.value = !self.value;
		
		checkImage.image = self.value?'/images/buttons/check.png':'/images/buttons/check_off.png';
		self.fireEvent('change',{value:self.value});
	};
	checkView.addEventListener('click', checkFunction);
	
	if(args.labelCheck) {
		args.labelView.addEventListener('click', checkFunction);
	}
	
	var labelArea = Ti.UI.createView({
		left:args.checkWidth+15,
		right:16,
		height:Ti.UI.SIZE,
	});
	self.add(labelArea);
	labelArea.add(args.labelView);
	
	return self;
};

module.exports = FormCheckboxRow;