var ICABBI = require('/core/icabbi'), 
	Theme = require('/ui/Theme');

var FormTextareaRow = function(args){
	args.value = args.value||'';
	
	var self = Ti.UI.createView({
		left:8,
		right:8,
		height:88,
		value:args.value,
	});
	
	var label = Ti.UI.createLabel({
		left:0,
		height:21,
		top:(44-21)/2,
		width:45,
		color:Theme.form.labelColor,
		font:Theme.form.labelFont,
		text:args.label,
		textAlign:'right',
		touchEnabled:false,
	});
	self.add(label);

	self.showPredefinedBtn = function() {};
	self.hidePredefinedBtn = function() {};

	if(args.predefinedValues) {
		self.predefinedView = Ti.UI.createView({
			right:0,
			top:1,
			height:41,
			width:40,
			visible: false,
		    backgroundColor:'#f1f1f1',
			borderRadius:6,
			borderWidth:1,
			borderColor:'#f1f1f1',
			zIndex:12,
		});
		self.add(self.predefinedView);
		self.predefinedBtn = Ti.UI.createImageView({
			top: 4,
			right: 1,
			height:35,
			width:35,
			image:'/images/buttons/icon_addnote.png'			
		});
		self.predefinedView.add(self.predefinedBtn);
		
		self.showPredefinedBtn = function() {
			//self.predefinedView.show();
			self.predefinedView.visible = true;
			//hint.applyProperties({left: 95});
			//note.applyProperties({left: 90});
		};
		self.hidePredefinedBtn = function() {
			//self.predefinedView.hide();
			self.predefinedView.visible = false;
			//hint.applyProperties({left: 70});
			//note.applyProperties({left: 60});
		};
	}
		
	var hint = Ti.UI.createLabel({
		//left: args.predefinedValues ? 95 : 70,
		left:70,
		right:15,
		top:15,
		height:Ti.UI.SIZE,
		color:Theme.global.fontColor,
		font:Theme.form.helpFont,
		value:args.value,
		text:args.hint,
		touchEnabled:false,
		visible:!self.value.length,
		zIndex:20,
	});
	self.add(hint);

	var noteWrapper = Ti.UI.createView({
		left:60,
		right:5,
		top:5,
		bottom:5,
		backgroundColor:Theme.form.inputBGColor,
		borderRadius:10,
		zIndex:10,
	});
	self.add(noteWrapper);
	var note = Ti.UI.createTextArea({
		left:0,
		right:args.predefinedValues ? 40 : 0,
		top:0,
		bottom:0,
		backgroundColor:Theme.form.inputBGColor,
		color:Theme.global.fontColor,
		borderRadius:10,
		font:Theme.menu.rowFont,
		minimumFontSize:Theme.menu.rowFont.fontSize,
		returnKeyType:Ti.UI.RETURNKEY_DONE,
		softKeyboardOnFocus : Ti.Android?Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS:undefined,
		value:self.value,
		zIndex:11,
	});
	noteWrapper.add(note);

	var rowLineTop = Ti.UI.createView({
		left:args.label.length?60:0,
		right:11,
		top:0,
		height:1,
		backgroundColor:Theme.global.listTopLineColor,
		visible:!args.firstItem,
		touchEnabled:false,
	});
	self.add(rowLineTop);
	
	self.hideKeybord = function(){
		note.blur();
	};
	// if (Ti.Android) {
	    // note.addEventListener('click', function() {
			// hint.visible = false;
	        // note.softKeyboardOnFocus = Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS;
	        // note.focus();
	    // });
// 	    
	    // note.addEventListener('blur', function() {
			// hint.visible = !self.value.length;
	        // note.softKeyboardOnFocus = Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS;
	    // });
	// } else {
		note.addEventListener('focus',function(){
			hint.visible = false;
		});
		note.addEventListener('blur',function() {
			var value = self.value.trim();
			note.setValue(value);
			hint.visible = !value.length;
		});
	// }
	
	// note.addEventListener('return',function() {
		// note.blur();
		// hint.visible = !self.value.length;
	// });
	
	note.addEventListener('change',function(e){
		self.value = e.value;
	});
	self.putValue = function(value) {
		if(!value)
			value = '';
		note.setValue(value);
		self.value = value;
		hint.visible = !value.length;
		note.blur();
	};
	self.getValue = function() {
		return note.getValue();
	};
	var rowLine = Ti.UI.createView({
		left:60,
		right:0,
		bottom:0,
		height:'1',
		backgroundColor:Theme.global.listBottomLineColor,
		visible:!args.lastItem,
		touchEnabled:false,
	});
	self.add(rowLine);
	
	return self;
};

module.exports = FormTextareaRow;
