var Theme = require('/ui/Theme');

var FormTextfieldrRow = function(args){
	args.value = args.value||'';
	args.hint = args.hint||'';
	args.passwordMask = args.passwordMask||false;
	args.keyboardType = args.keyboardType||Ti.UI.KEYBOARD_DEFAULT;
	args.autocapitalization = args.autocapitalization||false;
	args.autocorrect = args.autocorrect||false;
	args.returnKeyType = args.returnKeyType||Ti.UI.RETURNKEY_DEFAULT;
	args.hasLabel = args.hasLabel;
	
	var self = Ti.UI.createView({
		left:0,
		right:0,
		top:15,
		height:38,
		value:args.value,
	});
	
	var label = Ti.UI.createLabel({
		left:0,
		height:21,
		width:68,
		color:Theme.form.labelColor,
		font:Theme.form.labelFont,
		text:args.label,
		textAlign:'right',
		touchEnabled:false,
	});
	if(args.hasLabel!=false) {
		self.add(label);
	}
	
	var input = Ti.UI.createTextField({
		left:(args.hasLabel===false&&!args.moveContent) ? 16 : 80,
		right:16,
		height:38,
		backgroundColor:Theme.form.inputBGColor,
		borderRadius:10,
		color:Theme.global.fontColor,
		font:Theme.menu.rowFont,
		minimumFontSize:Theme.menu.rowFont.fontSize,
		paddingLeft:10,
		paddingRight:10,
		hintText:args.hint,
		value:self.value,
		// keyboard stuff
		clearButtonMode:args.clearButtonMode,
		clearOnEdit:args.clearOnEdit,
		keyboardType:args.keyboardType,
		passwordMask:args.passwordMask,
		returnKeyType:args.returnKeyType,
		autocapitalization:args.autocapitalization,
		autocorrect:args.autocorrect,
		verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
		keyboardToolbar:args.keyboardToolbar,
		editable: args.editable !== undefined ? args.editable : true,
		touchEnabled: true
	});
	self.add(input);
	
	if(args.editable === false && args.click && typeof args.click == 'function'){
		var clickView = Ti.UI.createView({
			left:(args.hasLabel===false) ? 16 : 80,
			right:16,
			height:38,
			zIndex: 5,
			touchEnabled: true,
		});		
		self.add(clickView);
		clickView.addEventListener('click', args.click);
	}
	if(args.editable === false && args.focus && typeof args.focus == 'function'){
		input.addEventListener('touchend', args.focus);
	}

	self.done = function(){
		input.blur();
	};
	
	self.putValue = function(val) {
		input.value = self.value = val;
	};
	
	input.addEventListener('change',function(e){
		self.value = e.value;
	});
	
	// interaction handlers
	if (args.prevField) {
		args.prevField.addEventListener('return',function(){
			input.focus();
		});
	}
	
	self.doFocus = function() {
		input.focus();
	};
	self.doBlur = function() {
		input.blur();
	};
	
	return self;
};

module.exports = FormTextfieldrRow;
