var Theme = require('/ui/Theme');

var HeaderButton = function(args){
	var self = Ti.UI.createView({
		width:Ti.UI.SIZE,
		height:44,
		animateType:Theme.ANTIMATE_TYPE_OPACITY,
	});
	
	var title = Ti.UI.createLabel({
		top:Ti.Android ? 6:8,
		left:2,
		right:args.icon?25:8,
		height:28,
		width:Ti.UI.SIZE,
		color:Theme.nav.buttonColor,
		font:Theme.nav.buttonFont,
		touchEnabled:false,
		text:args.title,
	});
	self.add(title);
	
	if (args.icon) {
		var icon = Ti.UI.createImageView({
			height:15,
			width:15,
			right:8,
			touchEnabled:false,
			image:args.icon,
		});
		self.add(icon);
	}
	
	if (args.closeButton) {
		self.top = Ti.Android ? 3 :2;
		icon.top = Ti.Android ? 13 :15;
	}
	Theme.animateButton(self);
	
	return self;
};

module.exports = HeaderButton;
