var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

var Theme = require('/ui/Theme');
var FormTextfieldRow = require('/ui/common/FormTextfieldRow');
var ActionButton = require('/ui/common/ActionButton');
var FormCheckboxRow = require('/ui/common/FormCheckboxRow');

//LoginView Component Constructor
var LoginView = function(options) {
	var countries = [
		{id:"44" , title:"UK (+44)"},
		{id:"353" , title:"Ireland (+353)"},
		{id:"49" , title:"Germany (+49)"},
		{id:"213" , title:"Algeria (+213)"},
		{id:"376" , title:"Andorra (+376)"},
		{id:"244" , title:"Angola (+244)"},
		{id:"1264" , title:"Anguilla (+1264)"},
		{id:"1268" , title:"Antigua &amp; Barbuda (+1268)"},
		{id:"54" , title:"Argentina (+54)"},
		{id:"374" , title:"Armenia (+374)"},
		{id:"297" , title:"Aruba (+297)"},
		{id:"61" , title:"Australia (+61)"},
		{id:"43" , title:"Austria (+43)"},
		{id:"994" , title:"Azerbaijan (+994)"},
		{id:"1242" , title:"Bahamas (+1242)"},
		{id:"973" , title:"Bahrain (+973)"},
		{id:"880" , title:"Bangladesh (+880)"},
		{id:"1246" , title:"Barbados (+1246)"},
		{id:"375" , title:"Belarus (+375)"},
		{id:"32" , title:"Belgium (+32)"},
		{id:"501" , title:"Belize (+501)"},
		{id:"229" , title:"Benin (+229)"},
		{id:"1441" , title:"Bermuda (+1441)"},
		{id:"975" , title:"Bhutan (+975)"},
		{id:"591" , title:"Bolivia (+591)"},
		{id:"387" , title:"Bosnia Herzegovina (+387)"},
		{id:"267" , title:"Botswana (+267)"},
		{id:"55" , title:"Brazil (+55)"},
		{id:"673" , title:"Brunei (+673)"},
		{id:"359" , title:"Bulgaria (+359)"},
		{id:"226" , title:"Burkina Faso (+226)"},
		{id:"257" , title:"Burundi (+257)"},
		{id:"855" , title:"Cambodia (+855)"},
		{id:"237" , title:"Cameroon (+237)"},
		{id:"1" , title:"Canada (+1)"},
		{id:"238" , title:"Cape Verde Islands (+238)"},
		{id:"1345" , title:"Cayman Islands (+1345)"},
		{id:"236" , title:"Central African Republic (+236)"},
		{id:"56" , title:"Chile (+56)"},
		{id:"86" , title:"China (+86)"},
		{id:"57" , title:"Colombia (+57)"},
		{id:"269" , title:"Comoros (+269)"},
		{id:"242" , title:"Congo (+242)"},
		{id:"682" , title:"Cook Islands (+682)"},
		{id:"506" , title:"Costa Rica (+506)"},
		{id:"385" , title:"Croatia (+385)"},
		{id:"53" , title:"Cuba (+53)"},
		{id:"90392" , title:"Cyprus North (+90392)"},
		{id:"357" , title:"Cyprus South (+357)"},
		{id:"42" , title:"Czech Republic (+42)"},
		{id:"45" , title:"Denmark (+45)"},
		{id:"253" , title:"Djibouti (+253)"},
		{id:"1809" , title:"Dominica (+1809)"},
		{id:"1809" , title:"Dominican Republic (+1809)"},
		{id:"593" , title:"Ecuador (+593)"},
		{id:"20" , title:"Egypt (+20)"},
		{id:"503" , title:"El Salvador (+503)"},
		{id:"240" , title:"Equatorial Guinea (+240)"},
		{id:"291" , title:"Eritrea (+291)"},
		{id:"372" , title:"Estonia (+372)"},
		{id:"251" , title:"Ethiopia (+251)"},
		{id:"500" , title:"Falkland Islands (+500)"},
		{id:"298" , title:"Faroe Islands (+298)"},
		{id:"679" , title:"Fiji (+679)"},
		{id:"358" , title:"Finland (+358)"},
		{id:"33" , title:"France (+33)"},
		{id:"594" , title:"French Guiana (+594)"},
		{id:"689" , title:"French Polynesia (+689)"},
		{id:"241" , title:"Gabon (+241)"},
		{id:"220" , title:"Gambia (+220)"},
		{id:"7880" , title:"Georgia (+7880)"},
		{id:"233" , title:"Ghana (+233)"},
		{id:"350" , title:"Gibraltar (+350)"},
		{id:"30" , title:"Greece (+30)"},
		{id:"299" , title:"Greenland (+299)"},
		{id:"1473" , title:"Grenada (+1473)"},
		{id:"590" , title:"Guadeloupe (+590)"},
		{id:"671" , title:"Guam (+671)"},
		{id:"502" , title:"Guatemala (+502)"},
		{id:"224" , title:"Guinea (+224)"},
		{id:"245" , title:"Guinea - Bissau (+245)"},
		{id:"592" , title:"Guyana (+592)"},
		{id:"509" , title:"Haiti (+509)"},
		{id:"504" , title:"Honduras (+504)"},
		{id:"852" , title:"Hong Kong (+852)"},
		{id:"36" , title:"Hungary (+36)"},
		{id:"354" , title:"Iceland (+354)"},
		{id:"91" , title:"India (+91)"},
		{id:"62" , title:"Indonesia (+62)"},
		{id:"98" , title:"Iran (+98)"},
		{id:"964" , title:"Iraq (+964)"},
		{id:"972" , title:"Israel (+972)"},
		{id:"39" , title:"Italy (+39)"},
		{id:"1876" , title:"Jamaica (+1876)"},
		{id:"81" , title:"Japan (+81)"},
		{id:"962" , title:"Jordan (+962)"},
		{id:"7" , title:"Kazakhstan (+7)"},
		{id:"254" , title:"Kenya (+254)"},
		{id:"686" , title:"Kiribati (+686)"},
		{id:"850" , title:"Korea North (+850)"},
		{id:"82" , title:"Korea South (+82)"},
		{id:"965" , title:"Kuwait (+965)"},
		{id:"996" , title:"Kyrgyzstan (+996)"},
		{id:"856" , title:"Laos (+856)"},
		{id:"371" , title:"Latvia (+371)"},
		{id:"961" , title:"Lebanon (+961)"},
		{id:"266" , title:"Lesotho (+266)"},
		{id:"231" , title:"Liberia (+231)"},
		{id:"218" , title:"Libya (+218)"},
		{id:"417" , title:"Liechtenstein (+417)"},
		{id:"370" , title:"Lithuania (+370)"},
		{id:"352" , title:"Luxembourg (+352)"},
		{id:"853" , title:"Macao (+853)"},
		{id:"389" , title:"Macedonia (+389)"},
		{id:"261" , title:"Madagascar (+261)"},
		{id:"265" , title:"Malawi (+265)"},
		{id:"60" , title:"Malaysia (+60)"},
		{id:"960" , title:"Maldives (+960)"},
		{id:"223" , title:"Mali (+223)"},
		{id:"356" , title:"Malta (+356)"},
		{id:"692" , title:"Marshall Islands (+692)"},
		{id:"596" , title:"Martinique (+596)"},
		{id:"222" , title:"Mauritania (+222)"},
		{id:"269" , title:"Mayotte (+269)"},
		{id:"52" , title:"Mexico (+52)"},
		{id:"691" , title:"Micronesia (+691)"},
		{id:"373" , title:"Moldova (+373)"},
		{id:"377" , title:"Monaco (+377)"},
		{id:"976" , title:"Mongolia (+976)"},
		{id:"1664" , title:"Montserrat (+1664)"},
		{id:"212" , title:"Morocco (+212)"},
		{id:"258" , title:"Mozambique (+258)"},
		{id:"95" , title:"Myanmar (+95)"},
		{id:"264" , title:"Namibia (+264)"},
		{id:"674" , title:"Nauru (+674)"},
		{id:"977" , title:"Nepal (+977)"},
		{id:"31" , title:"Netherlands (+31)"},
		{id:"687" , title:"New Caledonia (+687)"},
		{id:"64" , title:"New Zealand (+64)"},
		{id:"505" , title:"Nicaragua (+505)"},
		{id:"227" , title:"Niger (+227)"},
		{id:"234" , title:"Nigeria (+234)"},
		{id:"683" , title:"Niue (+683)"},
		{id:"672" , title:"Norfolk Islands (+672)"},
		{id:"670" , title:"Northern Marianas (+670)"},
		{id:"47" , title:"Norway (+47)"},
		{id:"968" , title:"Oman (+968)"},
		{id:"680" , title:"Palau (+680)"},
		{id:"507" , title:"Panama (+507)"},
		{id:"675" , title:"Papua New Guinea (+675)"},
		{id:"595" , title:"Paraguay (+595)"},
		{id:"51" , title:"Peru (+51)"},
		{id:"63" , title:"Philippines (+63)"},
		{id:"48" , title:"Poland (+48)"},
		{id:"351" , title:"Portugal (+351)"},
		{id:"1787" , title:"Puerto Rico (+1787)"},
		{id:"974" , title:"Qatar (+974)"},
		{id:"262" , title:"Reunion (+262)"},
		{id:"40" , title:"Romania (+40)"},
		{id:"7" , title:"Russia (+7)"},
		{id:"250" , title:"Rwanda (+250)"},
		{id:"378" , title:"San Marino (+378)"},
		{id:"239" , title:"Sao Tome &amp; Principe (+239)"},
		{id:"966" , title:"Saudi Arabia (+966)"},
		{id:"221" , title:"Senegal (+221)"},
		{id:"381" , title:"Serbia (+381)"},
		{id:"248" , title:"Seychelles (+248)"},
		{id:"232" , title:"Sierra Leone (+232)"},
		{id:"65" , title:"Singapore (+65)"},
		{id:"421" , title:"Slovak Republic (+421)"},
		{id:"386" , title:"Slovenia (+386)"},
		{id:"677" , title:"Solomon Islands (+677)"},
		{id:"252" , title:"Somalia (+252)"},
		{id:"27" , title:"South Africa (+27)"},
		{id:"34" , title:"Spain (+34)"},
		{id:"94" , title:"Sri Lanka (+94)"},
		{id:"290" , title:"St. Helena (+290)"},
		{id:"1869" , title:"St. Kitts (+1869)"},
		{id:"1758" , title:"St. Lucia (+1758)"},
		{id:"249" , title:"Sudan (+249)"},
		{id:"597" , title:"Suriname (+597)"},
		{id:"268" , title:"Swaziland (+268)"},
		{id:"46" , title:"Sweden (+46)"},
		{id:"41" , title:"Switzerland (+41)"},
		{id:"963" , title:"Syria (+963)"},
		{id:"886" , title:"Taiwan (+886)"},
		{id:"7" , title:"Tajikstan (+7)"},
		{id:"66" , title:"Thailand (+66)"},
		{id:"228" , title:"Togo (+228)"},
		{id:"676" , title:"Tonga (+676)"},
		{id:"1868" , title:"Trinidad &amp; Tobago (+1868)"},
		{id:"216" , title:"Tunisia (+216)"},
		{id:"90" , title:"Turkey (+90)"},
		{id:"7" , title:"Turkmenistan (+7)"},
		{id:"993" , title:"Turkmenistan (+993)"},
		{id:"1649" , title:"Turks &amp; Caicos Islands (+1649)"},
		{id:"688" , title:"Tuvalu (+688)"},
		{id:"256" , title:"Uganda (+256)"},
		{id:"1" , title:"USA (+1)"},
		{id:"380" , title:"Ukraine (+380)"},
		{id:"971" , title:"United Arab Emirates (+971)"},
		{id:"598" , title:"Uruguay (+598)"},
		{id:"7" , title:"Uzbekistan (+7)"},
		{id:"678" , title:"Vanuatu (+678)"},
		{id:"379" , title:"Vatican City (+379)"},
		{id:"58" , title:"Venezuela (+58)"},
		{id:"84" , title:"Vietnam (+84)"},
		{id:"84" , title:"Virgin Islands - British (+1284)"},
		{id:"84" , title:"Virgin Islands - US (+1340)"},
		{id:"681" , title:"Wallis &amp; Futuna (+681)"},
		{id:"969" , title:"Yemen (North)(+969)"},
		{id:"967" , title:"Yemen (South)(+967)"},
		{id:"260" , title:"Zambia (+260)"},
		{id:"263" , title:"Zimbabwe (+263)"}
	];
	options = options || {};
	var ICABBI = require('/core/icabbi');
	var IcabbiAPI = require('/core/IcabbiAPI');
	var btnNavLogin;
	
	var createForm = function(){
		var rect;
		var action = 'authenticate',
			prev_action = '';

		//create object instance, a parasitic subclass of Observable
		var view = Titanium.UI.createView({
			top: 0,
			left:0,
			right:0,
	        height:Ti.UI.SIZE,
			layout:'vertical',
	    });
	    
	    var form={fields:{}};
	    
	    
		/*
		 *******************************************
		 * Login / Register toggle
		 *******************************************
		 */	
		btnNavLogin = Ti.UI.createView({
			right:5,
			height:48,
			width:65,
			animateType:Theme.ANTIMATE_TYPE_OPACITY,
		});
		
		var submitIcon = Ti.UI.createImageView({
			height:31,
			width:65,
			left:0,
			touchEnabled:false,
			image:'/images/headers/icon_submit.png',
		});
		btnNavLogin.add(submitIcon);
		var loginLabel = Ti.UI.createLabel({
			text: action==='authenticate'?'Register':'Login',
			color:Theme.childwindow.buttonTextColor,
			font:Theme.childwindow.headerButtonFont,
			bottom:17,
			textAlign:Ti.UI.TEXT_ALIGNMENT_CENTER,
		});
		btnNavLogin.add(loginLabel);
		
		Theme.animateButton(btnNavLogin);

	    btnNavLogin.addEventListener('click',function(e){
	    	// toggle the screen
			if(action==='FORGOTPASSWORD') {
				options.parent.setTitle('Login');
				action=prev_action;
				prev_action='';
				//btnSubmit.title='Login';
				btnSubmit.top= 15; 
			}
			else
		    	if (action==='REGISTER') {
		    		options.parent.setTitle('Login');
					prev_action=action;
		    		action = 'authenticate';
		    		//btnSubmit.title='Login';
		    		btnSubmit.top= 15; 
		    	} else {
		    		options.parent.setTitle('Register');
					prev_action=action;
		    		action = 'REGISTER';
		    		//btnSubmit.title='Register';
		    		btnSubmit.top= 3; 
		    	}
	    	
	    	loginLabel.text = action==='REGISTER'?'Login':'Register';
	    	noteText.text = action=== 'authenticate'? '':'';
	    	//registerText.visible = action==='REGISTER';
	    	//registerText.height = action==='REGISTER'?Ti.UI.SIZE:0;
			forgotPassword.visible = action==='authenticate';
			forgotPassword.height = action==='authenticate'?35:0;
			view.top = action==='authenticate'? 5 :15;
			usernameRow.top = action==='authenticate'? 5 : 15;
		
			sectionLogin.height = action==='REGISTER' ? 0 : Ti.UI.SIZE;
	    	sectionLogin.visible = action!=='REGISTER';
	    	
			sectionHelp.height = 0;
	    	sectionHelp.visible = false;
			
			sectionProfile.height = action==='REGISTER' ? Ti.UI.SIZE:0;
	    	sectionProfile.visible = action==='REGISTER';
			
	    });
	    
		view.onClose = function() {
			if(action === 'FORGOTPASSWORD' || action === 'REGISTER') {
				action=prev_action;
				prev_action='';
				
				options.parent.setTitle(action === 'REGISTER' ? 'Register':'Login');
		    	loginLabel.text = action === 'REGISTER' ? 'Login' : 'Register';
		    	//btnSubmit.title= action === 'REGISTER' ? 'Register' : 'Login';
		    	btnSubmit.top= action === 'REGISTER' ? 3 : 15;
		    	noteText.text = action === 'authenticate' ? '' : '';
				forgotPassword.visible = action === 'authenticate';
				forgotPassword.height = action === 'authenticate' ? 35 : 0;
				view.top = action==='authenticate'? 5 : 15;
				usernameRow.top = action==='authenticate'? 5 : 15;
	
				sectionLogin.height = action==='REGISTER' ? 0 : Ti.UI.SIZE;
		    	sectionLogin.visible = action!=='REGISTER';
				
				sectionHelp.height = 0;
		    	sectionHelp.visible = false;
				
				sectionProfile.height = action === 'REGISTER' ? Ti.UI.SIZE : 0;
		    	sectionProfile.visible = action === 'REGISTER';
				
				return true;
			}
			return false;
		};
		


		/*
		 *******************************************
		 * Register Section
		 *******************************************
		 */	
		 	    
	    // var registerSection = Titanium.UI.createView({
	    	// top:15,
			// left:0,
			// right:0,
	        // height:action==='REGISTER' ? Ti.UI.SIZE:0,
			// visible:action==='REGISTER',
			// layout:'vertical',
			// backgroundColor:'blue',
	    // });
		// view.add(registerSection);	
		
		/*var registerText = Ti.UI.createLabel({
					left:16,
					right:16,
					height:action==='REGISTER'?Ti.UI.SIZE:0,
					width:Ti.UI.SIZE,
					color:Theme.nav.headerColor,
					font:Theme.nav.headerFont,
					text:'Welcome, please register your details so we have them for the next time.',
					visible:action==='REGISTER',
				});
		registerSection.add(registerText);
		*/
		

		/*
		 *******************************************
		 * Section Login
		 *******************************************
		 */	
		/*
		 * Forgot Password
		 */	    
	    var forgotPassword = Ti.UI.createView({
	    	top: 0,
	    	right:20,
	    	height:35,
	    	width:Ti.UI.SIZE,
			visible:action==='authenticate',
	    });
		var forgotPasswordLabel = Ti.UI.createLabel({
			width:Ti.UI.SIZE,
			color:Theme.global.highlightColor,
			font:Theme.form.smallLinkFont,
			text:'Forgot Password?',
		});
		forgotPassword.addEventListener('click',function(e){
			if(action=== 'FORGOTPASSWORD')
				return;
			if(action==='authenticate'){
				btnNavLogin.title = 'LOGIN';
			}
			if(action==='REGISTER'){
				btnNavLogin.title = 'REGISTER';
			}
			view.top = 15;
			prev_action=action;
			options.parent.setTitle('Forgot Password');
			action= 'FORGOTPASSWORD';
			forgotPassword.visible = false;
			forgotPassword.height = 0;
			loginLabel.text ='Login';
			noteText.text='Please enter your email address to recover your password.';
			sectionHelp.height = Ti.UI.SIZE;
	    	sectionHelp.visible = true;
			sectionLogin.height = 0;
	    	sectionLogin.visible = false;
			sectionProfile.height = 0;
	    	sectionProfile.visible = false;
	    	//btnSubmit.title='Submit';
	    	btnSubmit.top= 15; 
		});
		forgotPassword.add(forgotPasswordLabel);
		view.add(forgotPassword);
		
		var sectionLogin = Titanium.UI.createView({
			top:0,
			left:0,
			right:0,
	        height: Ti.UI.SIZE,
	        visible: true,
			layout:'vertical'
	    });
		view.add(sectionLogin);
		
		/*
	     * Username
	     */
	    var usernameRow = new FormTextfieldRow({
   			label:'Email',
			keyboardType:Ti.UI.KEYBOARD_EMAIL,
			autocapitalization:false,
			autocorrect:false,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			value : Ti.App.Properties.getString("LoginEmail", '')
	    });
		form.fields.username = {
			title:'Email Address',
			required:true,
			getValue: function(){usernameRow.doBlur();return usernameRow.value.replace(/\s/g,'');}
		};
		usernameRow.top = action==='authenticate'? 5 : 15;
		sectionLogin.add(usernameRow);
	    
	    /*
	     * Password
	     */
	    var passwordRow = new FormTextfieldRow({
   			label:'Password',
			autocapitalization:false,
			autocorrect:false,
			passwordMask:true,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			prevField:usernameRow,
	    });
		form.fields.password = {
			title:'Password',
			required:true,
			getValue: function(){passwordRow.doBlur();return passwordRow.value;}
		};
		sectionLogin.add(passwordRow);

		/*
		 *******************************************
		 * Section Help
		 *******************************************
		 */	
		var sectionHelp = Titanium.UI.createView({
			left:0,
			right:0,
			height:0,
			visible:false,
			layout:'vertical',
	    });
		view.add(sectionHelp);
		
		var noteText = Ti.UI.createLabel({
			left:16,
			right:16,
			height:Ti.UI.SIZE,
			width:Ti.UI.SIZE,
			color:Theme.nav.headerColor,
			font:Theme.nav.headerFont,
			text:'',
		});
		
		sectionHelp.add(noteText);

	    /*
	     * Email
	     */
	    var forgotpassword_emailRow = new FormTextfieldRow({
   			hasLabel:false,
   			keyboardType:Ti.UI.KEYBOARD_EMAIL,
			autocapitalization:false,
			autocorrect:true,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			prevField:nameRow,
			hint:'Enter your email address'
	    });

		form.fields.forgotpassword_email = {
			title:'Email',
			required:true,
			getValue: function(){forgotpassword_emailRow.doBlur();return forgotpassword_emailRow.value.replace(/\s/g,'').toLowerCase();}
		};
		sectionHelp.add(forgotpassword_emailRow);

		/*
		 *******************************************
		 * Section Profile
		 *******************************************
		 */	
		var sectionProfile = Titanium.UI.createView({
			left:0,
			right:0,
	        height:0,
			visible:false,
			layout:'vertical',
	    });
		view.add(sectionProfile);

	    /*
	     * Name
	     */
	    var nameRow = new FormTextfieldRow({
   			label:'Name',
   			hint:'Enter full name',
			autocapitalization:true,
			autocorrect:true,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
	    });
		form.fields.name = {
			title:'Name',
			required:true,
			getValue: function(){nameRow.doBlur();return nameRow.value;}
		};
		sectionProfile.add(nameRow);

		/*
	     * Email
	     */
	    var emailRow = new FormTextfieldRow({
   			label:'Email',
   			hint:'Enter your email address',
   			keyboardType:Ti.UI.KEYBOARD_EMAIL,
			autocapitalization:false,
			autocorrect:true,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			prevField:nameRow,
	    });
		form.fields.email = {
			title:'Email',
			required:true,
			getValue: function(){emailRow.doBlur();return emailRow.value.replace(/\s/g,'').toLowerCase();}
		};
		sectionProfile.add(emailRow);
		
		/*
	     * Phone
	     */
	   	var countryCode = '44';
	   	
	    var phoneCodeRow = new FormTextfieldRow({
   			label:'Country',
   			hint:'Country Code',
			keyboardType:Titanium.UI.KEYBOARD_NUMBER_PAD,
			autocapitalization:false,
			autocorrect:false,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			prevField:emailRow,
			editable:false,
			focus : function() {
				ICABBI.navController.showPickerModal({
				    title:'Country Code',
				    data: countries,
				    //simple : true,
				    click : function(e){
				    	if(e.selected) {
				    		countryCode = e.selected;
				    		
				    		for(var k in countries){
				    			var item = countries[k];
				    			if(item.id === e.selected) {
									phoneCodeRow.putValue(item.title);				    				
				    			}
							}
				    	}
				    	else
				    	{
				    		phoneCodeRow.putValue('');
				    		countryCode = '';
				    	}
				    }
				});				
			}
	    });
		form.fields.phonecode = {
			title:'Phone Code',
			required:true,
			getValue: function(){return countryCode;}
		};
		phoneCodeRow.top = action==='authenticate'? 5 : 15;
		sectionProfile.add(phoneCodeRow);
		
	    var phoneRow = new FormTextfieldRow({
   			label: 'Phone',
   			hint:'Area Code+Local Number',
			keyboardType:Titanium.UI.KEYBOARD_NUMBER_PAD,
			autocapitalization:false,
			autocorrect:false,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			prevField:emailRow,
	    });
		form.fields.phoneno = {
			title:'Phone Number',
			required:true,
			getValue: function(){phoneRow.doBlur();return phoneRow.value.replace(/[^0-9]/g,'').replace(/^[0]/g,'');}
		};
		phoneRow.top = action==='authenticate'? 5 : 15;
		sectionProfile.add(phoneRow);
	    
	    /*
	     * Password
	     */
	    var passwordRegisterRow = new FormTextfieldRow({
   			label:'Password',
   			hint:'Min 8 characters',
			autocapitalization:false,
			autocorrect:false,
			passwordMask:true,
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
			prevField:phoneRow,
	    });
		form.fields.rpassword = {
			title:'Password',
			required:true,
			getValue: function(){passwordRegisterRow.doBlur();return passwordRegisterRow.value;}
		};
		sectionProfile.add(passwordRegisterRow);


	    /*
	     * Promo
	     
	    var promoRow = new FormTextfieldRow({
   			label:'Promo',
   			hint:'If Applicable',
			autocapitalization:false,
			autocorrect:false,
			returnKeyType:Ti.UI.RETURNKEY_DONE,
			prevField:passwordRegisterRow,
	    });
		form.fields.promo = {
			title:'Promo',
			required:true,
			getValue: function(){promoRow.doBlur();return promoRow.value.replace(/^\s*|\s*$/g,'');}
		};
		sectionProfile.add(promoRow);
*/
	    /*
	     * Terms
	     */
	    var termsLabel = Ti.UI.createView({
	    	top: 6,
	    	height:33,
	    	layout:'horizontal',
	    });

		var termsPart1 = Ti.UI.createLabel({
			height:21,
			width:Ti.UI.SIZE,
			color:Theme.form.smallColor,
			font:Theme.form.smallLinkFont,
			text:'Agree to',
			touchEnabled:false,
		});
		termsLabel.add(termsPart1);

		var termsPart2 = Ti.UI.createLabel({
			left:1,
			height:21,
			width:Ti.UI.SIZE,
			color:Theme.global.highlightColor,
			font:Theme.form.smallLinkFont,
			text:'Terms & Conditions',
			touchEnabled:false,
		});
		termsLabel.add(termsPart2);
		
		termsLabel.addEventListener('click',function(e){
			if (ICABBI.navController.opening(e.source)) {
				return;
			}
			var ChildWindow = require('/ui/common/ChildWindow'),
				WebView = require('/ui/common/WebView'),
				params = {
					content	: WebView,
					header	: {visible:true,controls:{cancel:{visible:true},submit:{visible:false}}},
					title:'Terms & Conditions',
					data:{
						contentAPI:IcabbiAPI.getTerms,
					},
				};

			var win = new ChildWindow(params);
			ICABBI.navController.open(win,undefined,e.source);
		});

	    var termsRow = new FormCheckboxRow({
	    	labelView:termsLabel,
   			value:true,
	    });
		form.fields.agree = {
			title:'Agreeing to Terms & Conditions',
			required:true,
			getValue: function(){return termsRow.value ? true:'';}
		};
		
		sectionProfile.add(termsRow);
		
		
	    
	   	/*
		 * Submit button
		 */	  		

		var btnSubmit = Ti.UI.createButton({
			top:10,
			right:16,
			width:110,
			height:42,
			backgroundColor:Theme.global.buttonBGColor,
			borderColor:Theme.global.highlightColor,
			backgroundFocusedColor:Theme.global.highlightColor,
			backgroundSelectedColor:Theme.global.highlightColor,
			borderWidth:1,
			borderRadius:8,
			color:Theme.global.fontColor,
			font:Theme.form.buttonFont,
			title: 'Submit',
	  	    style:Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		});
		Theme.animateButton(btnSubmit);
		view.add(btnSubmit);
		
		btnSubmit.addEventListener('click',function(e){
			//promoRow.doBlur();
			noError= true;
			var error = '';
			var requiredFields = {
				"authenticate"	: ['username','password'],
				"REGISTER"	: ['name','email','phonecode','phoneno','rpassword','agree'],
				"FORGOTPASSWORD": ['forgotpassword_email']
			};
			var validated = true;
			for(var i=0,count=requiredFields[action].length;i<count;i++){
				var fld = form.fields[requiredFields[action][i]];
				if(!fld.getValue().toString().length){
					error += '- '+fld.title+' is Required!\n';
					noError= false;
				}
			};
			if(!noError) {
				ICABBI.navController.showError({
				    title:'Error!',
				    message:error,
				    close:true
				});
				return;
			}							
			var fields = {
				action: action,
				username	:form.fields.username.getValue(),
				phone	: '00' + form.fields.phonecode.getValue() + form.fields.phoneno.getValue(),
				password: form.fields.password.getValue() || form.fields.rpassword.getValue(),
				password_confirm: form.fields.password.getValue() || form.fields.rpassword.getValue(),
				name	: form.fields.name.getValue(),
				email	: form.fields.email.getValue(),
				//promo	: form.fields.promo.getValue(),
				agree	: form.fields.agree.getValue(),
			};
			
			// ajax login now
			if(action==='FORGOTPASSWORD'){
				var params = {
					email: form.fields.forgotpassword_email.getValue()
				};
				ICABBI.Controller.forgotPassword(
					params,
					{
						success: function(){
							//close this and open contact-us screen
							var ChildWindow = require('/ui/common/ChildWindow'),
								PromptView = require('/ui/common/PromptView'),
								params = {
									content	: PromptView,
									header	: {visible:true,controls:{close:{visible:true}}},
									title:'Email sent',
									data:{
										message:'We have sent you an email containing instructions on how to reset your password',
										modal:true,
										callbutton:false,
									},

								};

							setTimeout(function(){
								ICABBI.navController.close(options.parent.window);
							},13);
							var win = new ChildWindow(params);
							ICABBI.navController.open(win,undefined,e.source);
						},
						error: function(e){
							ICABBI.navController.showError({
							    title:'Error!',
							    message:e,
							    close:true
							});
						}
					}
				);
			}
			else if(action==='REGISTER'){
				var params = _.clone(fields);
				ICABBI.Controller.register(
					params,
					{
						success: function(user){
							// if(user.isAuthenticated()){
								// //if true close modal and cchangeview
								// setTimeout(function(){
									// ICABBI.navController.close(options.parent.window);
								// },13);
// 								
								// return;
							// }
							if(user.isAuthenticated()){
								//if true fire an event
								options.parent.window && options.parent.window.fireEvent('loggedIn');
								return;
							}
							ICABBI.navController.showError({
							    title:'Error!',
							    message:'- Registration was unsuccessful!\n',
							    close:true
							});
						},
						error: function(err){
							var error = '';
							for (var e in err) {
								error += err[e] + '\n';
							}
							ICABBI.navController.showError({
							    title:'Error!',
							    message:error,
							    close:true
							});
						}
					}
				);
			}
			else if(action==='authenticate'){
				ICABBI.Controller.authenticate(
					{username:fields.username,password:fields.password},
					{
						success: function(user){
								if(user.isAuthenticated()){
									//if true fire an event
									options.parent.window && options.parent.window.fireEvent('loggedIn');
									return;
								}
							ICABBI.navController.showError({
							    title:'Error!',
							    message:'- Invalid phone/password\n',
							    close:true
							});
							
						},
						error: function(err){
							ICABBI.navController.showError({
							    title:'Error!',
							    message:err,
							    close:true
							});
						}
					}
				);
			}
			
			
		});		
		return view;
	};
	
	var self = createForm();
	self.createHeaderRightControls = function(){
		var buttons = [];
		buttons.push(btnNavLogin);	
		return buttons;	
	};

	return self;
};

module.exports = LoginView;
