var Theme = require('/ui/Theme');
var HeaderButton = require('/ui/common/HeaderButton');
var Theme = require('/ui/Theme');

var Modal = function(){
	var self = Titanium.UI.createView({
	    top:0,
	    bottom:0,
	    left:0,
	    right:0,
	    zIndex: 10,	
	});
	var modalOverlay = Titanium.UI.createView({
	    top:0,
	    bottom:0,
	    left:0,
	    right:0,
	    owner: null,
	    myView: null,
		backgroundColor: 'black',
		opacity: 0.50,
		zIndex: 10,			
	});
	var modalContent = Titanium.UI.createView({
		left: 10,
		right: 10,
		backgroundColor: '#fdfdfd',
		height: Ti.UI.SIZE,
		opacity: 1,
		zIndex: 11,
		borderRadius:6,
		layout:'vertical',
	});
	
	var titleBar = Titanium.UI.createView({
	    backgroundColor:'#ddd',
		height:44,
		left:0,
		right:0,
		top:0,
	});
	
	var titleIcon = Ti.UI.createImageView({
		height:15,
		width:15,
		left:12,
		touchEnabled:false,
		image:'/images/headers/icon_error.png',
		visible:false,
	});
	titleBar.add(titleIcon);
	
	var titleBarTitle = Ti.UI.createLabel({
		text:'',
		left:12,
		height:44,
		top:0,
		bottom:0,
	    color:'#000000',
		font:Theme.nav.buttonFont,
	});
	titleBar.add(titleBarTitle);
	
	var controls = Ti.UI.createView({
		width:Ti.UI.SIZE,
		height: 44,
		right:0,
		layout:'horizontal',
	});
	titleBar.add(controls);
	

	var btnClose = new HeaderButton({
		title:'Close',
		icon:'/images/headers/icon_close.png',
		
	});
	btnClose.addEventListener('click',function(e){
		self.fireEvent('buttons_click', {'index' : 0});
	});
	btnClose.visible=false;
	controls.add(btnClose);
			
	modalContent.add(titleBar);
	
	var titleBorder = Ti.UI.createView({
		top:  0,
		left: 0,
		right:0,
		height:1,
		backgroundColor:'#666',
	});
	modalContent.add(titleBorder);
			
	var lblMessage = Ti.UI.createLabel({
		text:'',
		left:12,
		right:12,
		height:Ti.UI.SIZE,
		top:10,
		bottom:10,
	    color:'#000000',
		font:Theme.form.smallFont,
	});
	modalContent.add(lblMessage);
	
	var controlBar = Titanium.UI.createView({
	        top:10,
	        width:Ti.UI.SIZE,
	        height:Ti.UI.SIZE,
			bottom:10,
	        layout:'horizontal', 
	    });
	
	self.add(modalOverlay);
	self.add(modalContent);  
	
	modalContent.add(controlBar);
	
	var createButtons = function(buttons){
		controlBar.removeAllChildren( );
		if(buttons) {
		    buttonContols = [];
		    for(var i = 0; i < buttons.length; i++){
		    	var btnOptions = buttons[i];
		    	
		    	if(typeof btnOptions === 'string')
		    	{
		    		btnOptions = {
		    			lable : btnOptions,
		    			icon : '/images/buttons/icon_button_ok.png'
		    		};
		    	}
		    	var btn = Ti.UI.createView({
					height:btnOptions.height || 48,
					width:btnOptions.width || 50,
					animateType:Theme.ANTIMATE_TYPE_OPACITY,
				});
				
				if(btnOptions.icon)
				{
					var icon = Ti.UI.createImageView({
						height:30,
						width:btnOptions.width || 50,
						left:0,
						touchEnabled:false,
						image:btnOptions.icon,
					});
					btn.add(icon);
				}
				else if(btnOptions.color) {
					btn.setBackgroundColor(btnOptions.color);
					btn.setBorderRadius(8);
				}
				
				var label = Ti.UI.createLabel({
					text: btnOptions.lable,
					height:btnOptions.height || 48,
					width:btnOptions.width || 50,
					textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
					color:Theme.childwindow.buttonTextColor,
					font:Theme.childwindow.headerButtonFont,
				});
				btn.add(label);
				btn.index = i + 1;
				Theme.animateButton(btn);
				buttonContols.push(btn);
				
				var clickFunc = btnOptions.click || false;
				btn.addEventListener('click',function(e){
					clickFunc && clickFunc({'index' : this.index});
					self.fireEvent('buttons_click', {'index' : this.index});
				});
		    }
		    
		    for(var i = 0; i < buttonContols.length; i++){
		    	if (i > 0) {
		    		buttonContols[i].left = 16;
		    	}
				controlBar.add(buttonContols[i]);
		    }
	    }
	};
	//Methods  		
	self.setOptions = function(options){
		if(options.titleIcon) {
			titleIcon = options.titleIcon;
			titleIcon.visble = true;
			titleBarTitle.left  = 32;
		}
		else
			titleIcon.visble = false;
			
		titleBarTitle.left = 12;
		titleBarTitle.setColor(options.titleColor || '#000000');
		titleBarTitle.setText(options.title || '');

		if(options.title === false) {
			titleBar.visible = false;
			titleBorder.visible = false;
			titleBar.height = 0;
		}
		else {
			titleBar.visible = true;
			titleBorder.visible = true;
			titleBar.height = 44;
		}
		
		lblMessage.setText(options.message || '');
		lblMessage.setColor(options.messageColor || '#000000');
		
		if(options.textAlign) {
			lblMessage.setTextAlign(options.textAlign);
		}
		else {
			lblMessage.setTextAlign(Ti.UI.TEXT_ALIGNMENT_LEFT);
		}
		
		btnClose.visible = 'close' in options ? options.close : false;
		createButtons(options.buttons);		
	};
	
	return self;
};

module.exports = Modal;
