var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager'),
	Theme = require('/ui/Theme'),
	FormTextfieldRow = require('/ui/common/FormTextfieldRow'),
	FormCheckboxRow = require('/ui/common/FormCheckboxRow'),
	Geolocation = require('/lib/Geolocation');
//EditAddressView Component Constructor
var POIsView = function(options) {
	options = options || {};

	var headerHeight = footerHeight = 48;
	var tableView;

	var fillTable = function(pois) {
		Ti.API.info('fill pois');
		var tableData = [];
		if(pois) {
			_.each(pois, function(poi){
				Ti.API.info('fill poi');
				tableData.push(createPOIRow({
				  	title: poi.name,
				  	data : poi
				}));	
			});
		}
		tableView.setData(tableData);
	};
		
	var createContent = function(){
		var content = Titanium.UI.createView({
			top:0,
			bottom:footerHeight,
			left:0,
			right:0,
	    });

		var contentTopBorder = Ti.UI.createView({
			top: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:'#fff',
		});
		content.add(contentTopBorder);
		var contentBottomBorder = Ti.UI.createView({
			bottom: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.altBGColor,
		});
		content.add(contentBottomBorder);

		// test tableview
		
		var tableData = [];
		// todo add a recent location search
		// for (var i=1; i<=20; i++){
// 		  
		  // tableData.push(createAddressRow({
		  	// title:i+' create Qpjulting engineers Dunston hall bunkers bar, ipswich road ',
		  // }));
		// }
		
		tableView = Ti.UI.createTableView({
		  backgroundColor:'white',
		  data:tableData,
		  top: 0,
		  bottom: 1,
		  left: 0,
		  right:0,
		  separatorColor: '#ffffff',
		});
		
		tableView.addEventListener('click', function(e) {
			options.parent.window.__retval = {poi:e.row.data};
			ICABBI.navController.close(options.parent.window);
		});
		content.add(tableView);

		return content;
	}; 

	var createPOIRow = function(data) {
		var row = Ti.UI.createTableViewRow({
			height:44,
			backgroundColor:'#f8f8f8',
			selectedColor: 'transparent',
			backgroundFocusedColor:'transparent',
			backgroundSelectedColor:'transparent',
			selectionStyle:Ti.Android?undefined:Ti.UI.iPhone.TableViewCellSelectionStyle.NONE,
		});
		row.data = data.data;
		
		row.className = 'datarow';
		row.clickName = 'row';
		
		var container=Ti.UI.createView({
			right:0,
			height:44,
			left:Ti.UI.SIZE,
		});
		row.add(container);
		var title = Ti.UI.createLabel({
			color:Theme.global.fontColor,
			left:7,
			right:36,
			text:data.title,
			touchEnabled:false,
		    wordWrap:false,
		    ellipsize:true,
			width: Ti.UI.FILL,
			font:Theme.address.addressFont,
		});
		container.add(title);
		
		var arrowIcon = Ti.UI.createImageView({
		    height:11,
		    width:11,
		    right: 7,
		    image:'/images/map/arrow.png',
		    touchEnabled:false,
		});
		container.add(arrowIcon);
		
		var rowBottomLine = Ti.UI.createView({
			left:0,
			right:0,
			bottom:0,
			height:1,
			backgroundColor:'#cacaca',
			touchEnabled:false,
		});
		container.add(rowBottomLine);
		Theme.animateButton(container);	
		return row;

	};
	var createFooter = function(){
		var footer = Ti.UI.createView({
			bottom: 0,
			left: 0,
			right:0,
			height: footerHeight,
			backgroundColor: '#dddddd',
		});
		
		var footerBorder = Ti.UI.createView({
			top: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:"#ffffff",
		});
		footer.add(footerBorder);

		var btnRecentAddresses = Ti.UI.createView({
			left:8,
			bottom:0,
			height:47,
			width:40,
			animateType:Theme.ANTIMATE_TYPE_OPACITY,
		});
		var recentIcon = Ti.UI.createImageView({
			height:47,
			width:40,
			top: 0,
			touchEnabled:false,
			image:'/images/buttons/icon_recent.png',
		});
		btnRecentAddresses.add(recentIcon);
		var labelRecent = Ti.UI.createLabel({
			bottom:0,
			height:15,
			width:Ti.UI.FILL,
			color:Theme.global.fontColor,
			font:Theme.footer.footerFont,
			text:'Recent',
			textAlign:'center',
			touchEnabled:false,
		});
		btnRecentAddresses.add(labelRecent);
		
		Theme.animateButton(btnRecentAddresses);
		btnRecentAddresses.addEventListener('click',function(e){
			options.parent.window.__retval = {poi:null, recent:true};
			ICABBI.navController.close(options.parent.window);
		});
		footer.add(btnRecentAddresses);
		
		return footer;
	};
	
	var create = function(){
		var view = Titanium.UI.createView({
			top:0,
			left:0,
			right:0,
	        height:Ti.UI.SIZE,
			//layout:'vertical',
	    });
		
		content = createContent();
		footer = createFooter();
		view.add(content);
		view.add(footer);

		IcabbiAPI.poiCategories({
			success: function(pois){
				fillTable(pois || []);
			},
			error: function(error){
			    fillTable([]);
			}
		});
		
		return view;
	};
	
	var self = create();
	return self;
};

module.exports = POIsView;
