var ICABBI = require('/core/icabbi');
var HeaderButton = require('/ui/common/HeaderButton');

var SlidingView = require('/ui/common/SlidingView'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

var Theme = require('/ui/Theme');

//PageView Component Constructor
var PageView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			header:{visible:true,title:'new page'}
		};
	options = _.extend(defaults,options||{});
	
	var headerHeight = Theme.childwindow.headerHeight;

	var createHeader = function(backAction){
		var header = Ti.UI.createView({
			top: 0,
			left: 0,
			right:0,
			height: headerHeight,
			backgroundColor: Theme.childwindow.bgColor,
		});

		var headerBorder = Ti.UI.createView({
			bottom: 0,
			left: 0,
			right:0,
			height:1,
			backgroundColor:Theme.global.altBGColor,
		});
		header.add(headerBorder);
		
		btnSlideMenu = Ti.UI.createView({
			left:3,
			top:3,
			height:44,
			width:44,
			animateType:Theme.ANTIMATE_TYPE_OPACITY,
		});
		
		var menuIcon = Ti.UI.createImageView({
			height:17,
			width:21,
			touchEnabled:false,
			image:'/images/map/btn_menu.png',
		});
		btnSlideMenu.add(menuIcon);
		Theme.animateButton(btnSlideMenu);

		btnSlideMenu.addEventListener('click',function(e){
			ICABBI.Controller.trigger('slidingmenu:toggle');
			if(content && content.onClose)
				content.onClose();
		});
		header.add(btnSlideMenu);
		
		var lblInfo = Ti.UI.createLabel({
		    text: options.title || '',
		    height:headerHeight,
			color:Theme.nav.headerColor,
			font:Theme.nav.headerFont,
		    text:options.header.title|| '',
		    textAlign:Ti.UI.TEXT_ALIGNMENT_CENTER,
		});
		header.add(lblInfo);

		var controls = Ti.UI.createView({
			width:Ti.UI.SIZE,
			height: headerHeight,
			right:0,
			layout:'horizontal',
		});
		header.add(controls);
		
		var btnClose = Ti.UI.createView({
			right:5,
			height:48,
			width:50,
			animateType:Theme.ANTIMATE_TYPE_OPACITY,
		});
		
		var closeIcon = Ti.UI.createImageView({
			height:30,
			width:50,
			left:0,
			touchEnabled:false,
			image:'/images/headers/icon_close_button.png',
		});
		btnClose.add(closeIcon);
		var closeLabel = Ti.UI.createLabel({
			text: 'Close',
			bottom:17,
		    left: 10,
			color:Theme.childwindow.buttonTextColor,
			font:Theme.childwindow.headerButtonFont,
		});
		btnClose.add(closeLabel);
		btnClose.addEventListener('click', backAction);
		Theme.animateButton(btnClose);
		controls.add(btnClose);
		
		return header;
	};
	var content;
	var createBody = function(header,view){
		//BODY
		var body;
		if (options.content.scroll) {
			body = Ti.UI.createScrollView({
				top		: 0,
				bottom	: 0,
				left	: 0,
				right	: 0,
				scrollType:'vertical',
				disableBounce:true,
			});
		} else {
			body = Ti.UI.createView({
				top		: 0,
				bottom	: 0,
				left	: 0,
				right	: 0,
			});
		}
		options.content.data.__parent={header:header,scroll:body,view:view};
		content = new options.content.view({data:options.content.data});
		
		body.add(content);
		return body;
	};

    var create = function(){
	    var slidingview = new SlidingView({
    		backgroundColor:'#fff',
    		top:0,
    		bottom:0,
	   	});
	    var view = Ti.UI.createView({
	    	top:0,left:0,right:0,bottom:0,
//    		width:Ti.UI.FILL,
//    		height:Ti.UI.FILL,
    		layout:'vertical'
	   	});
	   	slidingview.add(view);

	   	var header;
	 	if(options.header.visible){
	 		
	 		var backAction = function(e){		
				ICABBI.SlidingMenu.fireEvent('openview',{index:ICABBI.Config.show_map?0:1});			
			};
	 		
	 		if(Ti.Android)
	 			slidingview.onBackPressed = backAction;
	 		
	 		header=createHeader(backAction);
			view.add(header);
	   	}
	   	view.add(createBody(header,slidingview));
    	return slidingview;
    };
	var self = create();
	self.addEventListener('slidingmenu:view:load',function(e){
		content.fireEvent('slidingmenu:view:load',{bubbles:false});
	});
    
	return self;
};

module.exports = PageView;
