var Theme = require('/ui/Theme');
var HeaderButton = require('/ui/common/HeaderButton');
var Theme = require('/ui/Theme');
var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ;

var PickerModal = function(){
	var tableView;
	var fillTable = function(rows, groupings, simple) {
		var tableData = [];

		if(rows) {
			if(groupings)
			{
				_.each(rows,function(sectionData){
					sectionRow = createSection(sectionData.title);
					tableData.push(sectionRow);
					_.each(sectionData.rows,function(rowData){
						sectionRow.add(createRow({
						  	title : rowData.title || '',
						  	data : rowData.id,
						}, simple));
					});
				});
			}
			else
			{
				_.each(rows,function(row){
					tableData.push(createRow({
					  	title : row.title || '',
					  	data : row.id,
					},simple));
				});
			}
		}
		return tableData;
	};
	
	var self = Titanium.UI.createView({
	    top:0,
	    bottom:0,
	    left:0,
	    right:0,
	    zIndex: 10,	
	});
	var modalOverlay = Titanium.UI.createView({
	    top:0,
	    bottom:0,
	    left:0,
	    right:0,
	    owner: null,
	    myView: null,
		backgroundColor: 'black',
		opacity: 0.50,
		zIndex: 10,			
	});
	var modalContent = Titanium.UI.createView({
		left: 10,
		right: 10,
		backgroundColor: '#fdfdfd',
		//height: Ti.UI.SIZE,
		opacity: 1,
		zIndex: 11,
		borderRadius:6,
		layout:'vertical',
	});
	
	var titleBar = Titanium.UI.createView({
	    backgroundColor:'#ddd',
		height:44,
		left:0,
		right:0,
		top:0,
	});
		
	var titleBarTitle = Ti.UI.createLabel({
		text:'',
		left:12,
		height:44,
		top:0,
		bottom:0,
	    color:'#000000',
		font:Theme.nav.buttonFont,
	});
	titleBar.add(titleBarTitle);
	
	var controls = Ti.UI.createView({
		width:Ti.UI.SIZE,
		height: 44,
		right:0,
		layout:'horizontal',
	});
	titleBar.add(controls);
	

	var btnClose = new HeaderButton({
		title:'Close',
		icon:'/images/headers/icon_close.png',
		
	});
	btnClose.addEventListener('click',function(e){
		self.fireEvent('buttons_click', {'index' : 0});
	});
	btnClose.visible=true;
	controls.add(btnClose);
			
	modalContent.add(titleBar);
	
	var titleBorder = Ti.UI.createView({
		top:  0,
		left: 0,
		right:0,
		height:1,
		backgroundColor:'#666',
	});
	modalContent.add(titleBorder);
			
	self.add(modalOverlay);
	self.add(modalContent);  
	
	var createSection = function(header){
		var container=Ti.UI.createView({
			right:0,
			height:44,
			left:0,
			backgroundColor: Theme.picker.sectionBackgroundColor,
		});

		var title = Ti.UI.createLabel({
			color:Theme.global.fontColor,
			left:7,
			right:7,
			text:header,
			touchEnabled:false,
		    wordWrap:false,
		    ellipsize:true,
			width: Ti.UI.FILL,
			font:Theme.picker.titleFont,
		});
		container.add(title);
		
		var rowBottomLine = Ti.UI.createView({
			left:0,
			right:0,
			bottom:0,
			height:1,
			backgroundColor:Theme.picker.rowSeparator,
			touchEnabled:false,
		});
		container.add(rowBottomLine);
		
		var section = Ti.UI.createTableViewSection({
			headerView : container,
		});
		return section;
	};
	var createRow = function(data, simple) {
		var row = Ti.UI.createTableViewRow({
			height:44,
			backgroundColor: Theme.picker.rowBackgroundColor,
			selectedColor: 'transparent',
			backgroundFocusedColor:'transparent',
			backgroundSelectedColor:'transparent',
			selectionStyle:Ti.Android?undefined:Ti.UI.iPhone.TableViewCellSelectionStyle.NONE,
		});
		row.data = data.data;
		if(simple)
		{
			row.title = data.title;	
		}
		else
		{
		row.className = 'datarow';
		row.clickName = 'row';
		
		var container=Ti.UI.createView({
			right:0,
			height:44,
			left:Ti.UI.SIZE,
		});
		row.add(container);
		var title = Ti.UI.createLabel({
			color:Theme.global.fontColor,
			left:7,
			right:36,
			text:data.title,
			touchEnabled:false,
		    wordWrap:false,
		    ellipsize:true,
			width: Ti.UI.FILL,
			font:Theme.picker.subtitleFont,
		});
		container.add(title);
		
		var arrowIcon = Ti.UI.createImageView({
		    height:11,
		    width:11,
		    right: 7,
		    image:'/images/map/arrow.png',
		    touchEnabled:false,
		});
		container.add(arrowIcon);
		
		var rowBottomLine = Ti.UI.createView({
			left:0,
			right:0,
			bottom:0,
			height:1,
			backgroundColor:Theme.picker.rowSeparator,
			touchEnabled:false,
		});
		container.add(rowBottomLine);
		Theme.animateButton(container);	
		}	
		return row;

	};
	
	//Methods  		
	self.setOptions = function(options){
		titleBarTitle.setText(options.title || '');	
		if (tableView)
			modalContent.remove(tableView);
		var rowsCount = options.data.length;
		if(options.grouping) {
			_.each(options.data,function(sectionData){
				rowsCount += sectionData.rows.length + 1;
			});
		}
		var maxHeight = (Ti.Platform.displayCaps.platformHeight * 0.9) - 64;
		var th = Math.min(rowsCount * 44, maxHeight);
		if(rowsCount * 44 < maxHeight)
			modalContent.height = (rowsCount * 44) + 46;
		else
			modalContent.height = '90%';
			
			
		var rows = fillTable(options.data, options.grouping, options.simple);
		tableView = Ti.UI.createTableView({
			  backgroundColor:'white',
			  data:rows,
			  left: 0,
			  right:0,
			  height : th,
			  separatorColor: Theme.picker.backgroundColor,
			  footertitle:'',
			  allowsSelection:Ti.Android,
		});
		
		tableView.addEventListener('click', function(e) {
			self.fireEvent('buttons_click', {'selected':e.row.data});
		});
		modalContent.add(tableView);
	};
	
	return self;
};

module.exports = PickerModal;
