var _ = require('/lib/lodash')._ ,
	ICABBI = require('/core/icabbi');

var Theme = require('/ui/Theme');
var ActionButton = require('/ui/common/ActionButton');
var HeaderButton = require('/ui/common/HeaderButton');

var PromptView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
			title:'Contact',
			logo:'icabbi.png',
			header: {visible:false},
			phoneNumber:'01 45678987',
			modal:false,
			callbutton:true,
		};
	options = _.extend(defaults,options.data||{},{parent:options.parent||{}});
	
	var self = Ti.UI.createView({
        width:Ti.UI.FILL,
        height:Ti.UI.FILL,
		backgroundColor:'#fff',
	});
	
	// logo
	var logo = Ti.UI.createImageView({
		top:0,
		left : '10%',
		right : '10%',
		height : ((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		image:'/images/logo200.png',
	});
	self.add(logo);
	
	// powered by
	var powered = Ti.UI.createImageView({
		bottom:2,
		height:28,
		width:128,
		image:'/images/powered.png',
	});
	self.add(powered);
		
	// content positioning
	var content = Ti.UI.createView({
		top:5+((Ti.Platform.displayCaps.platformWidth * 0.8) * (Titanium.Platform.displayCaps.dpi / 160)),
		bottom:30,
		left:0,
		rigth:0,
		layout:'vertical'
	});
	self.add(content);
	var layoutListener = function(){
		self.removeEventListener('postlayout', layoutListener);
		logo.height = logo.rect.width;
		content.top = 5+logo.rect.width; 
	};
	self.addEventListener('postlayout',layoutListener);

	var messageView = Ti.UI.createView({
		top:0,//300,
		height:Ti.UI.SIZE,
		left:10,
		right:10,
		layout:'vertical'
	});
	content.add(messageView);

	// text
	var messages=[];
	if(options.message && options.message.length){
		messages = _.isArray(options.message) ? options.message : [options.message];
	}
	_.each(messages,function(message,i){
		messageView.add(Ti.UI.createLabel({
			top:5,
			//left:16,
			//right:16,
			// width:Ti.UI.SIZE,
			height:Ti.UI.SIZE,
			textAlign:'center',
			color:Theme.global.fontColor,
			font: i==0 ? Theme.nav.buttonFont : Theme.global.smallFont,
			touchEnabled:false,
			text:message
		}));
	});

		// button
	if(options.callbutton){
		var phoneButton = ActionButton({
			title:'PHONE',
			icon:'/images/buttons/icon_phone.png',
		});
		// phoneButton.top = 10;
		//phoneButton.bottom = 20;
		phoneButton.top = 10;
		content.add(phoneButton);
		phoneButton.addEventListener('click',function(){
			Ti.Platform.openURL('tel:'+ICABBI.Config.phone.replace(/[^\d^+]/g, ''));
		});
	}

	return self;
};

module.exports = PromptView;
