/**
 * @author Sonal 
 */

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');

var Theme = require('/ui/Theme');
var ActionButton = require('/ui/common/ActionButton');
var HeaderButton = require('/ui/common/HeaderButton');

//PromptView Component Constructor
var PromptView = function(options) {
	options = options || {};
	
	var createLabel = function(options){
		var label = Ti.UI.createLabel($$.styl('label','Modal.label',{
		    height:Ti.UI.FILL,
		    left:0,
		    width:80,//Ti.UI.FILL
	  	    font:{fontSize:14,fontWeight:'bold'},
		},options)
		);
		return label;
	};

	var createContent = function(){
		//create object instance, a parasitic subclass of Observable
		var defaults = {
				title:options.title||ICABBI.Config.Company.name||Theme.app.company,
				logo:'icabbi.png',
				header: {visible:false},
				phoneNumber:'01 45678987',
				modal:false,
			};
		options = _.extend(defaults,options.data||{},{parent:options.parent||{}});
		
		var view = Ti.UI.createView({
	        width:Ti.UI.FILL,
	        height:Ti.UI.FILL,
			backgroundColor:'#fff',
		});
		
		// logo
		var logo = Ti.UI.createImageView({
			top:50,
			height: 260,//320,
			width: 260,//320,
			image:'/images/logo.png',
		});
		view.add(logo);
		
		// powered by
		var powered = Ti.UI.createImageView({
			bottom:2,
			height:28,
			width:128,
			image:'/images/powered.png',
		});
		view.add(powered);
		
		// content positioning
		var content = Ti.UI.createView({
			top:225,
			bottom:0,
			left:0,
			rigth:0,
		});
		view.add(content);
		
		var contactBox = Ti.UI.createView({
			left:16,
			right:16,
			height:Ti.UI.SIZE,
			layout:'vertical',
		});
		content.add(contactBox);
	
		// text
		_.each(options.content,function(text){
			if (!contactBox.children.length) {
				var firstLabel = Ti.UI.createLabel({
					left:0,
					right:0,
					height:Ti.UI.SIZE,
					color:Theme.global.fontColor,
					font:Theme.nav.buttonFont,
					text:text,
					textAlign:'center',
				});
				contactBox.add(firstLabel);
			} else {
				var secondLabel = Ti.UI.createLabel({
					left:0,
					right:0,
					height:Ti.UI.SIZE,
					color:Theme.global.fontColor,
					font:Theme.global.smallFont,
					text:text,
					textAlign:'center',
				});
				contactBox.add(secondLabel);
			}
		});
		
		// button
		var phoneButton = ActionButton({
			title:'PHONE',
			icon:'/images/buttons/icon_phone.png',
		});
		phoneButton.top = 10;
		contactBox.add(phoneButton);
		
		phoneButton.addEventListener('click',function(){
			Ti.Platform.openURL('tel:'+ICABBI.Config.phone.replace(/[^\d^+]/g, ''));
		});

		return view;
	}; 
	
	var self = createContent();
	return self;
};

module.exports = PromptView;
