	$$ = require('/core/ThemeManager');

var SlidingMenu = function(args) {
	//create the main application window
    var self = args.window || Ti.UI.createWindow({
		navBarHidden:true,
		windowSoftInputMode:Ti.Android ? Ti.UI.Android.SOFT_INPUT_STATE_HIDDEN | Ti.UI.Android.SOFT_INPUT_ADJUST_RESIZE:undefined,
		top:Ti.IOSPlus?20:0,
	});
    var left = args.left,
        view, //the current view... start with 0
        views = [],
        menuRows = [],
        events = {}, //holder for our custom events
        draggable = args.draggable === undefined ? false : args.draggable,
        ledge,
        threshold,
        half = {
            width: undefined,
            height: undefined
        },
        duration = {
            slide: 300,
            swipe: 150,
            bounce: 10,//100,
            change_out: 120,
            change_in: 400,//300
        },
        bounce = 8,
        shadow = {
            shadowRadius: 2,
            shadowOpacity: 0.6,
            shadowOffset: {
                x: 4,
                y: 0
            },
            shadowColor: 'black'
        },
        current = 'view',
        sliding = {
            center: 0,
            offset: 0
        };
    // Our Identity Matrix for all animations using transform
    var twoD = Ti.UI.create2DMatrix();
    
    var doPost = function(e){
    	if (self.rect.width === 0) {
    		// do nothing, wait for next layout
    		return;
    	}
    	self.removeEventListener('postlayout',doPost);
    	
    	Ti.UI.setBackgroundImage( null );
    	Ti.UI.setBackgroundColor('#fff');
    	
    	// set the size after we know what the size is. this should cover orientation too
        half = {
            width: self.rect.width / 2,
            height: self.rect.height / 2
        };
        
        // hard-code size
        for (var v in views) {
        	if (views[v]) {
	            views[v].width = self.rect.width;
//	            views[v].height = self.rect.height;
	            if (views[v].visible !== undefined && views[v].visible === false) {
	            	if(Ti.Android)
	            		views[v].left = self.rect.width;
		            self.add(views[v]);
	            }
        	}
        }
    };
    self.addEventListener('postlayout',doPost);
    
	var getFirstVisible = function(){
		var visibleIndex = 1;
		
		if(ICABBI.Config.show_map)
			visibleIndex = 0;
		
		/*if(Ti.App.Properties.getString("LocationPublicKey", null) == null && ICABBI.Config.fleet && ICABBI.Config.fleet.length > 0) {
			visibleIndex = 8;//!!!!!! Change this if you add another menu
		}
		else {*/
			if(!Ti.App.Properties.getBool("TourTaken", false) && ICABBI.Config.tour && ICABBI.Config.tour.length > 0) {
				visibleIndex = 7;//!!!!!! Change this if you add another menu
			}
		/*}*/
		
		return visibleIndex;
	}; 
    var open = function(restart) {
    	
    	var dpi = Titanium.Platform.displayCaps.dpi;

		if(!restart)
		{
	        // Add the menu first
	        if(left !== undefined && left.toString().indexOf('TableView') !== -1) {
	            self.add(left);
	        } else {
	            throw "'left' property must be a Titanium Table view proxy... was:" + left.toString();
	        }
		}
		var visibleIndex = getFirstVisible();

        // Here we will process the table rows just as if they were tabs in a tabgroup
        // Making sure we check all the table sections
        views = [];
        for(var i = 0; i < left.rows.length; i++)
        {
            var row = left.rows[i];

            //only work with rows that have a view... in case some are buttons or decoration
            if(row.navView !== undefined) {
                var View;

                // here we will accept anything but a window...
                if(row.navView.toString().indexOf('Window') === -1) {
                    View = row.navView;
                } else {
                    throw "ViewSlider can only accept UI Views as the table row view property for now";
                    //Maybe in the future just copy all children of a window to a view?
                }
                View.width = ICABBI.width / (Ti.Android ? (dpi / 160):1);
                View.height = Ti.UI.FILL;
				View.zIndex = 2;
				
                views.push(View);

				if(i == visibleIndex && !restart)
				{
               		view = View;
               		self.add(View);
				} 
				else
					View.visible = false;
            } else {
                views.push(false); // keep our index correct...
            }
        }
		Ti.API.error(views.length + "======================------------------");
		if(!restart)
		{
	        // ledge = view.width * 0.8,
	        // threshold = view.width * 0.2,
	        ledge = view.width,
	        threshold = 0,
	        half = {
	            width: view.width / 2,
	            height: view.size.height / 2
	        };
	        left.zIndex = 1;
	        view.left = 0;
	
	        if(draggable) {
	            addEvents();
	        }
	
	        left.addEventListener('click', function(e) {Ti.API.info(e.row.viewIndex + 'SELECTECROW-------------------');
	        	if(e.row.viewIndex == 0 || e.row.viewIndex == 1){
	            	ICABBI.Controller.trigger('mapview:reset');
	            }
	            
	            var newView;
	            if(e.row.viewIndex == 0 && !ICABBI.Config.show_map) {
	            	e.row = left.rows[1];
	            }
	            
	            if(views[e.row.viewIndex]) { // see if it's an object, or a boolean false
	
	            	ICABBI.Controller.trigger('slidingmenu:switch',{
		                index: e.row.viewIndex,
		                rowData: e.row.data
		            });
	            } else {
	            	newView = view; // switch back to the old view
		           	if(e.row.data && typeof e.row.data.newViewIndex!=='undefined') {
		           		var newViewIndex = e.row.data.newViewIndex;
		           		if(newViewIndex == 0 && !ICABBI.Config.show_map)
		           			newViewIndex = 1;
		           		if(newViewIndex == -1)
		           			newView = null;
		           		else
			            	newView = views[e.row.data.newViewIndex]==void 0 ? view : views[newViewIndex];
			        }
	            	
	            	ICABBI.Controller.trigger('slidingmenu:buttonclick',{
		                index: e.row.viewIndex,
		                rowData: e.row.data
		            });
		            
		            if(newView)
	            		changeView(newView);
	            }
	        });
	        addEventListener('open', function() {
	            slideView('left');
	        });
	        addEventListener('openview', function(args) {
	        	var index = args.index || 0;
	            var newView = views[index]==void 0 ? 0 : views[index];
	            changeView(newView);
	        });
	        addEventListener('swapview', function(args) {
	        	var index = args.index || 0;
	            var newView = views[index]==void 0 ? 0 : views[index];
	
	            newView.show();
				if (Ti.Android) {
		            newView.left = 0;
				} else {
		            newView.animate({
		                transform: twoD.translate(0, 0),
		                duration: duration.change_in
		            });
				}
	
	            view.hide();
	            view = newView;
	            view.fireEvent('slidingmenu:view:load');
	        });
	        addEventListener('close', function() {
	            slideView('view');
	        });
	        addEventListener('toggle', function() {
	            if(current === 'view') {
	                slideView('left');
	            } else {
	                slideView('view');
	            }
	        });
			self.addEventListener('open',function(e) {
				setTimeout(function(){ICABBI.Controller.trigger('slidingmenu:loaded');},1000);
			});
	
	        var containerWin = ICABBI.navController.open(self, null, null, restart);
	        if(!restart && containerWin)
	        	containerWin.open();
        }
        if(ICABBI.navController.notificationContainer)
			ICABBI.navController.notificationContainer.backgroundImage = null;
    };

    var addEventListener = function(name, callback) {
        if(typeof events[name] !== 'array') {
            events[name] = [];
        }

        events[name].push(callback);
    };

    var fireEvent = function(name, args) {
    	if (args === undefined) {
    		args = {};
    	}
        args.event = name;
        for(var callback in events[name]) {
            events[name][callback](args);
        }
    };

    var onCurrentChanged = function() {
        shadow.shadowOffset.x = -4;
        //left.zIndex = -1;
    };

    var slideView = function(position) {
    	
        var delta_xs;
        delta_xs = {
            left: ledge,
            view: 0
        };
        if(position == 'view')
        	view.fireEvent('slidingmenu:view:load');
        if (Ti.Android) {
        	// just slide the view on Android
            view.animate({
                left: delta_xs[position],
                duration: duration.slide
            }, function(){
            	view.fireEvent('slidingmenu:view:load:finish');
            });
        } else {
	        view.animate({
                transform: twoD.translate(delta_xs[position], 0),
	            duration: duration.slide
	        });
        }
        current = position;
        onCurrentChanged();
    };

    var viewTouchstart = function(e) {
    	Ti.API.info('touchstart: '+JSON.stringify(e));
        Ti.API.info('starting');
        sliding.offset = e.x - half.width;
        sliding.center = view.rect.x + half.width;
    };

    var viewTouchmove = function(e) {
    	Ti.API.info('touchmove: '+JSON.stringify(e));
        var delta_x;

        delta_x = e.x - sliding.offset + view.rect.x;
        delta_x -= half.width;

        touchStarted = false;

        // //Minimum movement is 30
        if( delta_x > 30 ){
            touchStarted = true;
        }

        if(touchStarted) {

            fireEvent('sliding', {
                distance: delta_x
            });

            if ((delta_x > 0 && !left)) {
                return;
            }
            if (Math.abs(delta_x) > ledge) {
                return;
            }
            if (delta_x > 0 && current !== 'left') {
                current = 'left';
                onCurrentChanged();
            } else if (delta_x === 0 && current !== 'view') {
                current = 'view';
                onCurrentChanged();
            }

            view.animate({
                transform: twoD.translate(delta_x, 0),
                duration: 0
            });

        }

    };

    var viewTouchend = function(e) {
    	Ti.API.info('touchend: '+JSON.stringify(e));
        var delta_x;

        delta_x = e.x - sliding.offset + view.rect.x ;
        delta_x -= half.width;

        if ((delta_x > 0 && !left)) {
            return;
        }
        if (Math.abs(delta_x) > ledge) {
            return;
        }

        if(sliding.center - half.width === 0 && delta_x > threshold) {
            Ti.API.info('1');
            if (delta_x > 0) {
                delta_x = ledge;
                current = 'left';
            } else {
                delta_x = 0;
                current = 'view';
            }

            view.animate({
                transform: twoD.translate(ledge, 0),
                duration: duration.bounce
            });
        } else {
            delta_x = sliding.center - half.width;
            if (delta_x === 0) {
                current = 'view';
            } else if (delta_x > 0) {
                current = 'left';
            }
            view.animate({
                transform: twoD.translate(0, 0),
                duration: duration.swipe
            });
        }
        onCurrentChanged();
    };

    var viewAndroidend = function(e) {
    	Ti.API.info('androidend: '+JSON.stringify(e));
    	
    	if (e.left === e.minLeft || e.left === e.maxLeft) {
    		// already there
    		current = e.left === e.maxLeft ? 'left':'view';
    		return;
    	}

		if(e.left >= threshold){
			// finish showing menu
			current = 'left';
            view.animate({
                left: e.source.maxLeft,
                duration: duration.swipe
            });
		} else {
			// finish hiding menu
			current = 'view';
            view.animate({
                left: 0,
                duration: duration.swipe
            });
		}
        onCurrentChanged();
    };

    var addEvents = function() {
        if(view.toString() === "[object TiUIiPhoneNavigationGroup]") {
            view.window.addEventListener('touchstart', viewTouchstart);
            view.window.addEventListener('touchmove', viewTouchmove);
            view.window.addEventListener('touchend', viewTouchend);
            view.window.addEventListener('touchcancel', viewTouchend);
        } else if (Ti.Android) {
            view.addEventListener('end', viewAndroidend);
        } else {
            view.addEventListener('touchstart', viewTouchstart);
            view.addEventListener('touchmove', viewTouchmove);
            view.addEventListener('touchend', viewTouchend);
            view.addEventListener('touchcancel', viewTouchend);
        }
    };

    var removeEvents = function() {
        if(view.toString() === "[object TiUIiPhoneNavigationGroup]") {
            view.window.removeEventListener('touchstart', viewTouchstart);
            view.window.removeEventListener('touchmove', viewTouchmove);
            view.window.removeEventListener('touchend', viewTouchend);
        } else if (Ti.Android) {
            view.removeEventListener('end', viewAndroidend);
        } else {
            view.removeEventListener('touchstart', viewTouchstart);
            view.removeEventListener('touchmove', viewTouchmove);
            view.removeEventListener('touchend', viewTouchend);
        }
    };

    var changeView = function(newView) {
    	if (Ti.Android) {
    		
	        if (view !== newView && newView) {
	            newView.left = view.width;
	            newView.show();
				newView.zIndex = 3;

		        newView.animate({
		            left:0,
		            duration: duration.change_in
		        }, function() {
		            if(draggable) {
		                removeEvents();
		            }
		            view.hide();
		            view.left = view.width;
		            view = newView;
		            current = 'view';
		            view.zIndex = 2;

		            view.fireEvent('slidingmenu:view:load');
		
		            if(draggable) {
		                addEvents();
		            }
		            view.fireEvent('slidingmenu:view:load:finish');
		        });
	        } else {
	        	slideView('view');
	        }
    	} else {
	        if (view !== newView) {
	        	
	            newView.hide();
	            newView.animate({
	            	transform: twoD.translate(newView.width,0),
	            	duration: 0.1
	            }, function() {
	            	newView.show();
	            	newView.zIndex = 3;
	            	newView.animate({
			            transform: twoD.translate(0, 0),
			            duration: duration.change_out
			        }, function() {
			            if(draggable) {
			                removeEvents();
			            }
			            view.hide();
			            view = newView;
			            current = 'view';
			            newView.zIndex = 2;
			            view.fireEvent('slidingmenu:view:load');
			
			            if(draggable) {
			                addEvents();
			            }
			        });
	            });
		
		        
	        } else {
	        	slideView('view');
	        }
    	}
    };

    // API properties
    this.draggable = draggable;
	this.window = self;
    // API methods
    this.slideView = slideView;
    this.addEventListener = addEventListener;
    this.fireEvent = fireEvent;
    this.open = open;
    this.destroy = function() {
    	self.close();
    };
    this.currentView = function() {
        return current == 'left' ? left : view;
    };
    this.activeView = function() {
        return view;
    };
    this.restart = function(){
    	left.restart();
    	open(true);
    	
    	ICABBI.Controller.trigger('application:reset');
    	
    	ICABBI.Controller.deauthenticate({success : function(){
			ICABBI.Controller.trigger('mapview:reset');
			ICABBI.SlidingMenu.fireEvent('openview',{index:getFirstVisible()});
		}}); 
    };
};

module.exports = SlidingMenu;