var ICABBI = require('/core/icabbi');

var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	$$ = require('/core/ThemeManager');


//TextView Component Constructor
var TextView = function(options) {
	//create object instance, a parasitic subclass of Observable
	var defaults = {
				text:[
					// 'Lorem ipsum dolor sit amet, tantus puella est Apollonius. Quam aniculae morsque nutricem valeas Apollonium. Impietatem die audi anim igitur Apolloni figitur acquievit sed eu fugiens laudo misera haec sed. Cyrenensi reversus generum dixit eos Communicatio mihi quidditas iter dirigo. Iubeo non dum animae tuae lacrimis ut sua coniuge per dicis me vero non dum veniens.'
					// ,'Lorem ipsum dolor sit amet, istis in deinde cupis auras in. Plus quem acceperat utique dolorem in modo genito in rei civibus nescis admonente iustum ait regem Ardalio nos! Prius si Ave mea in modo invenit quasi non solutionem invenisti! Interveniens sed eu fides se sed haec vidit Dionysiadi, chaldaeorum in fuerat construeret in rei civibus in rei exultant deo! Prius dotis quare Tharsia coniugem Jesu Dionysiadem tuos ratio iuvenis est Apollonius eius ad quia ad per.'
				],
				modal:false
		};
	options = _.extend(defaults,options.data||{});
	
	var create = function(){
		var content = Ti.UI.createView({
			backgroundColor: 'transparent',
		    borderColor:'#CCC',
		    borderWidth:0,
			width:options.width||'95%',
			height: options.height||'95%'
		});
		var scroll = Ti.UI.createScrollView({
		    contentWidth:'auto',
		    contentHeight:'auto',
		    showVerticalScrollIndicator:false,
		    showHorizontalScrollIndicator:false,
		    top:0,
		    left:0,
		    scrollType:'vertical',
		    layout:'vertical'
		});
		_.each(options.text,function(text){
			scroll.add(
				Ti.UI.createLabel($$.styl('label',(options.modal?'Modal.label':{}),{
				    top:5,
				    left:0,
					width:Ti.UI.FILL,
					height: Ti.UI.SIZE,
				    text:text,
			  	    font:{fontSize:16,fontWeight:'normal'},
				}))
			);
		});
		content.add(scroll);
		return content;
	};

	var self = create();

	return self;
}

module.exports = TextView;
