var Theme = require('/ui/Theme');

var ToggleButton = function(_buttonData) {
	var buttonData = _buttonData;

	var buttonView = Ti.UI.createView({
		height:buttonData.height,
		width:buttonData.width,
		backgroundColor:buttonData.selected ? Theme.global.bgColor:Theme.nav.backgroundColor,
	});
	
	var buttonText = Ti.UI.createLabel({
		left:5,
		right:5,
		height:Ti.UI.SIZE,
		color: Theme.global.fontColor,
		font:Theme.nav.buttonFont,
		text:buttonData.title,
		textAlign:'center',
		touchEnabled:false,
	});
	buttonView.add(buttonText);
	
	if (_buttonData.borderSide) {
		var btnLine = Ti.UI.createView({
			left:_buttonData.borderSide==='left'?0:undefined,
			right:_buttonData.borderSide==='right'?0:undefined,
			top:0,
			bottom:0,
			width:'2px',
			backgroundColor:Theme.nav.seperatorColor,
			touchEnabled:false,
		});
		//buttonView.add(btnLine);
	}
	
	function clickHandler(){
		if (!buttonData.selected) {
			buttonData.selected = true;
			buttonView.backgroundColor = buttonData.selected ? Theme.global.bgColor:Theme.nav.backgroundColor;
			buttonView.fireEvent('change',{selected:buttonData.selected});
		}
	}
	
	buttonView.addEventListener('click',clickHandler);
	
	buttonView.turnOff = function(){
		buttonData.selected = false;
		buttonView.backgroundColor = buttonData.selected ? Theme.global.bgColor:Theme.nav.backgroundColor;
	};
	
	return buttonView;
};


module.exports = ToggleButton;