//Application Window Component Constructor
var ICABBI = require('/core/icabbi'),
	$$ = require('/core/ThemeManager'),
	IcabbiAPI = require('/core/IcabbiAPI');

var ApplicationWindow = function() {
	//load component dependencies
	var SlidingMenu 	= require('/ui/common/SlidingMenu'),
		MenuView 		= require('/ui/common/MenuView'),
		PageView 		= require('/ui/common/PageView');

	//[sonal]BookingView not merged using PageView as of now
	var BookingView 	= require('/ui/common/BookingView');
	var v_booking 		= new BookingView();
	
	var BookingEditView 	= require('/ui/common/BookingEditView');
	var v_booking_edit 		= new BookingEditView({bookingData : v_booking.getBookingData()});
	
	/*
	 *[sonal] once functionality is done..research on lazy loading of views 
	 */
	var v_bookings = new PageView({
					header:{visible:true,title:'My Bookings'},
					content:{
							view:require('/ui/common/BookingsView'),
							data:{
							}
					}
				}),
/*
		v_favourites = new PageView({
					header:{visible:true,title:'My Favourites'},
					content:{
							view:require('/ui/common/FavouritesView'),
							data:{
							}
					}
				}),
*/
		v_account = new PageView({
					header:{visible:true,title:'My Details'},
					content:{
							view:require('/ui/common/AccountView'),
							data:{
							},
							scroll:true
					}
				}),
		v_creditcards = new PageView({
					header:{visible:true,title:'My Credit Cards'},
					content:{
							view:require('/ui/common/CreditCardsView'),
							data:{
							}
					}
				}),
/*				
		v_appsettings = new PageView({
					header:{visible:true,title:'My Settings'},
					content:{
							view:require('/ui/common/AppSettingsView'),
							data:{
							}
					}
				}),
*/
		v_contact = new PageView({
					header:{visible:true,title:'Contact'},
					content:{
							view:require('/ui/common/ContactView'),
							data:{
							}
					}
				}),
/*				
		v_aboutus = new PageView({
					header:{visible:true,title:'About Us'},
					content:{
							view:require('/ui/common/TextView'),
							data:{
								text:[
									'Lorem ipsum dolor sit amet, tantus puella est Apollonius. Quam aniculae morsque nutricem valeas Apollonium. '
									,'Impietatem die audi anim igitur Apolloni figitur acquievit sed eu fugiens laudo misera haec sed. Cyrenensi reversus generum dixit eos Communicatio mihi quidditas iter dirigo. Iubeo non dum animae tuae lacrimis ut sua coniuge per dicis me vero non dum veniens.'
									,'Lorem ipsum dolor sit amet, istis in deinde cupis auras in. Plus quem acceperat utique dolorem in modo genito in rei civibus nescis admonente iustum ait regem Ardalio nos! Prius si Ave mea in modo invenit quasi non solutionem invenisti! Interveniens sed eu fides se sed haec vidit Dionysiadi, chaldaeorum in fuerat construeret in rei civibus in rei exultant deo! Prius dotis quare Tharsia coniugem Jesu Dionysiadem tuos ratio iuvenis est Apollonius eius ad quia ad per.'
								]
							}
					}
				}),
*/
		v_terms = new PageView({
					header:{visible:true,title:'Terms & Conditions'},
					content:{
							view:require('/ui/common/WebView'),
							data:{
								contentAPI:IcabbiAPI.getTerms,
							}
					}
				}),
		v_tour = new PageView({
					header:{visible:false,title:'Tour'},
					content:{
							view:require('/ui/common/TourView'),
							data:{
								
							}
					}
				})/*,
		v_fleet = new PageView({
					header:{visible:false,title:'Location'},
					content:{
							view:require('/ui/common/FleetSelectView'),
							data:{
								
							},
							scroll:false
					}
				})*/;
	// Each row with a view property when clicked will change to that view (any view works except tabgroups and windows)
	// If the row does not have a view property, but the switch event still fires
	var menuData = [
		{
			heading:'Bookings',
			rows:[
				{ title:'New Booking', image:'/images/menu/icon_newbooking.png', hasDetail:true, view: v_booking}
				,{ title:'New Booking', image:'/images/menu/icon_newbooking.png', hasDetail:true, view: v_booking_edit, visible : false}
				,{ title:'My Bookings', image:'/images/menu/icon_mybookings.png', hasNotification:true, hasDetail:true,data:{authenticate:true}, view: v_bookings, lastItem:true}
			]
		}
		,{
			heading:'Account',
			rows:[
				 { title:'My Details', image:'/images/menu/icon_account.png', hasDetail:true, data:{authenticate:true},view: v_account}
				,{ title:'My Credit Cards', image:'/images/menu/icon_cards.png', hasDetail:true, data:{authenticate:true},view: v_creditcards}
//				,{ title:'My Favourites', image:'/images/menu/icon_favorites.png',hasDetail:true, data:{authenticate:true},view:v_favourites}
				,{ title:'Contact', image:'/images/menu/icon_contact.png', hasDetail:true, view: v_contact}
				,{ title:'Terms & Conditions', image:'/images/menu/icon_terms.png', hasDetail:true, view: v_terms}
				,{ title:'Tour', image:'/images/menu/icon_tour.png', hasDetail:true, view: v_tour, visible : function(){return ICABBI.Config.tour && ICABBI.Config.tour.length > 0;}}
				//,{ title:'Location', image:'/images/menu/icon_location.png', hasDetail:true, view : v_fleet, visible : /*function(){return ICABBI.Config.fleet && ICABBI.Config.fleet.length > 0;}*/false}
				,{ title:ICABBI.Controller.getUser().isAuthenticated() ? 'Logout' : 'Login', 
						image: ICABBI.Controller.getUser().isAuthenticated() ? '/images/menu/icon_logout.png' : '/images/menu/icon_login.png',
						data:{logout:1,newViewIndex:-1}}
			]
		}
	];

	var v_menu = new MenuView({
		sectionData: menuData,
	});
	
    var window = Ti.UI.createWindow($$.styl('Window', {
    	top:Ti.IOSPlus?20:0,
    }));

	var slidingMenu = new SlidingMenu({
		window: window,
		left: v_menu, 
		draggable: false
	});

	window.mapControl = v_booking.mapControl;
	ICABBI.SlidingMenu = slidingMenu;
	
	// ICABBI.Controller.getUser().syncBookingsActive();

	return slidingMenu;
};

//make constructor function the public component interface
module.exports = ApplicationWindow;
