var tools = require('/lib/tools'),
	_ = require('/lib/lodash')._ ,
	height 	= Titanium.Platform.displayCaps.platformHeight,
	width 	= Titanium.Platform.displayCaps.platformWidth;

(function() {	

	//constants not much used as of now...will start using once UI is all fixed
	var constants = {
		platformWidth: width,
		platformHeight: height,
		headerHeight: 0.075*height,
		headerMenuButtonWidth: 40, 
		textColor:'#000000',
		grayTextColor:'#888888',
		lightBlue:'#006cb1',
		darkBlue:'#93caed',
		fontFamily: tools.os({
			iphone:'Helvetica Neue',
			android:'Droid Sans'
		})
	};

	//All shared property sets are declared here.
	var properties = {
		Window: {
			navBarHidden:true,
			windowSoftInputMode:Ti.Android ? Ti.UI.Android.SOFT_INPUT_STATE_HIDDEN | Ti.UI.Android.SOFT_INPUT_ADJUST_RESIZE:undefined,
		},
		button: {
			color:'#000',
			textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		    borderColor:'#222',
		    borderWidth:1,
		    borderRadius:4,
	  	    font:{fontSize:20,fontWeight:'bold'},
			backgroundGradient: {
				type: 'linear',
				colors: [
					{
						color: '#fff000',
						offset: 0.0
					}, {
						color: '#da9f00',
						offset: 1.0
					}
				]
			},
			style:Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		},
		label: {
			backgroundColor: 'transparent',
		    color:'#000',
	  	    font:{fontSize:16,fontWeight:'bold'},
		    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
		},
		textField: {
			borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
			color:'#000000' //'#336699'
		},
		Menu:{
			body:{
				backgroundColor:'#fff',
				// backgroundImage: '/images/whitebg.png',
				// backgroundRepeat: true,
			},
			gradient: {
				vertical: {
					backgroundGradient: {
						type: 'linear',
						colors: [
							{
								color: '#121212',
								offset: 0.0
							}, {
								color: '#414141',
								offset: 1.0
							}
						]
					},
			   	},
		   	},
		},
		Screen:{
			background:{
				backgroundColor:'#fff',
				// backgroundImage:'/images/patternbg.png',
				// backgroundRepeat:true,
			},
			header:{
				left	: 0,
				top		: 0,
				layout	: 'horizontal',
			},
			headerTitleContainer:{
				backgroundColor: 'transparent',
				left: 0,
				height: Ti.UI.FILL,
			},
			headerTitle:{
				backgroundColor: 'transparent',
			    color:'#000',
		  	    font:{fontSize:16,fontWeight:'bold'},
			    textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
			},
			headerGradient: {
				vertical: {
					backgroundGradient: {
						type: 'linear',
						colors: [
							{
								color: '#fff000',
								offset: 0.0
							}, {
								color: '#da9f00',
								offset: 1.0
							}
						]
					},
			   	},
		   	},
			headerButtonSlidingMenu:{
				left: 0,
				width: 50,
				height: Ti.UI.FILL,
				backgroundImage : '/images/menu.png',
				backgroundColor : 'transparent',
				borderColor:'#000',
				borderWidth: 0,
			},
		},

		Modal : {
			window:{
				exitOnClose:false,
				// modal:true, this aint just working..
				zIndex:20,
				backgroundColor:'#99000000',
			},
			background:{
				width:Ti.UI.FILL,
				height:Ti.UI.FILL,
				opacity:.95,
				backgroundColor:'#000',
			},
			container:{
//		        width:constants.platformWidth-20,
				left:0,
				right:0,
				top:0,
				height:Ti.UI.SIZE,
				backgroundColor: 'transparent',
				opacity:1, //dont remove
			},
			headerTitle:{
				backgroundColor: 'transparent',
			    color:'#000',
		  	    font:{fontSize:20,fontWeight:'bold'},
			    textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
			},
			headerGradient: {
				vertical: {
					backgroundGradient: {
						type: 'linear',
						colors: [
							{
								color: '#fff000',
								offset: 0.0
							}, {
								color: '#da9f00',
								offset: 1.0
							}
						]
					},
			   	},
		   	},
			headerButton:{
				color:'#fff',
			    borderWidth:1,
			    borderColor:'#111',
			    borderRadius:4,
				backgroundColor : '#222',
				textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
				style:Ti.UI.iPhone.SystemButtonStyle.PLAIN,
			},
			body:{
				top		: 0,
				bottom	: 0,
				left	: 0,
				right	: 0,
			},
			content:{
				top		: 0,
				left	: 0,
				right	: 0,
				height	: Ti.UI.SIZE,
			},
			bodyspacer:{
				width	: Ti.UI.FILL,
				height	: 10,
				backgroundImage: '/images/whitebg.png',
				backgroundRepeat: true,
			},
			button: {
				color:'#000',
				textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
			    borderColor:'#222',
			    borderWidth:1,
			    borderRadius:4,
		  	    font:{fontSize:20,fontWeight:'bold'},
				backgroundGradient: {
					type: 'linear',
					colors: [
						{
							color: '#fff000',
							offset: 0.0
						}, {
							color: '#da9f00',
							offset: 1.0
						}
					]
				},
				style:Ti.UI.iPhone.SystemButtonStyle.PLAIN,
			},
			label:{
				color:'#000',
			}
	   	},

		bookingEdit:{
			btnArrow: {
				right: 0,
				height: 40,
				width: 40,
				image : '/images/arrow_right_off.png',
				backgroundColor : '#000',
			    borderColor:'#666',
			    borderWidth:1,
			    borderRadius:4,
			    style:Ti.UI.iPhone.SystemButtonStyle.PLAIN,
			},
		},
		
		textArea: {
			//borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
			borderWidth: 2,
			borderRadius:5,
			borderColor: '#bbb',
			backgroundColor:'#efefef',
			color: '#336699',
			keyboardType: Titanium.UI.KEYBOARD_DEFAULT,
			returnKeyType: Ti.UI.RETURNKEY_GO,
			textAlign: Titanium.UI.TEXT_ALIGNMENT_LEFT,
			font: {fontSize:16, fontWeight:'bold'},
			//gradient will only work on iOS
			backgroundGradient:{
				type:'linear',
				colors:[
					{color:'#efefef',position:0.0},
					{color:'#cdcdcd',position:0.50},
					{color:'#efefef',position:1.0}
				]
			}
		},
		
		//we use these as JS-based 'style classes'
		animationDuration: 500,

		spacerRow: {
			backgroundImage:'images/spacer_row.png',
			height:30,
			className:'spacerRow'
		},
	};
	// android-scoped vars
	if (Ti.Android) {
		properties.Window.softInputMode = Ti.UI.Android.SOFT_INPUT_ADJUST_RESIZE;
	}
	
	module.exports ={
		Constants:constants,
		Properties:properties	
	};
})();

